package cn.jyjz.flowable.config;

import cn.jyjz.flowable.common.SystemConstantsOa;
import cn.jyjz.flowable.factory.FlowServiceFactory;
import cn.jyjz.flowable.service.IFlowFormMessageService;
import cn.jyjz.xiaoyao.common.base.language.SystemMessage;
import cn.jyjz.xiaoyao.common.base.util.SpringUtils;
import cn.jyjz.xiaoyao.oa.from.dataobject.Userdistionary;
import cn.jyjz.xiaoyao.oa.from.service.UserdistionaryService;
import org.apache.commons.lang3.StringUtils;
import org.flowable.bpmn.model.BpmnModel;
import org.flowable.bpmn.model.FlowElement;
import org.flowable.bpmn.model.UserTask;
import org.flowable.engine.RepositoryService;
import org.flowable.engine.RuntimeService;
import org.flowable.engine.TaskService;
import org.flowable.engine.delegate.TaskListener;
import org.flowable.engine.runtime.ProcessInstance;
import org.flowable.task.service.delegate.DelegateTask;

import java.util.ArrayList;
import java.util.List;


public class AutoJumpTaskListener extends FlowServiceFactory implements TaskListener {
    

    @Override
    public void notify(DelegateTask delegateTask) {
         TaskService taskService = SpringUtils.getBean(TaskService.class);
         RepositoryService repositoryService = SpringUtils.getBean(RepositoryService.class);
         UserdistionaryService userdistionaryService = SpringUtils.getBean(UserdistionaryService.class);
         RuntimeService runtimeService = SpringUtils.getBean(RuntimeService.class);
        
        String processInstanceId = delegateTask.getProcessInstanceId();
        String taskId = delegateTask.getId();
        // 流程实例为空则结束
        if(StringUtils.isBlank(processInstanceId) && StringUtils.isBlank(taskId)){
            return;
        }
        
        //判断节点是否需要跳过，需要判断当前申请人员是否需要过店长
        //获取当前审批节点的usertask
        BpmnModel bpmnModel = repositoryService .getBpmnModel(delegateTask.getProcessDefinitionId());
        //传节点定义key获取当前节点
        FlowElement flowElement = bpmnModel.getFlowElement(delegateTask.getTaskDefinitionKey());
        if(flowElement instanceof UserTask) {
            UserTask userTask = (UserTask) flowElement;
            //获取节点"描述信息内容"
            String documentation = userTask.getDocumentation();
            if(StringUtils.isNotBlank(documentation)){
    
                //更新业务表
                ProcessInstance processInstance = runtimeService.createProcessInstanceQuery().processInstanceId(delegateTask.getProcessInstanceId()).singleResult();
    
                //我这里以 流程定义key(oa_category_t定义的关键字，逻辑唯一) + 业务表主键（请假表、调岗表等） + 业务表对应的servicename
                String businesskey = processInstance.getBusinessKey();
    
                String[] busskey = businesskey.split(SystemConstantsOa.OA_BUSSINESS_KEY_SPLIT);
                if(documentation.equals(SystemConstantsOa.OA_TASK_MESSAGE_PASS)){
                    
                    String assignee = userTask.getAssignee();
                    
                    List<String> candidateUsers = userTask.getCandidateUsers();
                    
                    if(StringUtils.isNotBlank(assignee)){
                        taskService.claim(taskId, assignee);
    
                        List<String> loginNameList = new ArrayList<>();
                        loginNameList.add(assignee);
                        
//                        FlowableccService flowableccService = SpringUtils.getBean(FlowableccService.class);
//                        flowableccService.saveUserCc(Long.parseLong(busskey[1]),loginNameList);
                        
                    }else if(null != candidateUsers && !candidateUsers.isEmpty()){
                        taskService.claim(taskId, candidateUsers.get(0));
//                        FlowableccService flowableccService = SpringUtils.getBean(FlowableccService.class);
//                        flowableccService.saveUserCc(Long.parseLong(busskey[1]),candidateUsers);

                    }else{
                        return;
                    }
                    
                    
                    // 添加处理意见
                    taskService.addComment(taskId, processInstanceId, SystemConstantsOa.OA_TASK_SKIP_TYPE, SystemConstantsOa.OA_TASK_SEND_COMMENT);
                    // 自动审批通过
                    taskService.complete(taskId);
                }
        
            }
    
        }
        

    }
}
