package cn.jyjz.flowable.config;

import cn.jyjz.flowable.common.SystemConstantsOa;
import cn.jyjz.flowable.factory.FlowServiceFactory;

import cn.jyjz.xiaoyao.common.base.util.SpringUtils;
import cn.jyjz.xiaoyao.oa.from.dataobject.Userdistionary;
import cn.jyjz.xiaoyao.oa.from.service.UserdistionaryService;
import org.apache.commons.lang3.StringUtils;
import org.flowable.bpmn.model.BpmnModel;
import org.flowable.bpmn.model.FlowElement;
import org.flowable.bpmn.model.UserTask;
import org.flowable.engine.RepositoryService;
import org.flowable.engine.RuntimeService;
import org.flowable.engine.TaskService;
import org.flowable.engine.delegate.TaskListener;
import org.flowable.engine.runtime.ProcessInstance;
import org.flowable.task.service.delegate.DelegateTask;


import java.util.List;


public class AutoSkipTaskListener extends FlowServiceFactory implements TaskListener {
    

    @Override
    public void notify(DelegateTask delegateTask) {
         TaskService taskService = SpringUtils.getBean(TaskService.class);
         RepositoryService repositoryService = SpringUtils.getBean(RepositoryService.class);
         UserdistionaryService userdistionaryService = SpringUtils.getBean(UserdistionaryService.class);
         RuntimeService runtimeService = SpringUtils.getBean(RuntimeService.class);
        
        String processInstanceId = delegateTask.getProcessInstanceId();
        String taskId = delegateTask.getId();
        // 流程实例为空则结束
        if(StringUtils.isBlank(processInstanceId) && StringUtils.isBlank(taskId)){
            return;
        }
        
        //判断节点是否需要跳过，需要判断当前申请人员是否需要过店长
        //获取当前审批节点的usertask
        BpmnModel bpmnModel = repositoryService .getBpmnModel(delegateTask.getProcessDefinitionId());
        //传节点定义key获取当前节点
        FlowElement flowElement = bpmnModel.getFlowElement(delegateTask.getTaskDefinitionKey());
        if(flowElement instanceof UserTask) {
            UserTask userTask = (UserTask) flowElement;
            //获取节点分类内容
            String taskCategory = userTask.getCategory();
            if(StringUtils.isNotBlank(taskCategory)){
                //更新业务表
                ProcessInstance processInstance = runtimeService.createProcessInstanceQuery().processInstanceId(delegateTask.getProcessInstanceId()).singleResult();
                
                //获取当前流程发起用户属性(Userdistionary中的USERTYPE与分类内容是否一致，如果一直表示跳过当前节点)
                String loginname = processInstance.getStartUserId();
        
                //查询当前流程发起用户属性
                List<Userdistionary> userdistionaryList = userdistionaryService.selectListByLoginname(loginname);
                //当前流程是否跳过
                boolean ispass = false;
                for(Userdistionary userdistionary:userdistionaryList){
                    if(userdistionary.getUsertype().toString().equals(taskCategory)){
                        ispass = true;
                    }
                }
                if(ispass){
                    taskService.claim(taskId, SystemConstantsOa.OA_TASK_SKIP_ASSIGINE);
                    // 添加处理意见
                    taskService.addComment(taskId, processInstanceId, SystemConstantsOa.OA_TASK_SKIP_TYPE, SystemConstantsOa.OA_TASK_SKIP_COMMENT + SystemConstantsOa.OA_TASK_SKIP_HOUDUAN);
                    // 自动审批通过
                    taskService.complete(taskId);
                }
        
            }
    
        }
        

    }
}
