package cn.jyjz.flowable.config;

import org.flowable.spring.SpringProcessEngineConfiguration;
import org.flowable.spring.boot.EngineConfigurationConfigurer;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.context.annotation.Configuration;

@Configuration
public class FlowableConfig implements EngineConfigurationConfigurer<SpringProcessEngineConfiguration> {
    private static Logger LOGGER = LoggerFactory.getLogger(FlowableConfig.class);
    @Override
    public void configure(SpringProcessEngineConfiguration con) {
        //防止生成的流程图中中文乱码
        con.setActivityFontName("宋体");
        con.setLabelFontName("宋体");
        con.setAnnotationFontName("宋体");
        LOGGER.info("配置字体:" + con.getActivityFontName());
    }
}
