package cn.jyjz.flowable.config;

import lombok.RequiredArgsConstructor;

import org.flowable.common.engine.api.delegate.event.FlowableEngineEventType;
import org.flowable.common.engine.api.delegate.event.FlowableEventDispatcher;
import org.flowable.spring.SpringProcessEngineConfiguration;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationListener;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.event.ContextRefreshedEvent;

@Configuration
@RequiredArgsConstructor
public class FlowableGlobalListenerConfig implements ApplicationListener<ContextRefreshedEvent> {
    private final SpringProcessEngineConfiguration configuration;
    private final GlobalTaskCreateListener globalTaskCreateListener;
    
    @Autowired
    private GlobalProcistEndListener globalProcistEndListener;
    
    @Autowired
    private GlobalEntityInitListener globalEntityInitListener;
    
    @Autowired
    private GlobalTaskCompletedListener globalTaskCompletedListener;
    
    @Override
    public void onApplicationEvent(ContextRefreshedEvent event) {
        FlowableEventDispatcher dispatcher = configuration.getEventDispatcher();
        // 任务创建全局监听-待办消息发送
        dispatcher.addEventListener(globalTaskCreateListener);
    
//        // 任务创建全局监听-待办消息发送
//        dispatcher.addEventListener(taskCreateListener, FlowableEngineEventType.TASK_CREATED);
    
        dispatcher.addEventListener(globalEntityInitListener, FlowableEngineEventType.ENTITY_INITIALIZED);
    

        
        //流程结束全局监听
        dispatcher.addEventListener(globalProcistEndListener, FlowableEngineEventType.PROCESS_COMPLETED);
//        //添加任务创建全局监听
//        dispatcher.addEventListener(globalTaskCreateListener, FlowableEngineEventType.TASK_CREATED);
//
        //添加任务完成全局监听
        dispatcher.addEventListener(globalTaskCompletedListener, FlowableEngineEventType.TASK_ASSIGNED);
//
//        //添加流程实例创建全局监听
//        dispatcher.addEventListener(globalProcistStartListener, FlowableEngineEventType.PROCESS_STARTED);
//
//        //添加流程实例结束全局监听
//        dispatcher.addEventListener(globalProcistEndListener, FlowableEngineEventType.PROCESS_COMPLETED);
    }

}
