package cn.jyjz.flowable.config;

import cn.jyjz.xiaoyao.oa.from.dataobject.Category;
import cn.jyjz.xiaoyao.oa.from.service.CategoryService;
import org.flowable.common.engine.api.delegate.event.FlowableEvent;
import org.flowable.common.engine.api.delegate.event.FlowableEventListener;
import org.flowable.common.engine.api.delegate.event.FlowableEventType;
import org.flowable.engine.delegate.event.impl.FlowableEntityEventImpl;
import org.flowable.engine.impl.persistence.entity.ProcessDefinitionEntity;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * flowable 应用发布监听
 */
@Component
public class GlobalEntityInitListener implements FlowableEventListener {
    
    @Autowired
    private CategoryService categoryService;
    
    @Override
    public void onEvent(FlowableEvent flowableEvent) {
        FlowableEventType type = flowableEvent.getType();
        FlowableEntityEventImpl flowableEntityEvent = (FlowableEntityEventImpl) flowableEvent;
    
        Object object = flowableEntityEvent.getEntity();
        if(object instanceof ProcessDefinitionEntity){
            ProcessDefinitionEntity processDefinitionEntity = (ProcessDefinitionEntity)object;
            //修改类型对象，更新类型表
            List<Category> categoryList = categoryService.getCategoryList(processDefinitionEntity.getCategory());
            if(null != categoryList && !categoryList.isEmpty()){
                for(Category category:categoryList){
                    category.setProcessdefinitionid(processDefinitionEntity.getId());
    
                    categoryService.updateById(category);
                }

            }
        
        }
    }
    
    @Override
    public boolean isFailOnException() {
        return false;
    }
    
    @Override
    public boolean isFireOnTransactionLifecycleEvent() {
        return false;
    }
    
    @Override
    public String getOnTransaction() {
        return null;
    }
}
