package cn.jyjz.flowable.config;
import cn.jyjz.flowable.common.SystemConstantsOa;
import cn.jyjz.flowable.service.IFormCustomService;
import cn.jyjz.xiaoyao.common.base.util.SpringUtils;
import cn.jyjz.xiaoyao.oa.from.dataobject.Category;
import cn.jyjz.xiaoyao.oa.from.service.CategoryService;
import com.alanpoi.common.util.StringUtils;
import org.flowable.common.engine.api.delegate.event.FlowableEngineEntityEvent;
import org.flowable.engine.delegate.event.AbstractFlowableEngineEventListener;
import org.flowable.engine.delegate.event.impl.FlowableEntityEventImpl;
import org.flowable.engine.impl.persistence.entity.ExecutionEntityImpl;
import org.flowable.engine.runtime.ProcessInstance;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;

/**
 * 流程结束全局监听器
 */
@Component
public class GlobalProcistEndListener extends AbstractFlowableEngineEventListener {
    protected Logger logger = LoggerFactory.getLogger(this.getClass());
    @Autowired
    private CategoryService categoryService;
    @Override
    protected void processCompleted(FlowableEngineEntityEvent event) {
        logger.info("进入流程完成监听器------------------------Start---------------------->");
        String eventName = event.getType().name();
        
        FlowableEntityEventImpl flowableEntityEvent = (FlowableEntityEventImpl) event;
        ExecutionEntityImpl processInstance = (ExecutionEntityImpl) flowableEntityEvent.getEntity();
        
        Date startTime = processInstance.getStartTime();
        String processDefinitionKey = processInstance.getProcessDefinitionKey();
        String processInstanceId = processInstance.getProcessInstanceId();
        String processInstanceBusinessKey = processInstance.getProcessInstanceBusinessKey();
        String business = processInstance.getProcessInstanceBusinessKey();
        int suspensionState = processInstance.getSuspensionState();
        
        //判断业务key是否存在
        if(StringUtils.isNotBlank(business)){
            String[] busskey = business.split(SystemConstantsOa.OA_BUSSINESS_KEY_SPLIT);
            IFormCustomService iFormCustomService = SpringUtils.getBean(busskey[2]);
            //设置流程结束状态
            iFormCustomService.endForm(busskey[1],SystemConstantsOa.OA_STATUS_TYPE_END,"",processInstanceId);
        }
    
        logger.debug("业务流程key->{}", business);
        logger.debug("流程事件类型->{}", eventName);
        logger.debug("流程开始时间->{}", startTime);
        logger.debug("流程定义Key->{}", processDefinitionKey);
        logger.debug("流程实例ID->{}", processInstanceId);
        logger.debug("流程业务key->{}", processInstanceBusinessKey);
        logger.debug("流程是否挂起标志->{}", suspensionState);
        logger.debug("流程完成监听器------------------------End---------------------->");
    }
    
}
