package cn.jyjz.flowable.config;
import cn.jyjz.xiaoyao.oa.from.dataobject.Category;
import cn.jyjz.xiaoyao.oa.from.service.CategoryService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.flowable.common.engine.api.delegate.event.*;
import org.flowable.engine.RepositoryService;
import org.flowable.engine.delegate.event.impl.FlowableEntityEventImpl;
import org.flowable.engine.TaskService;

import org.flowable.engine.delegate.event.AbstractFlowableEngineEventListener;
import org.flowable.engine.delegate.event.impl.FlowableEntityWithVariablesEventImpl;
import org.flowable.engine.delegate.event.impl.FlowableProcessCancelledEventImpl;
import org.flowable.engine.impl.cfg.ProcessEngineConfigurationImpl;
import org.flowable.engine.impl.persistence.entity.DeploymentEntity;
import org.flowable.engine.impl.persistence.entity.ExecutionEntityImpl;
import org.flowable.engine.impl.persistence.entity.ProcessDefinitionEntity;
import org.flowable.engine.impl.persistence.entity.ResourceEntity;
import org.flowable.engine.impl.util.CommandContextUtil;
import org.flowable.engine.repository.ProcessDefinition;
import org.flowable.identitylink.api.IdentityLink;
import org.flowable.task.service.impl.persistence.entity.TaskEntity;
import org.flowable.task.service.impl.persistence.entity.TaskEntityImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;

@Slf4j
@Component
@RequiredArgsConstructor
public class GlobalTaskCreateListener implements FlowableEventListener {
    private final TaskService taskService;
    @Autowired
    protected RepositoryService repositoryService;
    
    @Autowired
    private CategoryService categoryService;
    @Override
    public void onEvent(FlowableEvent event) {
    
        FlowableEventType type = event.getType();
        FlowableEntityEventImpl flowableEntityEvent = (FlowableEntityEventImpl) event;
    
        Object object = flowableEntityEvent.getEntity();

        if(type.toString().indexOf("ENTITY_") != -1){

            if (type == FlowableEngineEventType.ENTITY_ACTIVATED) {
                System.out.println("--------------ENTITY_ACTIVATED================ " + event);
            }
            else if (type == FlowableEngineEventType.ENTITY_INITIALIZED) {
//                if(object instanceof ProcessDefinitionEntity){
//                    ProcessDefinitionEntity processDefinitionEntity = (ProcessDefinitionEntity)object;
//
//                    //修改类型对象
//                    Category category = categoryService.getCategory(processDefinitionEntity.getCategory());
//                    if(null != category){
//                        category.setProcessdefinitionid(processDefinitionEntity.getId());
//                        categoryService.updateById(category);
//                    }
//
//                }
//                ResourceEntity resourceEntity = (ResourceEntity) object;

            }
            else if (type == FlowableEngineEventType.ENTITY_CREATED) {
                ResourceEntity resourceEntity = (ResourceEntity) object;


            }
            //得到流程实例
            TaskEntity taskEntity = (TaskEntity) object;
            String taskId = taskEntity.getId();
    
    
    
            List<IdentityLink> idList = taskService.getIdentityLinksForTask(taskId);
            if (CollectionUtils.isEmpty(idList)) {
                return;
            }
            List<String> userNameList = new ArrayList<>();
            // 获取接收人，此处从Identity获取，实际情况会更复杂
            idList.forEach(identityLink -> {
                if (StringUtils.isNotBlank(identityLink.getUserId())) {
                    userNameList.add(identityLink.getUserId());
                }
            });

        }
        if(type.toString().indexOf("TASK_") != -1){
    
            //得到流程实例
            TaskEntity taskEntity = (TaskEntity) object;
            //得到流程定义id
            String processDefinitionId = taskEntity.getProcessDefinitionId();
            //  得到流程实例id
            String processInstanceId = taskEntity.getProcessInstanceId();
    
            String taskId = taskEntity.getId();
            

    
            List<IdentityLink> idList = taskService.getIdentityLinksForTask(taskId);
            if (CollectionUtils.isEmpty(idList)) {
                return;
            }
            List<String> userNameList = new ArrayList<>();
            // 获取接收人，此处从Identity获取，实际情况会更复杂
            idList.forEach(identityLink -> {
                if (StringUtils.isNotBlank(identityLink.getUserId())) {
                    userNameList.add(identityLink.getUserId());
                }
            });
            if (CollectionUtils.isNotEmpty(userNameList)) {
                // TODO: @author  发送提醒消息
            }
            if (type == FlowableEngineEventType.TASK_CREATED) {
                // 用户任务创建完成
                if (event instanceof FlowableEntityEventImpl) {
    

                }else if(event instanceof FlowableEntityEvent){

    
                }

            } else if (type == FlowableEngineEventType.TASK_COMPLETED) {
                // 用户审批任务
                if (event instanceof FlowableEntityWithVariablesEventImpl) {
            
            
                }
            } else if (type == FlowableEngineEventType.PROCESS_COMPLETED) {
                // 流程完成
                if (event instanceof FlowableEntityEventImpl) {
            
                }
            } else if (type == FlowableEngineEventType.PROCESS_CANCELLED) {
                // 流程删除
                if (event instanceof FlowableProcessCancelledEventImpl) {
            
                }
            }
        }
        
        
    }
    
    @Override
    public boolean isFailOnException() {
        return false;
    }
    
    @Override
    public boolean isFireOnTransactionLifecycleEvent() {
        return false;
    }
    
    @Override
    public String getOnTransaction() {
        return null;
    }
}
