package cn.jyjz.flowable.controller;

import cn.jyjz.flowable.utils.PageUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.*;
import javax.servlet.http.HttpServletRequest;

/**
 * 流程定义的Controller
 *    流程定义查询
 *    流程部署
 *    删除流程
 *    挂起/激活流程
 *    查看流程图
 */
@Slf4j
@Controller
@RequestMapping("/flow/definitionhtml")
public class FlowDefinitionHtmlController {

    /**
     * 查询我的待办任务
     * @return
     */
    @GetMapping("/toToDoTask")
    public String myToDoTask(PageUtils vo, Model model, HttpServletRequest request){
        return "/backstage/flowable/mytask/toDoTask";
    }
    @GetMapping("/print")
    public String print(PageUtils vo, Model model, HttpServletRequest request){
        String processInstanceId = request.getParameter("processInstanceId");

        request.setAttribute("processInstanceId",processInstanceId);

        return "/backstage/flowable/mypro/print";
    }
    /**
     * 我的已办
     *    查询我发起的已经完成的任务
     * @return
     */
    @GetMapping("/tofinishedList")
    public String getFinishedList(){

        return "/backstage/flowable/myfinished/myfinished";
    }
    @GetMapping("/toMylistcc")
    public String toMylistcc(){
        
        return "/backstage/flowable/mycc/mylistcc";
    }
    
    /**
     * 查询流程定义
     * @return
     */
    @GetMapping("/tolist")
    public String list(){

        return "/backstage/flowable/definition/flowDefinition";
    }
    /**
     * 查询流程定义
     * @return
     */
    @GetMapping("/tostart")
    public String tostart(){
    
        return "/backstage/flowable/myprocess/startFlow";
    }
    
    @GetMapping("/toformlist")
    public String toformlist(){
        return "/backstage/flowable/form/formManager";
    }
    
    
    @GetMapping("/toDataList")
    public String toDataList(){
        return "/backstage/flowable/mypro/list";
    }
}