package cn.jyjz.flowable.modeler.controllers;

import cn.jyjz.flowable.modeler.domain.FlowRemoteUser;
import cn.jyjz.xiaoyao.admin.service.UserService;
import cn.jyjz.xiaoyao.common.base.service.UserTokenService;
import cn.jyjz.xiaoyao.framework.security.model.AdminUserModel;
import org.flowable.ui.common.model.UserRepresentation;
import org.flowable.ui.common.security.DefaultPrivileges;
import org.flowable.ui.common.security.FlowableAppUser;
import org.flowable.ui.common.security.SecurityUtils;
import org.flowable.ui.modeler.model.AppDefinitionPublishRepresentation;
import org.flowable.ui.modeler.model.AppDefinitionUpdateResultRepresentation;
import org.flowable.ui.modeler.service.AppDefinitionImportService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

@RestController
public class RemoteAccountResource {
    
    @Autowired
    private AppDefinitionImportService appDefinitionImportService;
    /**
     * 应用发布->流程部署
     */
    @PostMapping("/app/rest/app-definitions/{modelId}/publish")
    public AppDefinitionUpdateResultRepresentation publishAppDefinition(@PathVariable("modelId") String modelId,
                                                                        @RequestBody AppDefinitionPublishRepresentation publishModel) {
        AppDefinitionUpdateResultRepresentation resultRepresentation = null;
        try {
            resultRepresentation = appDefinitionImportService.publishAppDefinition(modelId, publishModel);
        } catch (Exception ex) {
            resultRepresentation = new AppDefinitionUpdateResultRepresentation();
            resultRepresentation.setError(true);
            resultRepresentation.setErrorDescription(ex.getMessage());
        }
        return resultRepresentation;
    }

    @Resource
    private UserTokenService userTokenService;
    @GetMapping("app/rest/account")
    public UserRepresentation getAccount(HttpServletRequest request) {
    
        Authentication authentication = SecurityContextHolder.getContext().getAuthentication();
        
        if(null == authentication ){
            return null;
        }
        Object object = authentication.getPrincipal();
        
        if(null == object || object instanceof String){
            return null;
        }
        
        AdminUserModel adminUserModel = (AdminUserModel)object;
    
        FlowableAppUser appUser = (FlowableAppUser) adminUserModel.getFlowableUser();
        UserRepresentation userRepresentation = new UserRepresentation(appUser.getUserObject());
        if (appUser.getUserObject() instanceof FlowRemoteUser) {
            FlowRemoteUser temp = (FlowRemoteUser) appUser.getUserObject();
            userRepresentation.setPrivileges(temp.getPrivileges());
        }
    
        //UserRepresentation userRepresentation = new UserRepresentation();
//        userRepresentation.setId("admin");
//        userRepresentation.setFirstName("admin");
//        List<String> privileges=new ArrayList<>();
//        List<String> pris = new ArrayList<>();
//        pris.add(DefaultPrivileges.ACCESS_MODELER);
//        pris.add(DefaultPrivileges.ACCESS_IDM);
//        pris.add(DefaultPrivileges.ACCESS_ADMIN);
//        pris.add(DefaultPrivileges.ACCESS_TASK);
//        userRepresentation.setPrivileges(privileges);
        return userRepresentation;
    }

}
