package cn.jyjz.flowable.modeler.services;

import cn.jyjz.flowable.modeler.constants.FlowableConstants;
import cn.jyjz.flowable.modeler.domain.FlowRemoteUser;
import cn.jyjz.xiaoyao.admin.dataobject.Roles;

import cn.jyjz.xiaoyao.framework.security.service.FlowableUserLoginService;
import org.flowable.ui.common.security.FlowableAppUser;
import org.flowable.ui.common.security.SecurityUtils;
import org.springframework.security.core.authority.SimpleGrantedAuthority;
import cn.jyjz.xiaoyao.common.base.vo.User;
import org.springframework.stereotype.Component;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

@Service("flowableUserLoginService")
public class FlowableUserLoginServiceImpl implements FlowableUserLoginService {
    
    public Object flowableUserLogin(User user){
        //SecurityUtils.getCurrentFlowableAppUser();
        List<Roles> userRoleList = user.getRoleslist();
        
        List<SimpleGrantedAuthority> authorities = userRoleList.stream().map(item -> {

            return new SimpleGrantedAuthority(item.getRolename());
        }).collect(Collectors.toList());
        // 配置 flowable-modeler 权限
        FlowableConstants.FLOW_ABLE_MODELER_ROLES.parallelStream().forEach(obj -> {
            authorities.add(new SimpleGrantedAuthority(obj));
        });
        FlowRemoteUser remoteUser = new FlowRemoteUser();
        remoteUser.setId(user.getId()+"");
        remoteUser.setFirstName(user.getLoginname());

        remoteUser.setPassword(user.getPassword());
        remoteUser.setDisplayName(user.getUsername());
        remoteUser.setPrivileges(new ArrayList<>(FlowableConstants.FLOW_ABLE_MODELER_ROLES));
        FlowableAppUser userDetails = new FlowableAppUser(remoteUser,user.getLoginname(),authorities);

        return userDetails;
    }
}
