package cn.jyjz.flowable.service;


import cn.jyjz.flowable.domain.dto.HistoricTaskInstanceDto;
import cn.jyjz.flowable.domain.vo.FlowTaskCompleteVO;
import cn.jyjz.flowable.domain.vo.FlowTaskVO;
import cn.jyjz.flowable.domain.vo.WorkFlowNodeVO;
import cn.jyjz.flowable.utils.PageUtils;
import cn.jyjz.xiaoyao.common.base.param.ParamterPage;
import cn.jyjz.xiaoyao.common.base.vo.ResultVo;
import cn.jyjz.xiaoyao.common.base.vo.UserToken;
import cn.jyjz.xiaoyao.oa.from.dataobject.Category;

import cn.jyjz.xiaoyao.oa.from.vo.FlowUnionVo;
import cn.jyjz.xiaoyao.ocr.dataobject.OcrTaskchildPicture;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.flowable.engine.repository.ProcessDefinition;
import org.flowable.task.api.Task;

import javax.servlet.http.HttpServletRequest;
import java.io.InputStream;
import java.util.List;
import java.util.Map;

public interface IFlowTaskService {
    void myTodoTaskList(PageUtils vo, HttpServletRequest request);

    InputStream diagram(String processId);

    InputStream myDiagram(String processId,HttpServletRequest request);
    
    Category viewForm(String processId, HttpServletRequest request);

    Boolean complete(FlowTaskVO taskVO,HttpServletRequest request);
    
    /**
     * 获取当前任务的可回退的流程集合
     *
     * @param taskId 当前的任务 ID
     * @return 可以回退的节点列表
     */
    public List<WorkFlowNodeVO> getReturnTaskList(String taskId);
    
    /**
     * 更新当前节点处理人信息
     * @param
     * @param processDefinition
     */
    public void updateAssignee(String processInstanceId,String processDefinitionId, ProcessDefinition processDefinition);

    void finishedList(PageUtils pageUtils,HttpServletRequest request);
    /**
     * 查询我发起的流程实例
     *
     * @param query 搜索条件
     * @param pageUtils  分页参数
     * @return
     */
    public void getMyProcessInstances( Map<String, Object> query, PageUtils<FlowUnionVo> pageUtils);
    
    /**
     * 查询最终审批数据
     *
     * @param query 搜索条件
     * @param pageUtils  分页参数
     * @return
     */
    public void getFinalProcessInstances( Map<String, Object> query, PageUtils<OcrTaskchildPicture> pageUtils);
    
    /**
     * 查询我发起的流程实例
     * 不做分类
     * @param query 查询条件
     * @return
     */
    public List<FlowUnionVo> getMyProcessInstances(Map<String, Object> query);
    /**
     * 抄送给我的
     *
     * @return
     */
    public IPage<FlowUnionVo> getMyListCc(Map<String, Object> query, UserToken userToken, ParamterPage paramterPage);
    /**
     * 查看任务的流程记录
     * @return
     */
    public List<HistoricTaskInstanceDto> listHistoriceTask(String processInstanceId);
    
    /**
     * 获取当前活动节点列表
     * @param processInstanceId 实例主键
     * @return
     */
    public List<String> listTask(String processInstanceId);
    /**
     * 设置当前审批节点的审批人
     * 目前只多候选组和多个候选人起作用
     * @param processInstanceId
     */
    public FlowTaskCompleteVO updateNowTaskAssignee(String processInstanceId, String processDefinitionId);
    /**
     * 查看当前执行人列表
     * @param processInstanceId
     * @return
     */
    public List getApprovers(String processInstanceId);
    
    /**
     * 设置当前审批节点的
     */
    public List<Task> nowRunTask(String processInstanceId, String processDefinitionId);
    /**
     * 撤销流程
     * @param taskId
     * @param reason
     */
    public void cancelTask(String taskId, String reason);
    
    /**
     * 重置流程
     * @param fromid 任务表主键
     */
    public ResultVo removeTask(String fromid,String taskid );
}
