package cn.jyjz.flowable.service;

import cn.jyjz.flowable.domain.vo.FlowModelVO;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;

/**
 * 用于处理本地数据表单
 */
public interface IFormCustomService<T> {
    
    /**
     * 保存表单
     * @param request
     * 返回业务表单主键
     */
    public String saveForm(HttpServletRequest request);
    
    /**
     * 更新表单
     * @param request
     * 返回业务表单主键
     */
    public String editForm(HttpServletRequest request,String fromid);
    
    /**
     * 删除表单
     * @param formid
     * 返回业务表单主键
     */
    public boolean delForm(String formid);
    /**
     * 更新表单
     * @param fromid
     * @param deploymentid
     * @param processdefinitionid
     */
    public boolean updateForm(String fromid,String deploymentid,String processdefinitionid,String assignee,String taskId,String processInstanceId);
    /**
     * 表单流程状态修改
     * @param fromid 表单主键
     */
    public boolean editStatesForm(String fromid,int states,String assignee);
    /**
     * 表单流程状态更新
     * @param fromid 表单主键
     * @param states 状态 1:未提交 2:审批中 3:审批通过 5：审批未通过
     * @return
     */
    public boolean endForm(String fromid,int states,String assignee,String processInstanceId);
    
    /**
     * 获取表单
     * @param fromid 表单主键
     */
    public FlowModelVO getForm(String fromid);
    
}
