package cn.jyjz.flowable.service.impl;

import cn.jyjz.flowable.entity.DeModel;
import cn.jyjz.flowable.mapper.DeModelMapper;
import cn.jyjz.flowable.service.IDeModelService;
import cn.jyjz.flowable.utils.PageUtils;
import cn.jyjz.flowable.utils.Query;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author wanshu
 * @since 2022-08-02
 */
@Service
public class DeModelServiceImpl extends ServiceImpl<DeModelMapper, DeModel> implements IDeModelService {

    @Override
    public PageUtils list(PageUtils pageUtils, Integer type){
        QueryWrapper<DeModel> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(type!=null,"model_type",type)
                .and(StringUtils.isNotBlank(pageUtils.getKey()),item->{
                    item.like("name",pageUtils.getKey())
                            .or().like("description",pageUtils.getKey());
                });
        IPage<DeModel> page = this.page(new Query<DeModel>().getPage(pageUtils.getMap()), queryWrapper);
        pageUtils.setPage(page);
        return pageUtils;
    }
    
    public List<DeModel> list(String modelKey, Integer type){
        QueryWrapper<DeModel> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(type!=null,"model_key",modelKey);
        queryWrapper.eq(type!=null,"model_type",type);
        
        List<DeModel> modelList = this.list(queryWrapper);
        
        return modelList;
    }

}
