package cn.jyjz.flowable.service.impl;

import cn.jyjz.flowable.common.SystemConstantsOa;
import cn.jyjz.flowable.config.CustomProcessDiagramGenerator;
import cn.jyjz.flowable.domain.vo.*;
import cn.jyjz.flowable.service.IFlowInstanceService;
import cn.jyjz.xiaoyao.common.base.language.SystemMessage;
import cn.jyjz.xiaoyao.common.base.service.UserTokenService;
import cn.jyjz.xiaoyao.common.base.util.RequestBaseUtil;
import cn.jyjz.xiaoyao.common.base.util.requestFormat.SearchQuery;
import cn.jyjz.xiaoyao.common.base.vo.ResultVo;
import cn.jyjz.xiaoyao.common.base.vo.ResultVoUtil;
import cn.jyjz.xiaoyao.oa.from.dataDao.FlowableccMybatisDao;
import cn.jyjz.xiaoyao.oa.from.dataDao.IHisFlowableActinstDao;
import cn.jyjz.xiaoyao.oa.from.dataDao.IRunFlowableActinstDao;
import cn.jyjz.flowable.domain.dto.HistoricTaskInstanceDto;
import cn.jyjz.flowable.factory.FlowServiceFactory;
import cn.jyjz.flowable.service.IFlowTaskService;
import cn.jyjz.flowable.service.IFormCustomService;
import cn.jyjz.flowable.utils.PageUtils;
import cn.jyjz.xiaoyao.admin.dataobject.User;
import cn.jyjz.xiaoyao.admin.service.UserService;
import cn.jyjz.xiaoyao.common.base.param.ParamterPage;
import cn.jyjz.xiaoyao.common.base.util.SpringUtils;
import cn.jyjz.xiaoyao.common.base.vo.UserToken;

import cn.jyjz.xiaoyao.oa.from.dataobject.Category;

import cn.jyjz.xiaoyao.oa.from.dataobject.Flowablecc;
import cn.jyjz.xiaoyao.oa.from.dataobject.UserFinal;
import cn.jyjz.xiaoyao.oa.from.service.*;

import cn.jyjz.xiaoyao.oa.from.vo.FlowUnionVo;
import cn.jyjz.xiaoyao.ocr.dataobject.OcrTaskchildPicture;
import cn.jyjz.xiaoyao.ocr.service.OcrTaskchildPictureService;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.flowable.bpmn.constants.BpmnXMLConstants;
import org.flowable.bpmn.model.*;
import org.flowable.bpmn.model.Process;
import org.flowable.engine.ProcessEngineConfiguration;
import org.flowable.engine.history.HistoricActivityInstance;
import org.flowable.engine.history.HistoricProcessInstance;
import org.flowable.engine.history.HistoricProcessInstanceQuery;
import org.flowable.engine.impl.persistence.entity.ActivityInstanceEntity;
import org.flowable.engine.impl.util.ExecutionGraphUtil;
import org.flowable.engine.repository.ProcessDefinition;
import org.flowable.engine.runtime.ActivityInstance;
import org.flowable.engine.runtime.Execution;
import org.flowable.engine.runtime.ProcessInstance;
import org.flowable.engine.task.Comment;
import org.flowable.identitylink.api.IdentityLink;
import org.flowable.image.ProcessDiagramGenerator;
import org.flowable.image.impl.DefaultProcessDiagramGenerator;
import org.flowable.task.api.Task;
import org.flowable.task.api.TaskQuery;
import org.flowable.task.api.history.HistoricTaskInstance;
import org.flowable.task.api.history.HistoricTaskInstanceQuery;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.io.InputStream;
import java.util.*;
import java.util.stream.Collectors;

@Service
public class FlowTaskServiceImpl extends FlowServiceFactory implements IFlowTaskService {
    
    private Logger log = LoggerFactory.getLogger(FlowTaskServiceImpl.class);
    @Resource
    private CategoryService categoryService;
    @Resource
    private UserService userService;
    @Resource
    private UserViewapproeService userViewApproeService;
    @Resource
    private OcrTaskchildPictureService ocrTaskchildPictureService;
    @Resource
    private FlowableccMybatisDao flowableccMybatisDao;
    @Resource
    private CandidateuserService candidateuserService;
    @Resource
    private UserapproveService userapproveService;
    @Resource
    private UserTokenService userTokenService;
    @Resource
    private IFlowInstanceService iFlowInstanceService;
    @Resource
    private UserFinalService userFinalService;
    @Resource
    private IRunFlowableActinstDao runFlowableActinstDao;
    @Resource
    private IHisFlowableActinstDao hisFlowableActinstDao;
    @Override
    public void myTodoTaskList(PageUtils vo, HttpServletRequest request) {
        
        User user = this.userService.getSessionUser(request);
        
        String userName = user.getLoginname();
        
        TaskQuery taskQuery = taskService.createTaskQuery()
                .active() // 激活的任务
                .taskAssignee(userName)
                .orderByTaskCreateTime()
                .desc();
        // 查询条件
        if(StringUtils.isNotBlank(vo.getKey())){
            taskQuery.taskNameLike("%" + vo.getKey() + "%");
        }
        
        List<Task> tasks = taskQuery.listPage((vo.getCurrPage() - 1) * vo.getPageSize()
                , vo.getCurrPage() * vo.getPageSize());
        int totalcount = (int)taskQuery.count();
        vo.setTotalCount(totalcount);
        // 4 / 5 1  5/5 2  6/5 2
        if(totalcount%vo.getPageSize() == 0){
            vo.setTotalPage(totalcount / vo.getPageSize());
        }else{
            vo.setTotalPage((totalcount / vo.getPageSize()) + 1);
        }
        
        
        List<FlowModelVO> list = new ArrayList<>();
        if(tasks != null && tasks.size() > 0){
            for (Task task : tasks) {
                
                FlowModelVO flowTask = new FlowModelVO();
                
                
                // 流程发起人的信息
                ProcessInstance processInstance = runtimeService.createProcessInstanceQuery()
                        .processInstanceId(task.getProcessInstanceId())
                        .singleResult();
                
                //我这里以 流程定义key(oa_category_t定义的关键字，逻辑唯一) + 业务表主键（请假表、调岗表等） + 业务表对应的servicename
                String businesskey = processInstance.getBusinessKey();
                String[] busskey = businesskey.split(SystemConstantsOa.OA_BUSSINESS_KEY_SPLIT);
                IFormCustomService iFormCustomService = null;
                if(cn.jyjz.xiaoyao.common.base.util.StringUtils.isNotBlank(busskey[2])){
                    
                    iFormCustomService = SpringUtils.getBean(busskey[2]);
                    //表单主键
                    flowTask = iFormCustomService.getForm(busskey[1]);
                }
                
                BpmnModel bpmnModel = repositoryService.getBpmnModel(task.getProcessDefinitionId());
                // 获取节点定义id
                String taskDefinitionKey = task.getTaskDefinitionKey();
                // 根据节点定义id获取节点元素
                FlowElement flowElement = bpmnModel.getFlowElement(taskDefinitionKey);
                if (flowElement instanceof UserTask) {
                    UserTask userTask = (UserTask) flowElement;
                    
                    flowTask.setDocumentation(userTask.getDocumentation());
                }
                
                //  查询 当前的Task信息
                flowTask.setTaskId(task.getId());
                flowTask.setProcessInstanceId(task.getProcessInstanceId());
                flowTask.setTaskName(task.getName());
                
                
                // 查询流程定义的信息
                ProcessDefinition processDefinition = repositoryService.createProcessDefinitionQuery()
                        .processDefinitionId(task.getProcessDefinitionId())
                        .singleResult();
                flowTask.setProcDefId(task.getProcessDefinitionId());
                flowTask.setProcDefName(processDefinition.getName());
                flowTask.setProcDefVersion(processDefinition.getVersion());
                flowTask.setDeployId(processDefinition.getDeploymentId());
                
                // 流程发起人的信息
                HistoricProcessInstance historicProcessInstance = historyService.createHistoricProcessInstanceQuery()
                        .processInstanceId(task.getProcessInstanceId())
                        .singleResult();
                // 获取任务的发起人
                String startUserName = historicProcessInstance.getStartUserId();
                flowTask.setStartUserId(startUserName);
                // 查询nickName
                User startUser = userService.findByLoginname(startUserName);
                flowTask.setStartUserName(startUser.getUsername());
                flowTask.setStartTime(historicProcessInstance.getStartTime());
                
                //处理记录
                List<HistoricTaskInstanceDto> historicTaskInstanceDtos = listHistoriceTask(task.getProcessInstanceId());
                flowTask.setTransferRecords(historicTaskInstanceDtos);
                //flowTask.setSt
                list.add(flowTask);
            }
        }
        
        vo.setList(list);
        
    }
    
    /**
     * 获取流程过程图
     *
     * @param processId 流程实例ID
     * @return
     */
    @Override
    public InputStream diagram(String processId) {
        String processDefinitionId;
        // 获取当前的流程实例
        ProcessInstance processInstance = runtimeService.createProcessInstanceQuery().processInstanceId(processId).singleResult();
        // 如果流程已经结束，则得到结束节点
        if (Objects.isNull(processInstance)) {
            HistoricProcessInstance pi = historyService.createHistoricProcessInstanceQuery()
                    .processInstanceId(processId).singleResult();
            
            processDefinitionId = pi.getProcessDefinitionId();
        } else {
            // 如果流程没有结束，则取当前活动节点
            // 根据流程实例ID获得当前处于活动状态的ActivityId合集
            ProcessInstance pi = runtimeService.createProcessInstanceQuery()
                    .processInstanceId(processId).singleResult();
            processDefinitionId = pi.getProcessDefinitionId();
        }
        
        // 获得活动的节点
        List<HistoricActivityInstance> highLightedFlowList = historyService
                .createHistoricActivityInstanceQuery()
                .processInstanceId(processId)
                .orderByHistoricActivityInstanceStartTime().asc().list();
        
        List<String> highLightedFlows = new ArrayList<>();
        List<String> highLightedNodes = new ArrayList<>();
        //高亮线
        for (HistoricActivityInstance tempActivity : highLightedFlowList) {
            if ("sequenceFlow".equals(tempActivity.getActivityType())) {
                //高亮线
                highLightedFlows.add(tempActivity.getActivityId());
            } else {
                //高亮节点
                highLightedNodes.add(tempActivity.getActivityId());
            }
        }
        
        //获取流程图
        BpmnModel bpmnModel = repositoryService.getBpmnModel(processDefinitionId);
        ProcessEngineConfiguration configuration = processEngine.getProcessEngineConfiguration();
        //获取自定义图片生成器
        ProcessDiagramGenerator diagramGenerator = new CustomProcessDiagramGenerator();
        InputStream in = diagramGenerator
                .generateDiagram(bpmnModel, "png", highLightedNodes, highLightedFlows, configuration.getActivityFontName(),
                        configuration.getLabelFontName(), configuration.getAnnotationFontName(), configuration.getClassLoader(), 1.0, true);
        return in;
        
    }
    
    public Category viewForm(String processId,HttpServletRequest request){
        HistoricProcessInstance historicProcessInstance = historyService.createHistoricProcessInstanceQuery()
                .processInstanceId(processId).singleResult();
        historicProcessInstance.getBusinessKey();
        //我这里以 流程定义key(oa_category_t定义的关键字，逻辑唯一) + 业务表主键（请假表、调岗表等） + 业务表对应的servicename
        String businesskey = historicProcessInstance.getBusinessKey();
        
        if(StringUtils.isBlank(businesskey)){
            return null;
        }
        
        String[] busskey = businesskey.split(SystemConstantsOa.OA_BUSSINESS_KEY_SPLIT);
        Category category = this.categoryService.getCategory(busskey[1]);
        
        List<HistoricTaskInstance> list = historyService.createHistoricTaskInstanceQuery()
                .orderByHistoricTaskInstanceStartTime()
                .processInstanceId(processId)
                .asc()
                .list();
        // 获取节点定义id
        String taskDefinitionKey = "";
        for(HistoricTaskInstance historicTaskInstance:list){
            taskDefinitionKey = historicTaskInstance.getTaskDefinitionKey();
        }
        
        BpmnModel bpmnModel = repositoryService.getBpmnModel(historicProcessInstance.getProcessDefinitionId());
        
        // 根据节点定义id获取节点元素
        FlowElement flowElement = bpmnModel.getFlowElement(taskDefinitionKey);
        if (flowElement instanceof UserTask) {
            UserTask userTask = (UserTask) flowElement;
            category.setDocumentation(userTask.getDocumentation());
        }
        
        IFormCustomService iFormCustomService = null;
        if(cn.jyjz.xiaoyao.common.base.util.StringUtils.isNotBlank(busskey[2])) {
            
            iFormCustomService = SpringUtils.getBean(busskey[2]);
        }
        //表单主键
        FlowModelVO flowModelVO = iFormCustomService.getForm(busskey[1]);
        
        category.setStates(flowModelVO.getStates());
        category.setFormid(busskey[1]);
        return category;
    }
    /**
     * 获取已办流程过程图
     *
     * @param processId 流程实例ID
     * @return
     */
    @Override
    public InputStream myDiagram(String processId,HttpServletRequest request){
        String processDefinitionId;
        // 获取当前的流程实例
        ProcessInstance processInstance = runtimeService.createProcessInstanceQuery().processInstanceId(processId).singleResult();
        // 如果流程已经结束，则得到结束节点
        if (Objects.isNull(processInstance)) {
            HistoricProcessInstance pi = historyService.createHistoricProcessInstanceQuery()
                    .processInstanceId(processId).singleResult();
            
            processDefinitionId = pi.getProcessDefinitionId();
        } else {
            // 如果流程没有结束，则取当前活动节点
            // 根据流程实例ID获得当前处于活动状态的ActivityId合集
            ProcessInstance pi = runtimeService.createProcessInstanceQuery()
                    .processInstanceId(processId).singleResult();
            processDefinitionId = pi.getProcessDefinitionId();
        }
        User user = this.userService.getSessionUser(request);
        String userName = user.getLoginname();
        
        // 获得活动的节点
        List<HistoricActivityInstance> highLightedFlowList = historyService
                .createHistoricActivityInstanceQuery()
                .processInstanceId(processId)
                .taskAssignee(userName)
                .orderByHistoricActivityInstanceStartTime().asc().list();
        
        List<String> highLightedFlows = new ArrayList<>();
        List<String> highLightedNodes = new ArrayList<>();
        //高亮线
        for (HistoricActivityInstance tempActivity : highLightedFlowList) {
            if ("sequenceFlow".equals(tempActivity.getActivityType())) {
                //高亮线
                //highLightedFlows.add(tempActivity.getActivityId());
            } else {
                //高亮节点
                highLightedNodes.add(tempActivity.getActivityId());
            }
        }
        
        //获取流程图
        BpmnModel bpmnModel = repositoryService.getBpmnModel(processDefinitionId);
        ProcessEngineConfiguration configuration = processEngine.getProcessEngineConfiguration();
        //获取自定义图片生成器
        ProcessDiagramGenerator diagramGenerator = new DefaultProcessDiagramGenerator();
        InputStream in = diagramGenerator
                .generateDiagram(bpmnModel, "png", highLightedNodes, highLightedFlows, configuration.getActivityFontName(),
                        configuration.getLabelFontName(), configuration.getAnnotationFontName(), configuration.getClassLoader(), 1.0, true);
        return in;
    }
    
    
    /**
     * 获取当前任务的可回退的流程集合
     *
     * @param taskId 当前的任务 ID
     * @return 可以回退的节点列表
     */
    @Override
    public List<WorkFlowNodeVO> getReturnTaskList(String taskId) {

        // 初始化返回结果列表
        List<WorkFlowNodeVO> result = new ArrayList<>(16);
        if (StringUtils.isBlank(taskId)){
            return result;
        }
        Task task = taskService.createTaskQuery().taskId(taskId).singleResult();
        if (task == null){
            return result;
        }
        // 任务定义key 等于 当前任务节点id
        String taskDefinitionKey = task.getTaskDefinitionKey();
        BpmnModel bpmnModel = repositoryService.getBpmnModel(task.getProcessDefinitionId());
        Process mainProcess = bpmnModel.getMainProcess();
        // 当前节点
        FlowNode currentFlowElement = (FlowNode) mainProcess.getFlowElement(taskDefinitionKey, true);
        // 查询历史节点实例
        List<HistoricActivityInstance> activityInstanceList = historyService.createHistoricActivityInstanceQuery()
                .processInstanceId(task.getProcessInstanceId())
                .finished()
                .orderByHistoricActivityInstanceEndTime().asc().list();
        List<String> activityIdList = activityInstanceList.stream()
                .filter(activityInstance ->
                        BpmnXMLConstants.ELEMENT_TASK_USER.equals(activityInstance.getActivityType()) || BpmnXMLConstants.ELEMENT_EVENT_START.equals(activityInstance.getActivityType()))
                .map(HistoricActivityInstance::getActivityId)
                .filter(activityId -> !taskDefinitionKey.equals(activityId))
                .distinct()
                .collect(Collectors.toList());
        for (String activityId : activityIdList) {
            // 回退到主流程的节点
            FlowNode toBackFlowElement = (FlowNode) mainProcess.getFlowElement(activityId, true);
            // 判断 【工具类判断是否可以从源节点 到 目标节点】
            Set<String> set = new HashSet<>();
            if (toBackFlowElement != null && ExecutionGraphUtil.isReachable(mainProcess,toBackFlowElement,currentFlowElement, set)) {
                WorkFlowNodeVO workFlowNodeVO = new WorkFlowNodeVO();
                workFlowNodeVO.setNodeId(activityId);
                workFlowNodeVO.setNodeName(toBackFlowElement.getName());
                result.add(workFlowNodeVO);
            }
        }
        return result;
    }

    
    /**
     * 完成任务
     */
    @Override
    public Boolean complete(FlowTaskVO taskVO,HttpServletRequest request) {
        try {
            // 当前要处理的任务
            Task task = taskService.createTaskQuery().taskId(taskVO.getTaskId()).singleResult();
            // 查询流程定义的信息
            ProcessDefinition processDefinition = repositoryService.createProcessDefinitionQuery()
                    .processDefinitionId(task.getProcessDefinitionId())
                    .singleResult();
            // 对任务添加对应的审批意见
            taskService.addComment(task.getId(),task.getProcessInstanceId(),taskVO.getTaskComment());
            
            Map<String,Object> variables = new HashMap<>();
            if(null != taskVO.getTaskApprovd() && StringUtils.isNotBlank(taskVO.getTaskApprovd().toString())){
                variables.put("taskApprovd",taskVO.getTaskApprovd().intValue());
            }
            variables.put("approvd",taskVO.getApprovd());
            
            //只有同意，再进行候选人设置
            if(taskVO.getApprovd()){
                //进入下一个节点
                taskService.complete(task.getId(),variables);

                
                //判断是否存在表单二次提交
                if(StringUtils.isNotBlank(taskVO.getDocumentation()) && taskVO.getDocumentation().equals(SystemConstantsOa.OA_TASK_COMPLETE_FORM)){
                    //获取流程类型
                    String category = processDefinition.getCategory();
                    if(StringUtils.isNotBlank(category)){
                        Category categoryDto = this.categoryService.getCategory(category);
                        //解析页面请求，并持久化
                        IFormCustomService iFormCustomService = SpringUtils.getBean(categoryDto.getServicename());
                        
                        //TODO 如果更新失败，需要撤销流程
                        if(null == iFormCustomService.editForm(request,taskVO.getFormid())){
                            //撤销审批
                            
                        }
                    }
                }
                //判断是否存在表单三次提交
                if(StringUtils.isNotBlank(taskVO.getDocumentation()) && taskVO.getDocumentation().equals(SystemConstantsOa.OA_TASK_COMPLETE_THREE_FORM)){
                    //获取流程类型
                    String category = processDefinition.getCategory();
                    if(StringUtils.isNotBlank(category)){
                        Category categoryDto = this.categoryService.getCategory(category);
                        //解析页面请求，并持久化
                        IFormCustomService iFormCustomService = SpringUtils.getBean(categoryDto.getServicename());
                        
                        //TODO 如果更新失败，需要撤销流程
                        if(null == iFormCustomService.editForm(request,taskVO.getFormid())){
                            //撤销审批
                            
                        }
                    }
                }
                updateAssignee(task.getProcessInstanceId(),task.getProcessDefinitionId(),processDefinition);
    
                String category = processDefinition.getCategory();
                Category categoryDto = this.categoryService.getCategory(category);
                IFormCustomService iFormCustomService = SpringUtils.getBean(categoryDto.getServicename());
    
                FlowModelVO formData = iFormCustomService.getForm(taskVO.getFormid());
    
                List<Task> taskList = this.nowRunTask(formData.getProcessInstanceId(),formData.getProcessdefinitionid());
                Task taskData = null;
                if(null != taskList && !taskList.isEmpty()) {
                    taskData = taskList.get(0);
                }
                //判断节点上的描述字段，是否伟finale_judgment,如果是，记录到终审表中，如果终审表已经存在，不再重复记录
                if(null != taskData && StringUtils.isNotBlank(taskData.getDescription()) && taskData.getDescription().equals(SystemConstantsOa.OA_TASK_COMPLETE_FINALE_FORM)){
                    UserToken userToken = this.userTokenService.getUserToken(RequestBaseUtil.getToken(request));
                    User user = userService.findByLoginname(formData.getAssignee());
                    userFinalService.save(user.getId().toString(),taskVO.getFormid());
                }
                
                //增加未查看记录
                userViewApproeService.saveUserViewApproe(formData.getAssignee(),formData.getFormid().toString(),formData.getTenantid().toString());
            }else{
                ProcessInstance processInstance = runtimeService.createProcessInstanceQuery().processInstanceId(task.getProcessInstanceId()).singleResult();
                //我这里以 流程定义key(oa_category_t定义的关键字，逻辑唯一) + 业务表主键（请假表、调岗表等） + 业务表对应的servicename
                String businesskey = processInstance.getBusinessKey();
                //3、修改业务表状态
                //判断业务key是否存在
                if(StringUtils.isNotBlank(businesskey)){
                    
                    String assignee = "";
                    BpmnModel bpmnModel = repositoryService.getBpmnModel(task.getProcessDefinitionId());
                    //传节点定义key获取当前节点
                    FlowElement flowElement = bpmnModel.getFlowElement(task.getTaskDefinitionKey());
                    if(flowElement instanceof UserTask) {
                        UserTask userTask = (UserTask) flowElement;
                        
                        //如果审批不存在，需要在候选组中查询
                        if(StringUtils.isBlank(userTask.getAssignee())){
                            assignee = userTask.getAssignee();
                        }
                    }
                    String[] busskey = businesskey.split(SystemConstantsOa.OA_BUSSINESS_KEY_SPLIT);
                    IFormCustomService iFormCustomService = SpringUtils.getBean(busskey[2]);
                    //设置流程结束状态
                    iFormCustomService.endForm(busskey[1],SystemConstantsOa.OA_STATUS_TYPE_REFUSE,assignee,task.getProcessInstanceId());
                }
                
                //1、获取终止节点
                List<EndEvent> endNodes =findEndFlowElement(task.getProcessDefinitionId());
                String endId = endNodes.get(0).getId();
                //2、执行终止
                List<Execution> executions = runtimeService.createExecutionQuery().parentId(task.getProcessInstanceId()).list();
                List<String> executionIds = new ArrayList<>();
                executions.forEach(execution -> executionIds.add(execution.getId()));
                runtimeService.createChangeActivityStateBuilder().moveExecutionsToSingleActivityId(executionIds, endId).processVariables(variables).changeState();
                
            }

            
            UserToken userToken = this.userTokenService.getUserToken(RequestBaseUtil.getToken(request));
            //保存当前审批用户与业务表的关系
            userapproveService.save(userToken.getUserid(),taskVO.getFormid());

            
            return true;
        }catch (Exception e){
            log.error("e={}",e);
        }
        return false;
    }
    
    /**
     * 更新当前节点处理人信息
     * @param processDefinition
     */
    public void updateAssignee(String processInstanceId,String processDefinitionId,ProcessDefinition processDefinition){
        
        //如果是多个候选人或者是候选组，做任务拾取
        FlowTaskCompleteVO flowTaskCompleteVO = updateNowTaskAssignee(processInstanceId,processDefinitionId);
        
        if(null != flowTaskCompleteVO){
            
            Task task = taskService.createTaskQuery().taskId(flowTaskCompleteVO.getTaskId()).singleResult();
            
            //更新业务表
            ProcessInstance processInstance = runtimeService.createProcessInstanceQuery().processInstanceId(task.getProcessInstanceId()).singleResult();
            //我这里以 流程定义key(oa_category_t定义的关键字，逻辑唯一) + 业务表主键（请假表、调岗表等） + 业务表对应的servicename
            String businesskey = processInstance.getBusinessKey();
            
            IFormCustomService iFormCustomService = null;
            if(StringUtils.isNotBlank(businesskey)){
                String[] busskey = businesskey.split(SystemConstantsOa.OA_BUSSINESS_KEY_SPLIT);
                iFormCustomService = SpringUtils.getBean(busskey[2]);
                iFormCustomService.updateForm(busskey[1],processDefinition.getDeploymentId(),processDefinition.getId(),flowTaskCompleteVO.getAssignee(),flowTaskCompleteVO.getTaskId(),processInstanceId);
            }
        }
        
    }
    public List findEndFlowElement(String processDefId) {
        Process mainProcess = repositoryService.getBpmnModel(processDefId).getMainProcess();
        Collection<FlowElement> list = mainProcess.getFlowElements();
        if (CollectionUtils.isEmpty(list)) {
            return Collections.EMPTY_LIST;
        }
        return list.stream().filter(f -> f instanceof EndEvent).collect(Collectors.toList());
    }
    /**
     * 查看当前执行人列表
     * @param processInstanceId
     * @return
     */
    public List getApprovers(String processInstanceId) {
        List<Object> users = new ArrayList<>();
        List<Task> list = taskService.createTaskQuery().processInstanceId(processInstanceId).list();
        if (null != list && list.size() > 0) {
            list.forEach(task -> {
                if (StringUtils.isNotBlank(task.getAssignee())) {
                    //1.审批人ASSIGNEE_是用户id
                    Object user = identityService.createUserQuery().userId(task.getAssignee()).singleResult();
                    if (user != null) {
                        users.add(user);
                    }
                    //2.审批人ASSIGNEE_是组id
                    List gusers = identityService.createUserQuery().memberOfGroup(task.getAssignee()).list();
                    if (null != gusers && gusers.size() > 0) {
                        users.addAll(gusers);
                    }
                } else {
                    List<IdentityLink> identityLinks = taskService.getIdentityLinksForTask(task.getId());
                    if (null != identityLinks && identityLinks.size() > 0) {
                        identityLinks.forEach(identityLink -> {
                            //3.审批人ASSIGNEE_为空,用户id
                            if (StringUtils.isNotBlank(identityLink.getUserId())) {
                                Object user = identityService.createUserQuery().userId(identityLink.getUserId()).singleResult();
                                if (user != null) {
                                    users.add(user);
                                }
                            } else {
                                //4.审批人ASSIGNEE_为空,组id
                                List gusers = identityService.createUserQuery().memberOfGroup(identityLink.getGroupId()).list();
                                if (null != gusers && gusers.size() > 0 ) {
                                    users.addAll(gusers);
                                }
                            }
                        });
                    }
                }
            });
        }
        return users;
    }
    
    public List<String> listTask(String processInstanceId){
        List<String> activeActivityIds = runtimeService.getActiveActivityIds(processInstanceId);
        
        return activeActivityIds;
    }
    
    /**
     * 设置当前审批节点的审批人
     * 目前只多候选组和多个候选人起作用
     * @param processInstanceId
     */
    public FlowTaskCompleteVO updateNowTaskAssignee(String processInstanceId, String processDefinitionId){
        
        FlowTaskCompleteVO flowTaskCompleteVO = null;
        BpmnModel bpmnModel = repositoryService.getBpmnModel(processDefinitionId);
        
        List<Task> taskList = taskService.createTaskQuery().processInstanceId(processInstanceId).list();
        
        //记录审批人信息
        StringBuffer assignee = new StringBuffer();
        for(Task task:taskList){
            
            //传节点定义key获取当前节点
            FlowElement flowElement = bpmnModel.getFlowElement(task.getTaskDefinitionKey());
            if(flowElement instanceof UserTask && StringUtils.isBlank(task.getAssignee())) {
                UserTask userTask = (UserTask) flowElement;
                
                //如果审批不存在，需要在候选组中查询
                if(StringUtils.isBlank(userTask.getAssignee())){
                    //得到候选人
                    List<String> candidateUsers = userTask.getCandidateUsers();
                    if(null != candidateUsers && !candidateUsers.isEmpty()){
                        Random rand = new Random();
                        taskService.claim(task.getId(), candidateUsers.get(rand.nextInt(candidateUsers.size())));
                    }
                    
                    //得到候选组
                    List<String> candidateGroups = userTask.getCandidateGroups();
                    if(null != candidateGroups && !candidateGroups.isEmpty()){
                        String loginuser = null;
                        for(String groupid:candidateGroups){
                            //获取发起人员信息
                            HistoricProcessInstance hi = historyService.createHistoricProcessInstanceQuery()
                                    .processInstanceId(processInstanceId)
                                    .singleResult();
                            //发起人员登录账号
                            String startUserId = hi.getStartUserId();
                            //通过候选组主键，查询审批人员信息，并自动拾取
                            loginuser = candidateuserService.getClaimUser(startUserId,groupid);
                            if(StringUtils.isNotBlank(loginuser)){
                                taskService.claim(task.getId(), loginuser);
                            }
                        }
                        
                    }
                }
                
            }
            log.info("task.getAssignee()={}",task.getAssignee());
            Task tasknow = taskService.createTaskQuery().taskId(task.getId()).singleResult();
            log.info("tasknow.getAssignee()={}",tasknow.getAssignee());
            if(StringUtils.isNotBlank(tasknow.getAssignee())){
                
                flowTaskCompleteVO = new FlowTaskCompleteVO();
                
                if(StringUtils.isNotBlank(assignee.toString())){
                    assignee.append("," + tasknow.getAssignee());
                }else{
                    assignee.append(tasknow.getAssignee());
                }
                flowTaskCompleteVO.setTaskId(tasknow.getId());
                flowTaskCompleteVO.setAssignee(assignee.toString());
            }
        }
        return flowTaskCompleteVO;
    }
    /**
     * 设置当前审批节点的
     */
    public List<Task> nowRunTask(String processInstanceId, String processDefinitionId){
        
        List<Task> taskList = taskService.createTaskQuery()
                .processDefinitionId(processDefinitionId).processInstanceId(processInstanceId)
                .list();
        return taskList;
    }
    /**
     * 获取下一个节点审批人信息
     * @param userTaskList
     * @param bpmnModel
     * @param currentId
     */
    public void getNextUserTaskList(ArrayList<String> userTaskList, BpmnModel bpmnModel, String currentId) {
        //通过节点定义id获取当前节点
        FlowNode flowNode = (FlowNode) bpmnModel.getFlowElement(currentId);
        //当前节点所有输出顺序流
        List<SequenceFlow> outgoingFlows = flowNode.getOutgoingFlows();
        
        FlowElement targetFlowElement = null;
        for (SequenceFlow outgoingFlow : outgoingFlows) {
            
            // 忽略非正常流转的节点,"${pass}"为自定义的流转表达式
            if (outgoingFlow.getConditionExpression() != null && !"${pass}".equals(outgoingFlow.getConditionExpression())) {
                continue;
            }
            
            
            targetFlowElement = outgoingFlow.getTargetFlowElement();
            
            //用户节点
            if (targetFlowElement instanceof UserTask) {
                UserTask userTask = (UserTask) targetFlowElement;
                
                //TODO 其他候选组之类的判断需要增加
                userTaskList.add(userTask.getAssignee());
                //userTaskList.add((UserTask) targetFlowElement);
                break;
            } else if (targetFlowElement instanceof EndEvent) {
                // 结束节点
            }else {
                // 没有找到用户节点，且下一节点不是最后一个节点，继续查找
                getNextUserTaskList(userTaskList, bpmnModel, targetFlowElement.getId());
            }
        }
    }
    
    /**
     * 查询我的已办信息
     * @param pageUtils
     */
    @Override
    public void finishedList(PageUtils pageUtils,HttpServletRequest request) {
        
        
        // 获取当前登录的账号
        User user = this.userService.getSessionUser(request);
        String userName = user.getLoginname();
        
        HistoricTaskInstanceQuery taskInstanceQuery = historyService.createHistoricTaskInstanceQuery()
                .includeProcessVariables()
                .finished()
                .taskAssignee(userName)
                .orderByHistoricTaskInstanceStartTime()
                .desc();
        // 关键字查询
        
        List<HistoricTaskInstance> historicTaskInstances = taskInstanceQuery.listPage((pageUtils.getCurrPage() - 1) * pageUtils.getPageSize()
                , pageUtils.getCurrPage() * pageUtils.getPageSize());
        pageUtils.setTotalCount((int) taskInstanceQuery.count());
        List<FlowModelVO> list = new ArrayList<>();
        for (HistoricTaskInstance historicTaskInstance : historicTaskInstances) {
            
            FlowModelVO flowTask = new FlowModelVO();
            // 流程发起人的信息
            HistoricProcessInstance historicProcessInstance = historyService.createHistoricProcessInstanceQuery()
                    .processInstanceId(historicTaskInstance.getProcessInstanceId())
                    .singleResult();
            
            //我这里以 流程定义key(oa_category_t定义的关键字，逻辑唯一) + 业务表主键（请假表、调岗表等） + 业务表对应的servicename
            String businesskey = historicProcessInstance.getBusinessKey();
            
            if(StringUtils.isBlank(businesskey)){
                continue;
            }
            
            String[] busskey = businesskey.split(SystemConstantsOa.OA_BUSSINESS_KEY_SPLIT);
            IFormCustomService iFormCustomService = null;
            if(cn.jyjz.xiaoyao.common.base.util.StringUtils.isNotBlank(busskey[2])){
                
                iFormCustomService = SpringUtils.getBean(busskey[2]);
                //表单主键
                flowTask = iFormCustomService.getForm(busskey[1]);
            }
            if(null == flowTask){
                flowTask = new FlowModelVO();
            }
            // 任务审批耗时
            if(null != historicTaskInstance && null != historicTaskInstance.getDurationInMillis()){
                flowTask.setDuration(historicTaskInstance.getDurationInMillis()/1000+"秒");
            }
            
            /*Map<String, VariableInstance> variableInstances = taskService.getVariableInstances(historicTaskInstance.getId());
            // 绑定对应的流程变量
            flowTask.setVariableInstances(variableInstances);*/
            // 绑定流程变量
            Map<String, Object> processVariables = historicTaskInstance.getProcessVariables();
            flowTask.setVariables(processVariables);
            
            flowTask.setProcessInstanceId(historicTaskInstance.getProcessInstanceId());
            flowTask.setTaskName(historicTaskInstance.getName());
            
            // 查询流程定义的信息
            ProcessDefinition processDefinition = repositoryService.createProcessDefinitionQuery()
                    .processDefinitionId(historicTaskInstance.getProcessDefinitionId())
                    .singleResult();
            flowTask.setProcDefId(historicTaskInstance.getProcessDefinitionId());
            flowTask.setProcDefName(processDefinition.getName());
            flowTask.setProcDefVersion(processDefinition.getVersion());
            flowTask.setDeployId(processDefinition.getDeploymentId());
            
            // 获取任务的发起人
            String startUserName = historicProcessInstance.getStartUserId();
            
            User startUser = userService.findByLoginname(startUserName);
            flowTask.setStartUserId(startUser.getLoginname());
            
            flowTask.setStartUserName(startUser.getUsername());
            flowTask.setStartTime(historicProcessInstance.getStartTime());
            
            List<HistoricTaskInstanceDto> historicTaskInstanceDtos = listHistoriceTask(historicTaskInstance.getProcessInstanceId());

//            // 查询当前任务的流转信息
//            List<HistoricTaskInstance> taskHiInstances = historyService.createHistoricTaskInstanceQuery()
//                                    .processInstanceId(historicTaskInstance.getProcessInstanceId())
//                                    .orderByHistoricTaskInstanceStartTime()
//                                    .asc()
//                                    .list();
//            for (HistoricTaskInstance taskHiInstance : taskHiInstances) {
//                HistoricTaskInstanceDto dto = new HistoricTaskInstanceDto();
//                dto.setTaskId(taskHiInstance.getId());
//                dto.setTaskName(taskHiInstance.getName());
//                dto.setFinishTime(taskHiInstance.getEndTime());
//                if(taskHiInstance.getDurationInMillis() != null){
//                    dto.setDuration(taskHiInstance.getDurationInMillis()/1000 + "秒");
//                }
//
//                if(StringUtils.isNotBlank(taskHiInstance.getAssignee())){
//                    User user1 = userService.findByLoginname(taskHiInstance.getAssignee());
//                    dto.setAssigneeName(user1.getUsername());
//                }
//
//                // 还需要根据 HistoricTaskInstance 找到对应的 审批意见
//                List<Comment> processInstanceComments = taskService.getProcessInstanceComments(historicTaskInstance.getProcessInstanceId());
//                for (Comment comment : processInstanceComments) {
//                    if(comment.getTaskId().equals(taskHiInstance.getId())){
//                        // 审批意见
//                        String fullMessage = comment.getFullMessage();
//                        dto.setComment(fullMessage);
//                    }
//                }
//                historicTaskInstanceDtos.add(dto);
//            }
            flowTask.setTransferRecords(historicTaskInstanceDtos);
            //flowTask.setSt
            list.add(flowTask);
        }
        
        pageUtils.setList(list);
    }
    
    /**
     * 查看任务的流程记录
     * @return
     */
    public List<HistoricTaskInstanceDto> listHistoriceTask(String processInstanceId){
        List<HistoricTaskInstanceDto> historicTaskInstanceDtos = new ArrayList<>();
        // 查询当前任务的流转信息
        List<HistoricTaskInstance> taskHiInstances = historyService.createHistoricTaskInstanceQuery()
                .processInstanceId(processInstanceId)
                .includeProcessVariables()
                .orderByHistoricTaskInstanceStartTime()
                .asc()
                .list();
        for (HistoricTaskInstance taskHiInstance : taskHiInstances) {
            HistoricTaskInstanceDto dto = new HistoricTaskInstanceDto();
            dto.setTaskId(taskHiInstance.getId());
            dto.setTaskName(taskHiInstance.getName());
            dto.setFinishTime(taskHiInstance.getEndTime());
            //Map<String,Object> variables = taskHiInstance.getTaskLocalVariables();
            Map<String,Object> variables = taskHiInstance.getProcessVariables();
            if(null != variables && null != variables.get("approvd")){
                dto.setState(variables.get("approvd").toString());
            }
            
            if(taskHiInstance.getDurationInMillis() != null){
                dto.setDuration(taskHiInstance.getDurationInMillis()/1000 + "秒");
            }
            dto.setTaskDefKey(taskHiInstance.getTaskDefinitionKey());
            if(StringUtils.isNotBlank(taskHiInstance.getAssignee())){
                if(SystemConstantsOa.OA_TASK_SKIP_ASSIGINE.equals(taskHiInstance.getAssignee())){
                    dto.setAssigneeName(taskHiInstance.getAssignee());
                }else{
                    User user1 = userService.findByLoginname(taskHiInstance.getAssignee());
                    dto.setAssigneeName(user1.getUsername());
                }
            }
            
            // 还需要根据 HistoricTaskInstance 找到对应的 审批意见
            List<Comment> processInstanceComments = taskService.getProcessInstanceComments(processInstanceId);
            for (Comment comment : processInstanceComments) {
                if(comment.getTaskId().equals(taskHiInstance.getId())){
                    // 审批意见
                    String fullMessage = comment.getFullMessage();
                    dto.setComment(fullMessage);
                }
            }
            historicTaskInstanceDtos.add(dto);
        }
        return historicTaskInstanceDtos;
    }
    
    /**
     * 查询最终审批数据
     *
     * @param query 搜索条件
     * @param pageUtils  分页参数
     * @return
     */
    public void getFinalProcessInstances( Map<String, Object> query, PageUtils<OcrTaskchildPicture> pageUtils){
        ParamterPage paramterPage = new ParamterPage();
        paramterPage.setStart((pageUtils.getCurrPage() - 1) * pageUtils.getPageSize());
        paramterPage.setPagesize(pageUtils.getPageSize());
    
        if(StringUtils.isNotBlank(pageUtils.getSortname())){
            paramterPage.setSortname(pageUtils.getSortname());
        }else{
            paramterPage.setSortname("CREATEDATE");
        }
    
        if(StringUtils.isNotBlank(pageUtils.getSortorder())){
            paramterPage.setSortorder(pageUtils.getSortorder());
        }else{
            paramterPage.setSortorder("DESC");
        }
        
        Long count = ocrTaskchildPictureService.listFinalCount(query);
    
        query.put("page",paramterPage);
        List<OcrTaskchildPicture> list = ocrTaskchildPictureService.listFinal(query);
    
        for(OcrTaskchildPicture taskchildPicture:list){
            //查询对应的流程分类
            Category category = categoryService.selectDtoById(taskchildPicture.getCategoryid());
            taskchildPicture.setCategoryDto(category);
    
            if(StringUtils.isNotBlank(taskchildPicture.getProcessdefinitionid())){
    
                List<Task> taskList = this.nowRunTask(taskchildPicture.getProcessinstanceid(),taskchildPicture.getProcessdefinitionid());
                if(null != taskList && !taskList.isEmpty()){
                    taskchildPicture.setTaskId(taskList.get(0).getId());
        
                    Task tasknow =taskService.createTaskQuery().taskId(taskchildPicture.getTaskId()).singleResult();
                    BpmnModel bpmnModel = repositoryService.getBpmnModel(tasknow.getProcessDefinitionId());
                    // 获取节点定义id
                    String taskDefinitionKey = tasknow.getTaskDefinitionKey();
                    // 根据节点定义id获取节点元素
                    FlowElement flowElement = bpmnModel.getFlowElement(taskDefinitionKey);
                    if (flowElement instanceof UserTask) {
                        UserTask userTask = (UserTask) flowElement;
    
                        taskchildPicture.setDocumentation(userTask.getDocumentation());
                    }
                }
    
                //查询历史
                List<HistoricTaskInstanceDto> historicTaskInstanceDtos = new ArrayList<>();
                // 查询当前任务的流转信息
                List<HistoricTaskInstance> taskHiInstances = historyService.createHistoricTaskInstanceQuery()
                        .processInstanceId(taskchildPicture.getProcessinstanceid())
                        .includeProcessVariables()
                        .orderByHistoricTaskInstanceStartTime()
                        .asc()
                        .list();
                for (HistoricTaskInstance taskHiInstance : taskHiInstances) {
                    HistoricTaskInstanceDto dto = new HistoricTaskInstanceDto();
                    dto.setTaskId(taskHiInstance.getId());
                    dto.setTaskName(taskHiInstance.getName());
                    dto.setFinishTime(taskHiInstance.getEndTime());
                    if(taskHiInstance.getDurationInMillis() != null){
                        dto.setDuration(taskHiInstance.getDurationInMillis()/1000 + "秒");
                    }
                    dto.setTaskDefKey(taskHiInstance.getTaskDefinitionKey());
        
                    //Map<String,Object> variables = taskHiInstance.getTaskLocalVariables();
        
                    Map<String,Object> variables = taskHiInstance.getProcessVariables();
        
                    if(null != variables && null != variables.get("approvd")){
                        dto.setState(variables.get("approvd").toString());
                    }
        
                    if(StringUtils.isNotBlank(taskHiInstance.getAssignee())){
                        if(SystemConstantsOa.OA_TASK_SKIP_ASSIGINE.equals(taskHiInstance.getAssignee())){
                            dto.setAssigneeName(taskHiInstance.getAssignee());
                        }else{
                            User user1 = userService.findByLoginname(taskHiInstance.getAssignee());
                
                            dto.setAssigneeName(user1.getUsername());
                        }
            
                    }
        
                    BpmnModel bpmnModel = repositoryService.getBpmnModel(taskchildPicture.getProcessdefinitionid());

//                // 根据节点定义id获取节点元素
                    FlowElement flowElement = bpmnModel.getFlowElement(taskHiInstance.getTaskDefinitionKey());
                    if (flowElement instanceof UserTask) {
                        UserTask userTask = (UserTask) flowElement;
    
                        taskchildPicture.setDocumentation(userTask.getDocumentation());
                    }
                    // 还需要根据 HistoricTaskInstance 找到对应的 审批意见
                    List<Comment> processInstanceComments = taskService.getProcessInstanceComments(taskchildPicture.getProcessinstanceid());
                    for (Comment comment : processInstanceComments) {
            
                        if(comment.getTaskId().equals(taskHiInstance.getId())){
                            // 审批意见
                            String fullMessage = comment.getFullMessage();
                            dto.setComment(fullMessage);
                        }
                    }
                    historicTaskInstanceDtos.add(dto);
                }
                taskchildPicture.setTransferRecords(historicTaskInstanceDtos);
            }
        }
    
        pageUtils.setTotalCount(count.intValue());
        pageUtils.setList(list);
    }
    
    /**
     * 查询我发起的流程实例
     *
     * @param query 查询条件
     * @param pageUtils  分页参数
     * @return
     */
    public void getMyProcessInstances(Map<String, Object> query, PageUtils<FlowUnionVo> pageUtils){
        ParamterPage paramterPage = new ParamterPage();
        paramterPage.setStart((pageUtils.getCurrPage() - 1) * pageUtils.getPageSize());
        paramterPage.setPagesize(pageUtils.getPageSize());
        
        if(StringUtils.isNotBlank(pageUtils.getSortname())){
            paramterPage.setSortname(pageUtils.getSortname());
        }else{
            paramterPage.setSortname("CREATEDATE");
        }
    
        if(StringUtils.isNotBlank(pageUtils.getSortorder())){
            paramterPage.setSortorder(pageUtils.getSortorder());
        }else{
            paramterPage.setSortorder("DESC");
        }
        
        query.put("page",paramterPage);
        
        Long count = flowableccMybatisDao.listMyCcCount(query);
        List<FlowUnionVo> list = flowableccMybatisDao.listMyCc(query);

//        IPage<FlowUnionVo> flowableccIPage = new Page();
//
//        flowableccIPage.setSize(paramterPage.getPagesize());
//        flowableccIPage.setTotal(count);
//        flowableccIPage.setCurrent(paramterPage.getStart());
//
//        flowableccIPage.setRecords(list);
        for(FlowUnionVo flowUnionVo:list){
            
            //查询对应的流程分类
            Category category = categoryService.selectDtoById(flowUnionVo.getCategoryid());
            flowUnionVo.setCategoryDto(category);
            
            if(StringUtils.isNotBlank(flowUnionVo.getProcessdefinitionid())){
                
                List<Task> taskList = this.nowRunTask(flowUnionVo.getProcessinstanceid(),flowUnionVo.getProcessdefinitionid());
                if(null != taskList && !taskList.isEmpty()){
                    flowUnionVo.setTaskId(taskList.get(0).getId());
                    
                    Task tasknow =taskService.createTaskQuery().taskId(flowUnionVo.getTaskId()).singleResult();
                    BpmnModel bpmnModel = repositoryService.getBpmnModel(tasknow.getProcessDefinitionId());
                    // 获取节点定义id
                    String taskDefinitionKey = tasknow.getTaskDefinitionKey();
                    // 根据节点定义id获取节点元素
                    FlowElement flowElement = bpmnModel.getFlowElement(taskDefinitionKey);
                    if (flowElement instanceof UserTask) {
                        UserTask userTask = (UserTask) flowElement;
                        
                        flowUnionVo.setDocumentation(userTask.getDocumentation());
                    }
                }
                
                
                //查询历史
                List<HistoricTaskInstanceDto> historicTaskInstanceDtos = new ArrayList<>();
                // 查询当前任务的流转信息
                List<HistoricTaskInstance> taskHiInstances = historyService.createHistoricTaskInstanceQuery()
                        .processInstanceId(flowUnionVo.getProcessinstanceid())
                        .includeProcessVariables()
                        .orderByHistoricTaskInstanceStartTime()
                        .asc()
                        .list();
                for (HistoricTaskInstance taskHiInstance : taskHiInstances) {
                    HistoricTaskInstanceDto dto = new HistoricTaskInstanceDto();
                    dto.setTaskId(taskHiInstance.getId());
                    dto.setTaskName(taskHiInstance.getName());
                    dto.setFinishTime(taskHiInstance.getEndTime());
                    if(taskHiInstance.getDurationInMillis() != null){
                        dto.setDuration(taskHiInstance.getDurationInMillis()/1000 + "秒");
                    }
                    dto.setTaskDefKey(taskHiInstance.getTaskDefinitionKey());
                    
                    //Map<String,Object> variables = taskHiInstance.getTaskLocalVariables();
                    
                    Map<String,Object> variables = taskHiInstance.getProcessVariables();
                    
                    if(null != variables && null != variables.get("approvd")){
                        dto.setState(variables.get("approvd").toString());
                    }
                    
                    if(StringUtils.isNotBlank(taskHiInstance.getAssignee())){
                        if(SystemConstantsOa.OA_TASK_SKIP_ASSIGINE.equals(taskHiInstance.getAssignee())){
                            dto.setAssigneeName(taskHiInstance.getAssignee());
                        }else{
                            User user1 = userService.findByLoginname(taskHiInstance.getAssignee());
                            
                            dto.setAssigneeName(user1.getUsername());
                        }
                        
                    }
                    
                    BpmnModel bpmnModel = repositoryService.getBpmnModel(flowUnionVo.getProcessdefinitionid());

//                // 根据节点定义id获取节点元素
                    FlowElement flowElement = bpmnModel.getFlowElement(taskHiInstance.getTaskDefinitionKey());
                    if (flowElement instanceof UserTask) {
                        UserTask userTask = (UserTask) flowElement;
                        
                        flowUnionVo.setDocumentation(userTask.getDocumentation());
                    }
                    // 还需要根据 HistoricTaskInstance 找到对应的 审批意见
                    List<Comment> processInstanceComments = taskService.getProcessInstanceComments(flowUnionVo.getProcessinstanceid());
                    for (Comment comment : processInstanceComments) {
                        
                        if(comment.getTaskId().equals(taskHiInstance.getId())){
                            // 审批意见
                            String fullMessage = comment.getFullMessage();
                            dto.setComment(fullMessage);
                        }
                    }
                    historicTaskInstanceDtos.add(dto);
                }
                flowUnionVo.setTransferRecords(historicTaskInstanceDtos);
            }
        }
        
        pageUtils.setTotalCount(count.intValue());
        pageUtils.setList(list);

    }
    
    /**
     * 查询我发起的流程实例
     *
     * @param query 查询条件
     * @return
     */
    public List<FlowUnionVo> getMyProcessInstances(Map<String, Object> query){
        ParamterPage paramterPage = new ParamterPage();
        
        paramterPage.setSortname("CREATEDATE");
        paramterPage.setSortorder("DESC");
        query.put("page",paramterPage);
        
        List<FlowUnionVo> list = flowableccMybatisDao.listMyCc(query);
        
        for(FlowUnionVo flowUnionVo:list){
            
            //查询对应的流程分类
            Category category = categoryService.selectDtoById(flowUnionVo.getCategoryid());
            flowUnionVo.setCategoryDto(category);
            
            if(StringUtils.isNotBlank(flowUnionVo.getProcessdefinitionid())){
                
                List<Task> taskList = this.nowRunTask(flowUnionVo.getProcessinstanceid(),flowUnionVo.getProcessdefinitionid());
                if(null != taskList && !taskList.isEmpty()){
                    flowUnionVo.setTaskId(taskList.get(0).getId());
                    
                    Task tasknow =taskService.createTaskQuery().taskId(flowUnionVo.getTaskId()).singleResult();
                    BpmnModel bpmnModel = repositoryService.getBpmnModel(tasknow.getProcessDefinitionId());
                    // 获取节点定义id
                    String taskDefinitionKey = tasknow.getTaskDefinitionKey();
                    // 根据节点定义id获取节点元素
                    FlowElement flowElement = bpmnModel.getFlowElement(taskDefinitionKey);
                    if (flowElement instanceof UserTask) {
                        UserTask userTask = (UserTask) flowElement;
                        
                        flowUnionVo.setDocumentation(userTask.getDocumentation());
                    }
                }
                
                
                //查询历史
                List<HistoricTaskInstanceDto> historicTaskInstanceDtos = new ArrayList<>();
                // 查询当前任务的流转信息
                List<HistoricTaskInstance> taskHiInstances = historyService.createHistoricTaskInstanceQuery()
                        .processInstanceId(flowUnionVo.getProcessinstanceid())
                        .includeProcessVariables()
                        .orderByHistoricTaskInstanceStartTime()
                        .asc()
                        .list();
                for (HistoricTaskInstance taskHiInstance : taskHiInstances) {
                    HistoricTaskInstanceDto dto = new HistoricTaskInstanceDto();
                    dto.setTaskId(taskHiInstance.getId());
                    dto.setTaskName(taskHiInstance.getName());
                    dto.setFinishTime(taskHiInstance.getEndTime());
                    if(taskHiInstance.getDurationInMillis() != null){
                        dto.setDuration(taskHiInstance.getDurationInMillis()/1000 + "秒");
                    }
                    dto.setTaskDefKey(taskHiInstance.getTaskDefinitionKey());
                    
                    //Map<String,Object> variables = taskHiInstance.getTaskLocalVariables();
                    
                    Map<String,Object> variables = taskHiInstance.getProcessVariables();
                    
                    if(null != variables && null != variables.get("approvd")){
                        dto.setState(variables.get("approvd").toString());
                    }
                    
                    if(StringUtils.isNotBlank(taskHiInstance.getAssignee())){
                        if(SystemConstantsOa.OA_TASK_SKIP_ASSIGINE.equals(taskHiInstance.getAssignee())){
                            dto.setAssigneeName(taskHiInstance.getAssignee());
                        }else{
                            User user1 = userService.findByLoginname(taskHiInstance.getAssignee());
                            
                            dto.setAssigneeName(user1.getUsername());
                        }
                        
                    }
                    
                    BpmnModel bpmnModel = repositoryService.getBpmnModel(flowUnionVo.getProcessdefinitionid());

//                // 根据节点定义id获取节点元素
                    FlowElement flowElement = bpmnModel.getFlowElement(taskHiInstance.getTaskDefinitionKey());
                    if (flowElement instanceof UserTask) {
                        UserTask userTask = (UserTask) flowElement;
                        
                        flowUnionVo.setDocumentation(userTask.getDocumentation());
                    }
                    // 还需要根据 HistoricTaskInstance 找到对应的 审批意见
                    List<Comment> processInstanceComments = taskService.getProcessInstanceComments(flowUnionVo.getProcessinstanceid());
                    for (Comment comment : processInstanceComments) {
                        
                        if(comment.getTaskId().equals(taskHiInstance.getId())){
                            // 审批意见
                            String fullMessage = comment.getFullMessage();
                            dto.setComment(fullMessage);
                        }
                    }
                    historicTaskInstanceDtos.add(dto);
                }
                flowUnionVo.setTransferRecords(historicTaskInstanceDtos);
            }
        }
        
        return list;
    }
    /**
     * 抄送给我的
     *
     * @return
     */
    public IPage<FlowUnionVo> getMyListCc(Map<String, Object> query, UserToken userToken, ParamterPage paramterPage){
        
        //查询抄送给当前用户的fromid集合
        QueryWrapper queryWrapper = new QueryWrapper();
        queryWrapper.eq("USERID",userToken.getUserid());
        List<Flowablecc> listCc = flowableccMybatisDao.selectList(queryWrapper);
        
        if(null == listCc || listCc.isEmpty()){
            return null;
        }
        
        List<String> listFromid = new ArrayList<>();
        for(Flowablecc flowablecc:listCc){
            listFromid.add(flowablecc.getFormid().toString());
        }
        
        query.put("listFlowCcUserid",listFromid);
        paramterPage.setSortname("CREATEDATE");
        paramterPage.setSortorder("DESC");
        query.put("page",paramterPage);
        
        Long count = flowableccMybatisDao.listMyCcCount(query);
        List<FlowUnionVo> list = flowableccMybatisDao.listMyCc(query);
        
        IPage<FlowUnionVo> flowableccIPage = new Page();
        
        flowableccIPage.setSize(paramterPage.getPagesize());
        flowableccIPage.setTotal(count);
        flowableccIPage.setCurrent(paramterPage.getStart());
        
        for(FlowUnionVo flowUnionVo:list){
            
            //查询对应的流程分类
            Category category = categoryService.selectDtoById(flowUnionVo.getCategoryid());
            flowUnionVo.setCategoryDto(category);
            
            if(StringUtils.isNotBlank(flowUnionVo.getProcessdefinitionid())){
                
                List<Task> taskList = this.nowRunTask(flowUnionVo.getProcessinstanceid(),flowUnionVo.getProcessdefinitionid());
                if(null != taskList && !taskList.isEmpty()){
                    flowUnionVo.setTaskId(taskList.get(0).getId());
                }
                
                
                
                //查询历史
                List<HistoricTaskInstanceDto> historicTaskInstanceDtos = new ArrayList<>();
                // 查询当前任务的流转信息
                List<HistoricTaskInstance> taskHiInstances = historyService.createHistoricTaskInstanceQuery()
                        .processInstanceId(flowUnionVo.getProcessinstanceid())
                        .orderByHistoricTaskInstanceStartTime()
                        .asc()
                        .list();
                for (HistoricTaskInstance taskHiInstance : taskHiInstances) {
                    HistoricTaskInstanceDto dto = new HistoricTaskInstanceDto();
                    dto.setTaskId(taskHiInstance.getId());
                    dto.setTaskName(taskHiInstance.getName());
                    dto.setFinishTime(taskHiInstance.getEndTime());
                    if(taskHiInstance.getDurationInMillis() != null){
                        dto.setDuration(taskHiInstance.getDurationInMillis()/1000 + "秒");
                    }
                    dto.setTaskDefKey(taskHiInstance.getTaskDefinitionKey());
                    if(StringUtils.isNotBlank(taskHiInstance.getAssignee())){
                        if(SystemConstantsOa.OA_TASK_SKIP_ASSIGINE.equals(taskHiInstance.getAssignee())){
                            dto.setAssigneeName(taskHiInstance.getAssignee());
                        }else{
                            User user1 = userService.findByLoginname(taskHiInstance.getAssignee());
                            
                            dto.setAssigneeName(user1.getUsername());
                        }
                        
                    }
                    
                    // 还需要根据 HistoricTaskInstance 找到对应的 审批意见
                    List<Comment> processInstanceComments = taskService.getProcessInstanceComments(flowUnionVo.getProcessinstanceid());
                    for (Comment comment : processInstanceComments) {
                        if(comment.getTaskId().equals(taskHiInstance.getId())){
                            // 审批意见
                            String fullMessage = comment.getFullMessage();
                            dto.setComment(fullMessage);
                        }
                    }
                    historicTaskInstanceDtos.add(dto);
                }
                flowUnionVo.setTransferRecords(historicTaskInstanceDtos);
            }
        }
        
        flowableccIPage.setRecords(list);
        return flowableccIPage;
    }
    public void cancelTask(String taskId, String reason) {
        // 获取当前任务
        Task task = taskService.createTaskQuery().taskId(taskId).singleResult();
        
        ProcessInstance processInstance = runtimeService.createProcessInstanceQuery().processInstanceId(task.getProcessInstanceId()).singleResult();
        if(null == processInstance){
            throw new RuntimeException("流程已经结束，无法撤回。");
        }
        String businessKey = processInstance.getBusinessKey();
        String[] busskey = businessKey.split(SystemConstantsOa.OA_BUSSINESS_KEY_SPLIT);
        Category category = this.categoryService.getById(busskey[1]);
        
        IFormCustomService iFormCustomService = null;
        if(null != category){
            iFormCustomService = SpringUtils.getBean(category.getServicename());
            iFormCustomService.editStatesForm(busskey[1],SystemConstantsOa.OA_STATUS_TYPE_CANCLE,"");
        }
        
        runtimeService.deleteProcessInstance(processInstance.getProcessInstanceId(), SystemMessage.SYS_OA_START_CANCLE);
        historyService.deleteHistoricProcessInstance(processInstance.getProcessInstanceId());
        
        //删除当前业务表的关系
        userapproveService.delete(busskey[1]);
        
    }
    
    public ResultVo removeTask(String fromid,String taskid) {
        // 获取当前任务
        OcrTaskchildPicture ocrTaskchildPicture = this.ocrTaskchildPictureService.selectDtoById(Long.parseLong(fromid));
        
        ProcessInstance processInstance = runtimeService.createProcessInstanceQuery().processInstanceId(ocrTaskchildPicture.getProcessinstanceid()).singleResult();
    

        if(null == processInstance){
            
            //查询项目对象
            Category category = this.categoryService.getById(ocrTaskchildPicture.getCategoryid());
    
            HistoricProcessInstanceQuery query = historyService.createHistoricProcessInstanceQuery().processInstanceId(ocrTaskchildPicture.getProcessinstanceid()).finished();
    
            List<HistoricProcessInstance> terminatedInstances = query.list();
    
            String historyProcessDefinitionId = terminatedInstances.get(0).getProcessDefinitionId();
    
            boolean isStart = iFlowInstanceService.startProcessInstanceById(historyProcessDefinitionId,ocrTaskchildPicture.getCreateusername(),
                    ocrTaskchildPicture.getCreateuser(),ocrTaskchildPicture.getId().toString(),category.getServicename());
    
            if(isStart){
                ResultVoUtil.success();
            }else{
                ResultVoUtil.error();
            }
        }else{
            Task task = taskService.createTaskQuery().taskId(taskid).singleResult();
            taskService.addComment(task.getId(),task.getProcessInstanceId(),"流程重置。");
            
            List<WorkFlowNodeVO> flowNodeVOList = getReturnTaskList(task.getId());
    
            String targetRealActivityId = managementService.executeCommand(new BackTaskCmd(runtimeService, task.getId(), flowNodeVOList.get(0).getNodeId()));
    
    
            //查询项目对象
            Category category = this.categoryService.getById(ocrTaskchildPicture.getCategoryid());
    
            boolean isStart = iFlowInstanceService.startProcessInstanceById(task.getProcessDefinitionId(),ocrTaskchildPicture.getCreateusername(),
                    ocrTaskchildPicture.getCreateuser(),ocrTaskchildPicture.getId().toString(),category.getServicename());
    
            if(isStart){
                ResultVoUtil.success();
            }else{
                ResultVoUtil.error();
            }
            log.info("TaskId:{},流程跳到到：{}", task.getId().toString(), targetRealActivityId);
        }
        
        
        return ResultVoUtil.success();
    }
    
}
