/**
 * Copyright (c) 2016-2019 人人开源 All rights reserved.
 *
 * https://www.renren.io
 *
 * 版权所有，侵权必究！
 */

package cn.jyjz.flowable.utils;

import cn.jyjz.xiaoyao.common.base.exception.ServiceException;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;

/**
 * SQL过滤
 *
 */
public class SQLFilter {

    /**
     * SQL注入过滤
     * @param str  待验证的字符串
     */
    public static String sqlInject(String str){
        if(StringUtils.isBlank(str)){
            return null;
        }
        //去掉'|"|;|\字符

        str = str.replace( "'", "");
        str = str.replace( "\"", "");
        str = str.replace( ";", "");
        str = str.replace( "\\", "");

        //转换成小写
        str = str.toLowerCase();

        //非法字符
        String[] keywords = {"master", "truncate", "insert", "select", "delete", "update", "declare", "alter", "drop"};

        //判断是否包含非法字符
        for(String keyword : keywords){
            if(str.indexOf(keyword) != -1){
                throw new ServiceException("包含非法字符");
            }
        }

        return str;
    }
}
