package cn.jyjz.xiaoyao.oa.from.controller;

import cn.jyjz.xiaoyao.admin.service.UserService;
import cn.jyjz.xiaoyao.common.base.controller.BaseController;
import cn.jyjz.xiaoyao.common.base.param.ParamterPage;
import cn.jyjz.xiaoyao.common.base.service.UserTokenService;
import cn.jyjz.xiaoyao.common.base.util.RequestBaseUtil;
import cn.jyjz.xiaoyao.common.base.util.StringUtils;
import cn.jyjz.xiaoyao.common.base.util.requestFormat.SearchQuery;
import cn.jyjz.xiaoyao.common.base.vo.ResultVo;
import cn.jyjz.xiaoyao.common.base.vo.ResultVoUtil;
import cn.jyjz.xiaoyao.common.base.vo.UserToken;
import cn.jyjz.xiaoyao.common.mybatisplus.util.SearchQueryFormat;

import cn.jyjz.xiaoyao.oa.from.dataobject.Userdistionary;

import cn.jyjz.xiaoyao.oa.from.service.UserdistionaryService;
import cn.jyjz.xiaoyao.oa.from.vo.UserDistionaryVo;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.flowable.ui.common.model.RemoteUser;
import org.flowable.ui.common.service.idm.RemoteIdmService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/backstage/oa/userdistionary")
public class UserdistionaryController extends BaseController{

	private Logger log = LoggerFactory.getLogger(this.getClass());

	@Autowired
	private UserdistionaryService userdistionaryService;
	
	@Autowired
	private RemoteIdmService remoteIdmService;
	
	@Autowired
	private UserTokenService userTokenService;
	@Autowired
	private UserService userService;
	/**
	*方法描述：返回json字符串，接受参数，dto名称以及分页信息
	*创建人：mail.zhangyong@gmail.com
	*创建时间：2023-04-19 14:41:09
	**/
	@GetMapping("/list")
	public ResultVo<IPage<UserDistionaryVo>> listUserdistionary(ParamterPage paramterPage, HttpServletRequest request, HttpServletResponse response) throws IOException{
		SearchQuery searchQuery = this.getParametersStartingWithToSearchJson(request, "search_");

		cn.jyjz.xiaoyao.admin.dataobject.User user = this.userService.getSessionUser(request);
		UserDistionaryVo userdistionary = new UserDistionaryVo();
		userdistionary.setSearchQueryrolesShowleave(user.getSearchQueryrolesShowleave());
		QueryWrapper queryWrapper = SearchQueryFormat.queryStringFormat(searchQuery,userdistionary,"u.");
		
		//用户流程权限表，对应的店面主键
		String userDisId = request.getParameter("userDisId");

		//审批角色
		String userDisRolesid = request.getParameter("userDisRolesid");
		if(StringUtils.isNotBlank(userDisRolesid)){
			//queryWrapper.eq("uo.DEPARTID",userDisRolesid);
		}
		
		Map<String,Object> queryMap = new HashMap<>();
		if(StringUtils.isNotBlank(userDisId)){
			queryMap.put("userDisId",userDisId);//.eq("osud.DEPTID_DIS",userDisId);
			queryWrapper.eq("ut.TENANTID",userDisId);
		}
		
		
		IPage<UserDistionaryVo> page = this.userdistionaryService.selectUserInUd(paramterPage,queryWrapper,queryMap,userDisRolesid);
		return ResultVoUtil.success(page);
	}
	
	/**
	 * 查询不在当前租户下的用户
	 * @param paramterPage
	 * @param request
	 * @param response
	 * @return
	 * @throws IOException
	 */
	@GetMapping("/listnoin")
	public ResultVo listnoin(ParamterPage paramterPage, HttpServletRequest request, HttpServletResponse response) throws IOException{
		SearchQuery searchQuery = this.getParametersStartingWithToSearchJson(request, "search_");

		
		cn.jyjz.xiaoyao.admin.dataobject.User user = this.userService.getSessionUser(request);
		UserDistionaryVo userdistionary = new UserDistionaryVo();
		userdistionary.setSearchQueryrolesShowleave(user.getSearchQueryrolesShowleave());
		QueryWrapper<Userdistionary> queryWrapper = SearchQueryFormat.queryStringFormat(searchQuery,userdistionary,"u.");
		
		//用户流程权限表，对应的店面主键
		String userDisId = request.getParameter("userDisId");
		//用户所在部门主键
		String parentid  = request.getParameter("parentid");
		if(StringUtils.isNotBlank(parentid)){
			queryWrapper.eq("uo.DEPARTID",parentid);
		}
		Map<String,Object> queryMap = new HashMap<>();
		if(StringUtils.isNotBlank(userDisId)){
			queryMap.put("userDisId",userDisId);//.eq("osud.DEPTID_DIS",userDisId);
			queryWrapper.eq("ut.TENANTID",userDisId);
		}
		
		IPage<UserDistionaryVo> page = this.userdistionaryService.selectUserNoUd(paramterPage,queryWrapper,queryMap);;
		return ResultVoUtil.success(page);
	}
	/**
	*方法描述：保存添加数据
	*创建人：mail.zhangyong@gmail.com
	*创建时间：2023-04-19 14:41:09
	**/
	@PostMapping("/save")
	public ResultVo saveUserdistionary(HttpServletResponse response,HttpServletRequest request,Userdistionary tab) throws IOException{
		UserToken userToken = this.userTokenService.getUserToken(RequestBaseUtil.getToken(request));
		
		String userDisId = request.getParameter("userDisId");
		//获取用户集合，以英文逗号分隔
		String userlist = request.getParameter("userlist");
		String deptlist = request.getParameter("deptlist");
		
		tab.setDeptidDis(Long.parseLong(userDisId));

		this.userdistionaryService.saveUserdistionary(tab,userlist,deptlist);
		return ResultVoUtil.success();
	}
	
	/**
	 *方法描述：保存添加数据
	 *创建人：mail.zhangyong@gmail.com
	 *创建时间：2023-04-19 14:41:09
	 **/
	@PostMapping("/saveupdate")
	public ResultVo saveupdate(HttpServletResponse response,HttpServletRequest request) throws IOException{
		UserToken userToken = this.userTokenService.getUserToken(RequestBaseUtil.getToken(request));
		
		//审批人员关系主键
		String fromUserDisId = request.getParameter("fromUserDisId");
		//审批角色主键，以英文逗号分隔
		String fromUserDisRolesid = request.getParameter("fromUserDisRolesid");
		//用户类型
		String fromUserTyped = request.getParameter("fromUserTyped");
		
		this.userdistionaryService.saveUserdistionary(fromUserDisRolesid,fromUserDisId,fromUserTyped);
		return ResultVoUtil.success();
	}
	
	/**
	 *方法描述：添加分管部门，保存添加数据
	 *创建人：mail.zhangyong@gmail.com
	 *创建时间：2023-04-19 14:41:09
	 **/
	@PostMapping("/saveupdatechange")
	public ResultVo saveupdatechange(HttpServletResponse response,HttpServletRequest request) throws IOException{
		UserToken userToken = this.userTokenService.getUserToken(RequestBaseUtil.getToken(request));
		//当前关联角色主键，多个使用英文逗号分隔
		String[] candidateid = request.getParameterValues("userCandRolesid");
		//当前设置用户姓名
		String userid = request.getParameter("userid");
		//用户类型，后勤、前端
		String usertype = request.getParameter("usertype");

		//店面主键,多个使用英文逗号分隔
		String[] selectDis = request.getParameterValues("selectDis");
		//部门主键,多个使用英文逗号分隔
		String[] selectDept = request.getParameterValues("selectDept");
		
		this.userdistionaryService.saveUserdistionary(candidateid,userid,usertype,selectDis,selectDept);
		return ResultVoUtil.success();
	}
	/**
	 *方法描述：查询当前用户已经关联的店面和机构信息
	 *创建人：mail.zhangyong@gmail.com
	 *创建时间：2023-04-19 14:41:09
	 **/
	@GetMapping("/getdatabyuser/{userid}")
	public ResultVo getdatabyuser(HttpServletResponse response,HttpServletRequest request,@PathVariable("userid") Long userid) throws IOException{
		Map<String,List<Userdistionary>> list = this.userdistionaryService.selectListByUserid(userid.toString());
		if(null != list){
			return ResultVoUtil.success(list);
		}else{
			return ResultVoUtil.error();
		}
	}
	
	/**
	*方法描述：通过主键获得对象信息
	*创建人：mail.zhangyong@gmail.com
	*创建时间：2023-04-19 14:41:09
	**/
	@GetMapping("/getdata/{id}")
	public ResultVo getdateUserdistionary(HttpServletResponse response,HttpServletRequest request,@PathVariable("id") Long id) throws IOException{
		Userdistionary dto = this.userdistionaryService.selectDtoById(id);
		if(null != dto){
			return ResultVoUtil.success(dto);
		}else{
			return ResultVoUtil.error();
		}
	}

	/**
	*方法描述：根据id字符串组删除对象方法，例如1,2,3
	*创建人：mail.zhangyong@gmail.com
	*创建时间：2023-04-19 14:41:09
	**/
	@GetMapping("/delmore")
	@ResponseBody
	public ResultVo delMoreUserdistionary(HttpServletResponse response,HttpServletRequest request) throws IOException{
		String ids = request.getParameter("id");
		this.userdistionaryService.deleteByIdMore(ids);
		return ResultVoUtil.success();
	}
	
	/**
	 * 查询已经抄送的信息
	 * @return
	 */
//	@GetMapping("/selectusercc")
//	@ResponseBody
//	public ResultVo selectUserByFromid(HttpServletRequest request){
//		String fromid = request.getParameter("fromid");
//		List<UserDistionaryVo> userDistionaryVoList = flowableccService.selectUserByFromid(fromid);
//		return ResultVoUtil.success(userDistionaryVoList);
//
//
//	}
	/**
	 * 保存抄送信息
	 * @return
	 */
//	@GetMapping("/saveusercc")
//	@ResponseBody
//	public ResultVo saveFlowableCc(Flowablecc flowablecc,HttpServletRequest request){
//		String userids = request.getParameter("userids");
//
//		return flowableccService.saveUserCc(flowablecc.getFormid(),userids)?ResultVoUtil.success():ResultVoUtil.error();
//	}
	/**
	 * 查询可以抄送的人员
	 * @return
	 */
	@GetMapping("/finduser")
	@ResponseBody
	public ResultVo finduser(HttpServletRequest request){
		String filter = request.getParameter("filter");
		List<RemoteUser> remoteUserList = remoteIdmService.findUsersByNameFilter(filter);
		return ResultVoUtil.success(remoteUserList);
	}
}
