package cn.jyjz.xiaoyao.oa.from.dataDao;

import cn.jyjz.xiaoyao.admin.dataobject.User;
import cn.jyjz.xiaoyao.oa.from.dataobject.Userdistionary;
import cn.jyjz.xiaoyao.oa.from.vo.UserDistionaryVo;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
* 数据持久化
*/
@Mapper
public interface UserdistionaryMybatisDao extends BaseMapper<Userdistionary> {
    
    /**
     * 通过登录账号，查询审批权限关系表
     * @param loginname 登录账号
     * @return
     */
    List<Userdistionary> selectListByLoginname(String loginname);
    
    /**
     * 查询可以审批的人员
     * @param candidateid
     * @param deptid
     * @return
     */
    List<Userdistionary> selectListByCandidateidAndDeptid(@Param("candidateid")String candidateid,@Param("deptid")String deptid);
    /**
     * 通过
     * @param candidateid
     * @return
     */
    List<Userdistionary> selectListByCandidateid(@Param("candidateid")String candidateid,@Param("loginname")String loginname);
    /**
     * 查询不在当前关联表中的用户
     * @param page
     * @param query
     * @return
     */
    IPage<UserDistionaryVo> selectUserNoUd(Page<UserDistionaryVo> page, @Param(Constants.WRAPPER) QueryWrapper<UserDistionaryVo> query, @Param("querymap")Map<String,Object> queryMap);
    
    /**
     * 查询在当前关联表中的用户
     * @param page
     * @param query
     * @return
     */
    IPage<UserDistionaryVo> selectUserInUd(Page<UserDistionaryVo> page, @Param(Constants.WRAPPER) QueryWrapper<UserDistionaryVo> query, @Param("querymap")Map<String,Object> queryMap);

}
