package cn.jyjz.xiaoyao.oa.from.dataobject;

import cn.jyjz.xiaoyao.admin.dataobject.Tenant;
import cn.jyjz.xiaoyao.common.mybatisplus.dto.BaseDto;
import cn.jyjz.xiaoyao.common.base.util.requestFormat.SearchQuery;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import java.util.Map;
import java.util.AbstractMap.SimpleEntry;
import java.util.stream.Stream;
import java.util.stream.Collectors;
 
 

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Schema(name = "流程类型", title = "流程类型")
@TableName(value = "OA_CATEGORY_T")
public class Category implements BaseDto,java.io.Serializable {
	
	private static final long serialVersionUID = 3650775877135330041L;
	@Schema(description = "流水号")
	@TableId(value = "id",type = IdType.ASSIGN_ID)
	@JsonSerialize(using = ToStringSerializer.class)
	@TableField(value="ID")
	private Long id;
	
	@Schema(description = "项目名称")
	@TableField(value="CATEGORYNAME")
	private String categoryname;
	
	@Schema(description = "项目编码")
	@TableField(value="CATEGORY")
	private String category;
	
	@Schema(description = "对应的Service名，主要是spring的service名")
	@TableField(value="SERVICENAME")
	private String servicename;
	
	@Schema(description = "内置表单，使用flowable表单，0：使用本地数据，1：使用flowable表单，3:外置表单，4：其他自定义表单")
	@TableField(value="BUILTFORM")
	private Integer builtform;
	
	@Schema(description = "表单地址，用户展示用户表单使用")
	@TableField(value="FORMURL")
	private String formurl;
	
	@Schema(description = "表单详情")
	@TableField(value="FORMDETAIL")
	private String formdetail;
	
	@Schema(description = "是否启用，0：禁用，1：启用")
	@TableField(value="HAVEUSE")
	private Integer haveuse;
	
	@Schema(description = "表单分类")
	@TableField(value="FORMTYPE")
	private String formtype;
	
	@Schema(description = "流程定义id")
	@TableField(value="PROCESSDEFINITIONID")
	private String processdefinitionid;
	
	@Schema(description = "排序")
	@TableField(value="FORMNO")
	private Integer formno;
	
	@Schema(description = "创建人，记录创建人的帐号")
	@TableField(value="CREATEUSER")
	private String createuser;
	
	@Schema(description = "创建时间")
	@TableField(value="CREATEDATE")
	private Long createdate;
	
	@Schema(description = "修改人，记录创建人的帐号")
	@TableField(value="UPDATEUSER")
	private String updateuser;
	
	@Schema(description = "更新时间")
	@TableField(value="UPDATETIME")
	private Long updatetime;
	
	@Schema(description = "隶属机构")
	@TableField(value="DEPTID")
	private Long deptid;
	
	@Schema(description = "租户主键")
	@TableField(value="TENANTID")
	private Long tenantid;
	
	//租户对象
	@TableField(exist = false)
	private Tenant tenant;
	
	//业务表主键
	@Schema(description = "业务表主键")
	@TableField(exist = false)
	private String formid;
	
	//节点描述信息，用于判断是否存在多个下级界面
	@TableField(exist = false)
	String documentation;
	
	@Schema(description = "状态，审批状态 1:未提交 2:审批中 3:审批通过 ")
	@TableField(exist = false)
	private Integer states;
	
	//保存当前登录用户的数据权限范围的搜索条件
	@TableField(exist = false)
	@JsonIgnore
	private SearchQuery searchQueryrolesShowleave;

	@TableField(exist = false)
	@JsonIgnore
	private final Map<String,String> query = Stream.of(
		new SimpleEntry<>("listdept","deptid"),
		new SimpleEntry<>("ID","id"),
		new SimpleEntry<>("CATEGORYNAME","categoryname"),
		new SimpleEntry<>("CATEGORY","category"),
		new SimpleEntry<>("SERVICENAME","servicename"),
		new SimpleEntry<>("BUILTFORM","builtform"),
		new SimpleEntry<>("FORMURL","formurl"),
		new SimpleEntry<>("HAVEUSE","haveuse"),
		new SimpleEntry<>("FORMTYPE","formtype"),
		new SimpleEntry<>("PROCESSDEFINITIONID","processdefinitionid"),
		new SimpleEntry<>("FORMNO","formno"),
		new SimpleEntry<>("CREATEUSER","createuser"),
		new SimpleEntry<>("CREATEDATE","createdate"),
		new SimpleEntry<>("UPDATEUSER","updateuser"),
		new SimpleEntry<>("UPDATETIME","updatetime"),
		new SimpleEntry<>("TENANTID","tenantid")
	)
	.collect(Collectors.toMap(SimpleEntry::getKey, SimpleEntry::getValue));
	@Override
	public String getQueryFiled(String filedname){
		String obj = null;
		if(null != query && query.size() > 0){
		obj = query.get(filedname);
		}
		return obj;
	}
}
