package cn.jyjz.xiaoyao.oa.from.dataobject;

import cn.jyjz.xiaoyao.common.base.util.requestFormat.SearchQuery;
import cn.jyjz.xiaoyao.common.mybatisplus.dto.BaseDto;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.AbstractMap.SimpleEntry;
import java.util.Map;
import java.util.stream.Collectors;
import java.util.stream.Stream;


@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Schema(name = "审批抄送", title = "审批抄送")
@TableName(value = "OA_FLOWABLECC_T")
public class Flowablecc implements BaseDto,java.io.Serializable {

	private static final long serialVersionUID = 12807657L;
	@Schema(description = "流水号")
	@TableId(value = "id",type = IdType.ASSIGN_ID)
	@JsonSerialize(using = ToStringSerializer.class)
	@TableField(value="ID")
	private Long id;

	@Schema(description = "接收抄送信息的用户主键")
	@TableField(value="USERID")
	private Long userid;

	@Schema(description = "业务表主键，对应的请假、转正等业务表id")
	@TableField(value="FORMID")
	private Long formid;

	@Schema(description = "是否查看，0：未查看，1：查看")
	@TableField(value="HAVEREAD")
	private Integer haveread;


	//保存当前登录用户的数据权限范围的搜索条件
	@TableField(exist = false)
	private SearchQuery searchQueryrolesShowleave;

	@TableField(exist = false)
	private final Map<String,String> query = Stream.of(
		new SimpleEntry<>("listdept","deptid"),
		new SimpleEntry<>("ID","id"),
		new SimpleEntry<>("USERID","userid"),
		new SimpleEntry<>("FORMID","formid"),
		new SimpleEntry<>("HAVEREAD","haveread")
	)
	.collect(Collectors.toMap(SimpleEntry::getKey, SimpleEntry::getValue));
	@Override
	public String getQueryFiled(String filedname){
		String obj = null;
		if(null != query && query.size() > 0){
		obj = query.get(filedname);
		}
		return obj;
	}
}
