package cn.jyjz.xiaoyao.oa.from.dataobject;

import cn.jyjz.xiaoyao.common.mybatisplus.dto.BaseDto;
import cn.jyjz.xiaoyao.common.base.util.requestFormat.SearchQuery;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import java.util.Map;
import java.util.AbstractMap.SimpleEntry;
import java.util.stream.Stream;
import java.util.stream.Collectors;
 
 

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Schema(name = "用户未查看记录", title = "用户未查看记录")
@TableName(value = "OA_USERVIEWAPPROE_T")
public class UserViewapproe implements BaseDto,java.io.Serializable {

	private static final long serialVersionUID = -135113380405218360L;
	@Schema(description = "流水号")
	@TableId(value = "id",type = IdType.ASSIGN_ID)
	@JsonSerialize(using = ToStringSerializer.class)
	@TableField(value="ID")
	private Long id;

	@Schema(description = "审批用户主键，记录审批人的主键")
	@TableField(value="USERID")
	private Long userid;

	@Schema(description = "表单主键，业务表主键")
	@TableField(value="FORMID")
	private Long formid;
	
	@Schema(description = "租户主键")
	@TableField(value="TENANTID")
	private Long tenantid;

	//保存当前登录用户的数据权限范围的搜索条件
	@TableField(exist = false)
	@JsonIgnore
	private SearchQuery searchQueryrolesShowleave;

	@TableField(exist = false)
	@JsonIgnore
	private final Map<String,String> query = Stream.of(
		new SimpleEntry<>("ID","id"),
		new SimpleEntry<>("USERID","userid"),
		new SimpleEntry<>("FORMID","formid"),
		new SimpleEntry<>("TENANTID","tenantid")
	)
	.collect(Collectors.toMap(SimpleEntry::getKey, SimpleEntry::getValue));
	@Override
	public String getQueryFiled(String filedname){
		String obj = null;
		if(null != query && query.size() > 0){
		obj = query.get(filedname);
		}
		return obj;
	}
}
