package cn.jyjz.xiaoyao.oa.from.dataobject;

import cn.jyjz.xiaoyao.common.base.util.requestFormat.SearchQuery;
import cn.jyjz.xiaoyao.common.mybatisplus.dto.BaseDto;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.AbstractMap.SimpleEntry;
import java.util.Map;
import java.util.stream.Collectors;
import java.util.stream.Stream;


@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Schema(name = "人员归属关系", title = "人员归属关系")
@TableName(value = "OA_USERDISTIONARY_T")
public class Userdistionary implements BaseDto,java.io.Serializable {

	private static final long serialVersionUID = -6059710482718906353L;
	@Schema(description = "流水号")
	@TableId(value = "id",type = IdType.ASSIGN_ID)
	@JsonSerialize(using = ToStringSerializer.class)
	@TableField(value="ID")
	private Long id;

	@Schema(description = "数据字典店面主键")
	@TableField(value="DEPTID_DIS")
	@JsonSerialize(using = ToStringSerializer.class)
	private Long deptidDis;

	@Schema(description = "系统部门主键")
	@TableField(value="DEPTID")
	@JsonSerialize(using = ToStringSerializer.class)
	private Long deptid;

	@Schema(description = "用户ID")
	@TableField(value="USERID")
	@JsonSerialize(using = ToStringSerializer.class)
	private Long userid;
	
	@Schema(description = "审批流节点是否跳过标志，默认为0，前端人员，1：后勤人员0：审批流所有节点，1：跳过店长审批")
	@TableField(value="USERTYPE")
	private Integer usertype;
	//保存当前登录用户的数据权限范围的搜索条件
	@TableField(exist = false)
	@JsonIgnore
	private SearchQuery searchQueryrolesShowleave;

	@TableField(exist = false)
	@JsonIgnore
	private final Map<String,String> query = Stream.of(
		new SimpleEntry<>("listdept","deptid"),
		new SimpleEntry<>("ID","id"),
		new SimpleEntry<>("DEPTID_DIS","deptidDis"),
		new SimpleEntry<>("DEPTID","deptid"),
		new SimpleEntry<>("USERID","userid"),
		new SimpleEntry<>("USERTYPE","usertype")
	)
	.collect(Collectors.toMap(SimpleEntry::getKey, SimpleEntry::getValue));
	@Override
	public String getQueryFiled(String filedname){
		String obj = null;
		if(null != query && query.size() > 0){
		obj = query.get(filedname);
		}
		return obj;
	}
}
