package cn.jyjz.xiaoyao.oa.from.service;

import java.util.List;
import java.util.Map;

import cn.jyjz.xiaoyao.common.mybatisplus.base.BaseService;
import cn.jyjz.xiaoyao.oa.from.dataobject.Candidate;

/**
* 业务层
*/
public interface CandidateService extends BaseService<Candidate>  {
    
    /**
     * 查询所有审批类型
     * @return 返回list集合
     */
    public List<Candidate> listCandiate();
    
    /**
     * 根据用户查询对应的审批角色
     * @return 返回list集合
     */
    public List<Candidate> listCandiateByUserid(Long userid);
    
    /**
     * 根据审批角色名称查询
     * @return 返回list集合
     */
    public List<Candidate> listCandiateByKey(String key);
    
    /**
     * 查询所有审批类型
     * @return  返回map集合
     */
    public Map<Long,Candidate> mapCandiate();
    
    /**
     * 清理分类缓存
     */
    public void clearCache();
}
