package cn.jyjz.xiaoyao.oa.from.service;

import java.util.List;

import cn.jyjz.xiaoyao.admin.dataobject.Distionary;
import cn.jyjz.xiaoyao.common.mybatisplus.base.BaseService;
import cn.jyjz.xiaoyao.oa.from.dataobject.Candidateuser;

/**
* 业务层
*/
public interface CandidateuserService extends BaseService<Candidateuser>  {
    
    /**
     * 查询用户的关系对象
     * @param candidateid 用户组主键
     * @param userdisid 用户审批关系主键
     * @return
     */
    public List<Candidateuser> selectList(String candidateid,Long userdisid );
    
    /**
     * 查询用户的关系对象
     * @param loginname 登录账号
     * @return
     */
    public List<Distionary> selectList(String loginname);
    
    /**
     * 根据用户关系，删除候选组关系
     * @param userdisid 用户审批关系主键
     * @return
     */
    public boolean deleteByUserdisid(Long userdisid );
    
    /**
     * 返回可以流程的审批人员，返回登录账号
     * @param deptid 审批部门主键
     * @param candidateid 候选组主键
     * @return 返回登录账号
     */
    public String getClaimUserByDeptid(String deptid,String candidateid);
    /**
     * 返回可以流程的审批人员，返回登录账号
     * @param startUserId 流程发起人
     * @param candidateid 候选组主键
     * @return
     */
    public String getClaimUser(String startUserId,String candidateid);
}
