package cn.jyjz.xiaoyao.oa.from.service;

import cn.jyjz.xiaoyao.common.base.param.ParamterPage;
import cn.jyjz.xiaoyao.common.mybatisplus.base.BaseService;
import cn.jyjz.xiaoyao.oa.from.dataobject.Userdistionary;
import cn.jyjz.xiaoyao.oa.from.vo.UserDistionaryVo;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;

import java.util.List;
import java.util.Map;

/**
* 业务层
*/
public interface UserdistionaryService extends BaseService<Userdistionary>  {
    
    /**
     * 保存用户
     * @param userdistionary 用户分组对象
     * @param userList 用户主键,可能是多个，使用应为逗号分隔
     * @return
     */
    public boolean saveUserdistionary(Userdistionary userdistionary,String userList,String deptlist);
    
    /**
     * 通过登录账号，查询审批权限关系表
     * @param loginname 登录账号
     * @return
     */
    List<Userdistionary> selectListByLoginname(String loginname);
    
    /**
     * 通过登录账号，查询审批权限关系表
     * @param userid 登录账号主键
     * @return
     */
    Map<String,List<Userdistionary>> selectListByUserid(String userid);
    
    /**
     * 查询审批人信息
     * @param candidateid
     * @param deptid
     * @return
     */
    public List<Userdistionary> selectListByCandidateidAndDeptid(String candidateid,String deptid);
    /**
     * 查询审批人信息
     * @param candidateid
     * @return
     */
    List<Userdistionary> selectListByCandidateid(String candidateid,String loginname);
    
    /**
     * 设置用户审批权限
     * @param candidateid 权限组主键,可能是多个，使用应为逗号分隔
     * @param userdisid 用户关系分组
     * @return
     */
    public boolean saveUserdistionary(String candidateid,String userdisid);
    
    /**
     * 设置用户审批权限
     * @param candidateid 权限组主键,可能是多个，使用应为逗号分隔
     * @param userdisid 用户关系分组
     * @return
     */
    public boolean saveUserdistionary(String candidateid,String userdisid,String usertype);
    

    /**
     * 设置用户审批权限
     * @param candidateid 当前关联角色主键，多个使用英文逗号分隔
     * @param userid 设置用户主键
     * @param usertype 用户类型，后勤、前端
     * @param selectDis 店面主键,多个使用英文逗号分隔
     * @param selectDept 部门主键,多个使用英文逗号分隔
     * @return
     */
    public boolean saveUserdistionary(String[] candidateid,String userid,String usertype,String[] selectDis,String[] selectDept);
    
    /**
     * 查询不在当前关联表中的用户
     * @param paramterPage
     * @param query
     * @return
     */
    IPage<UserDistionaryVo> selectUserNoUd(ParamterPage paramterPage, QueryWrapper query, Map<String,Object> queryMap);
    
    /**
     * 查询在当前关联表中的用户
     * @param paramterPage
     * @param query
     * @return
     */
    IPage<UserDistionaryVo> selectUserInUd(ParamterPage paramterPage,QueryWrapper query,Map<String,Object> queryMap,String userDisRolesid);
    
    /**
     * 根据id字符串组对象，例如1,2,3
     *
     * @param id 要删除的ID，不能为null
     * @return int 受影响结果数
     * 2015年3月3日下午5:59:59
     */
    public int deleteByIdMore(String id);
    
}
