package cn.jyjz.xiaoyao.oa.from.service.impl;

import cn.jyjz.xiaoyao.oa.from.dataDao.CategoryMybatisDao;
import cn.jyjz.xiaoyao.oa.from.dataobject.Category;
import cn.jyjz.xiaoyao.oa.from.service.CategoryService;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import cn.jyjz.xiaoyao.common.mybatisplus.base.BaseServiceImpl;
import lombok.extern.slf4j.Slf4j;
import java.util.List;
/**
* 业务层实现
*/
@Service
@Slf4j
public class CategoryServiceImpl extends BaseServiceImpl<CategoryMybatisDao, Category>  implements CategoryService {
	@Autowired
	private CategoryMybatisDao categorymybatisdao;
	
	public Category  getCategory(String category){
		
		QueryWrapper queryWrapper = new QueryWrapper();
		queryWrapper.eq("CATEGORY",category);
		
		List<Category> categoryList = this.list(queryWrapper);
		if(null != categoryList && categoryList.size() > 0){
			return categoryList.get(0);
		}
		return null;
	}
	/**
	 * 查询流程定义id不为空的数据
	 * @return
	 */
	public Category getCategoryNotNull(){
		QueryWrapper queryWrapper = new QueryWrapper();
		queryWrapper.isNotNull("PROCESSDEFINITIONID");
		queryWrapper.ne("PROCESSDEFINITIONID","");
		
		List<Category> categoryList = this.list(queryWrapper);
		if(null != categoryList && categoryList.size() > 0){
			return categoryList.get(0);
		}
		return null;
	}
	public List<Category>  getCategoryList(String category){
		
		QueryWrapper queryWrapper = new QueryWrapper();
		queryWrapper.eq("CATEGORY",category);
		
		List<Category> categoryList = this.list(queryWrapper);
		return categoryList;
	}
}
