package cn.jyjz.xiaoyao.oa.from.service.impl;

import cn.jyjz.xiaoyao.admin.service.UserService;
import cn.jyjz.xiaoyao.common.mybatisplus.base.BaseServiceImpl;
import cn.jyjz.xiaoyao.oa.from.dataDao.FlowableccMybatisDao;
import cn.jyjz.xiaoyao.oa.from.dataobject.Flowablecc;
import cn.jyjz.xiaoyao.oa.from.service.FlowableccService;
import cn.jyjz.xiaoyao.oa.from.vo.UserDistionaryVo;
import com.alanpoi.common.util.StringUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

/**
* 业务层实现
*/
@Service
@Slf4j
public class FlowableccServiceImpl extends BaseServiceImpl<FlowableccMybatisDao, Flowablecc>  implements FlowableccService {
	@Resource
	private FlowableccMybatisDao flowableccmybatisdao;
	
	@Resource
	private UserService userService;
	
	/**
	 * 根据业务主键id，查询已经抄送的人员信息结婚
	 * @param fromid
	 * @return
	 */
	public List<UserDistionaryVo> selectUserByFromid(String fromid){
		if(StringUtils.isNotBlank(fromid)){
			return this.flowableccmybatisdao.selectUserByFromid(fromid);
		}
		
		return null;
	}
	
	/**
	 * 保存抄送信息
	 * @param fromid
	 * @param userids
	 * @return
	 */
	public boolean saveUserCc(Long fromid,String userids){
		if(StringUtils.isNotBlank(userids) && null != fromid){
			String[] userid = userids.split(",");
			
			List<Flowablecc> list = new ArrayList<>();
			for(String ui:userid){
				Flowablecc flowablecc = new Flowablecc();
				flowablecc.setUserid(Long.parseLong(ui));
				flowablecc.setFormid(fromid);
				list.add(flowablecc);
			}
			return this.saveBatch(list);
		}
		return false;
	}
	
	/**
	 * 保存抄送信息
	 * @param fromid
	 * @param listLoginame 登录账号
	 * @return
	 */
	public boolean saveUserCc(Long fromid,List<String> listLoginame){
		
		List<String> userids = userService.selectLoginNameByLoginNameToId(listLoginame);
		
		return saveUserCc( fromid,userids.stream().collect(Collectors.joining(",")));
	}
}
