package cn.jyjz.xiaoyao.oa.from.service.impl;

import cn.jyjz.xiaoyao.admin.dataobject.User;
import cn.jyjz.xiaoyao.admin.service.UserService;
import cn.jyjz.xiaoyao.oa.from.dataDao.UserViewapproeMybatisDao;
import cn.jyjz.xiaoyao.oa.from.dataobject.UserViewapproe;
import cn.jyjz.xiaoyao.oa.from.service.UserViewapproeService;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import cn.jyjz.xiaoyao.common.mybatisplus.base.BaseServiceImpl;
import lombok.extern.slf4j.Slf4j;

import javax.annotation.Resource;
import java.util.List;
/**
* 业务层实现
*/
@Service
@Slf4j
public class UserViewapproeServiceImpl extends BaseServiceImpl<UserViewapproeMybatisDao, UserViewapproe>  implements UserViewapproeService {
	@Resource
	private UserViewapproeMybatisDao userViewapproeMybatisDao;
	@Resource
	private UserService userService;
	/**
	 * 保存用户需要提醒的审批信息主键
	 * @param loginname 登录账号
	 * @param fromid 审批表单主键
	 * @return
	 */
	public boolean saveUserViewApproe(String loginname,String fromid){
		
		User user = userService.findByLoginname(loginname);
		if(null != user){
			UserViewapproe userViewApproe = new UserViewapproe();
			userViewApproe.setFormid(Long.parseLong(fromid));
			userViewApproe.setUserid(user.getId());
			
			return (this.userViewapproeMybatisDao.insert(userViewApproe) > 0)?true:false;
		}
		return false;
	}
	
	/**
	 * 保存用户需要提醒的审批信息主键
	 * @param loginname 登录账号
	 * @param fromid 审批表单主键
	 * @return
	 */
	public boolean saveUserViewApproe(String loginname,String fromid,String tenantid){
		User user = userService.findByLoginname(loginname);
		if(null != user){
			UserViewapproe userViewApproe = new UserViewapproe();
			userViewApproe.setFormid(Long.parseLong(fromid));
			userViewApproe.setUserid(user.getId());
			userViewApproe.setTenantid(Long.parseLong(tenantid));
			return (this.userViewapproeMybatisDao.insert(userViewApproe) > 0)?true:false;
		}
		return false;
	}
	
	/**
	 * 根据流程主键，移除未读提醒
	 * @param fromid
	 * @return
	 */
	public boolean removeByFromid(String fromid){
		if(this.haveByFromid(fromid)){
			QueryWrapper queryWrapper = new QueryWrapper();
			queryWrapper.eq("FORMID",fromid);
			return (this.userViewapproeMybatisDao.delete(queryWrapper) > 0)?true:false;
		}
		
		return false;
	}
	
	/**
	 * 根据流程主键，判断是否存在未读的待审批信息
	 * @param fromid
	 * @return 存在返回true，否则返回false
	 */
	public boolean haveByFromid(String fromid){
		QueryWrapper queryWrapper = new QueryWrapper();
		queryWrapper.eq("FORMID",fromid);
		
		return (this.userViewapproeMybatisDao.selectCount(queryWrapper).intValue() > 0)?true:false;
	}
}
