package cn.jyjz.xiaoyao.oa.from.service.impl;

import cn.jyjz.xiaoyao.common.base.param.ParamterPage;
import cn.jyjz.xiaoyao.common.base.util.StringUtils;
import cn.jyjz.xiaoyao.common.mybatisplus.base.BaseServiceImpl;
import cn.jyjz.xiaoyao.oa.from.dataDao.UserdistionaryMybatisDao;
import cn.jyjz.xiaoyao.oa.from.dataobject.Candidateuser;
import cn.jyjz.xiaoyao.oa.from.dataobject.Userdistionary;
import cn.jyjz.xiaoyao.oa.from.service.CandidateuserService;
import cn.jyjz.xiaoyao.oa.from.service.UserdistionaryService;
import cn.jyjz.xiaoyao.oa.from.vo.UserDistionaryVo;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
* 业务层实现
*/
@Service
@Slf4j
public class UserdistionaryServiceImpl extends BaseServiceImpl<UserdistionaryMybatisDao, Userdistionary>  implements UserdistionaryService {
	@Autowired
	private UserdistionaryMybatisDao userdistionarymybatisdao;
    @Autowired
	private CandidateuserService candidateuserService;
 
	/**
	 * 保存用户
	 * @param userdistionary 用户分组对象
	 * @param userList 用户主键,可能是多个，使用应为逗号分隔
	 * @return
	 */
    @Override
	public boolean saveUserdistionary(Userdistionary userdistionary,String userList,String deptlist){
        
        if(StringUtils.isNotBlank(userList)){
            String[] ul = userList.split(",");
            String[] dl = deptlist.split(",");
            List<Userdistionary> list = new ArrayList<>();
            for(int i = 0;i < ul.length;i++){

                Userdistionary userdistionary1 = new Userdistionary();
                userdistionary1.setUsertype(userdistionary.getUsertype());
                userdistionary1.setUserid(Long.parseLong(ul[i]));
                if(null != dl[i]){
                    //userid_deptid
                    String[] tempDl = dl[i].split("_");
                    userdistionary1.setDeptid(Long.parseLong(tempDl[1]));
                }
                
                userdistionary1.setDeptidDis(userdistionary.getDeptidDis());
                list.add(userdistionary1);
            }
            return this.saveBatch(list);
        }
        return false;
    }
	
	/**
	 * 设置用户审批权限
	 * @param candidateid 权限组主键,可能是多个，使用应为逗号分隔
	 * @param userdisid 用户关系分组
	 * @return
	 */
    @Override
	public boolean saveUserdistionary(String candidateid,String userdisid){
        if(StringUtils.isNotBlank(userdisid)){
            //删除对应的关系
            candidateuserService.deleteByUserdisid(Long.parseLong(userdisid));
    
            if(StringUtils.isNotBlank(candidateid)){
                String[] ul = candidateid.split(",");
                List<Candidateuser> list = new ArrayList<>();
                for(String cauid:ul){
            
                    Candidateuser candidateuser = new Candidateuser();
                    candidateuser.setCandidateid(Long.parseLong(cauid));
                    candidateuser.setUserdisid(Long.parseLong(userdisid));
                    list.add(candidateuser);
                }
                return this.candidateuserService.saveBatch(list);
            }
        }

        return false;
    }
    
    /**
     * 设置用户审批权限
     * @param candidateid 权限组主键,可能是多个，使用应为逗号分隔
     * @param userdisid 用户关系分组
     * @return
     */
    @Override
    public boolean saveUserdistionary(String candidateid,String userdisid,String usertype){

        if(StringUtils.isNotBlank(userdisid)){
            //删除对应的关系
            candidateuserService.deleteByUserdisid(Long.parseLong(userdisid));
            
            if(StringUtils.isNotBlank(candidateid)){
                String[] ul = candidateid.split(",");
                List<Candidateuser> list = new ArrayList<>();
                for(String cauid:ul){
                    
                    Candidateuser candidateuser = new Candidateuser();
                    candidateuser.setCandidateid(Long.parseLong(cauid));
                    candidateuser.setUserdisid(Long.parseLong(userdisid));
                    list.add(candidateuser);
                }

                this.candidateuserService.saveBatch(list);
            }
        }
        Userdistionary userdistionary = this.selectDtoById(Long.parseLong(userdisid));
        userdistionary.setUsertype(Integer.parseInt(usertype));
        return this.updateById(userdistionary);

    }
    
    /**
     * 设置用户审批权限
     * @param candidateid 当前关联角色主键，多个使用英文逗号分隔
     * @param userid 设置用户主键
     * @param usertype 用户类型，后勤、前端
     * @param selectDis 店面主键,多个使用英文逗号分隔
     * @param selectDept 部门主键,多个使用英文逗号分隔
     * @return
     */
    public boolean saveUserdistionary(String[] candidateid,String userid,String usertype,String[] selectDis,String[] selectDept){
        boolean isok = false;
        if(StringUtils.isNotEmpty(candidateid)
                && StringUtils.isNotBlank(userid)
                && StringUtils.isNotBlank(usertype)
                && StringUtils.isNotBlank(userid)
                && StringUtils.isNotEmpty(selectDis)
                && StringUtils.isNotEmpty(selectDept)
        ){
            List<Candidateuser> list = new ArrayList<>();
            List<Userdistionary> listUd = new ArrayList<>();
            
            //查询当前用户关联的数据
            QueryWrapper queryWrapper = new QueryWrapper();
            queryWrapper.eq("USERID",userid);
            List<Userdistionary> listOld = this.userdistionarymybatisdao.selectList(queryWrapper);
            
            //删除当前用户的机构关联数据
            if(null != listOld && !listOld.isEmpty()){
                List<Long> listUds = listOld.stream().map(p -> p.getId()).collect(Collectors.toList());
                QueryWrapper delUd = new QueryWrapper();
                delUd.in("ID",listUds);
                this.userdistionarymybatisdao.delete(delUd);
    
                QueryWrapper cu = new QueryWrapper();
                cu.in("USERDISID",listUds);
                this.candidateuserService.remove(cu);
            }


            for(int i = 0;i < selectDis.length;i++){

                Userdistionary userdistionary = new Userdistionary();
                userdistionary.setDeptid(Long.parseLong(selectDept[i]));
                userdistionary.setDeptidDis(Long.parseLong(selectDis[i]));
                userdistionary.setUserid(Long.parseLong(userid));
                userdistionary.setUsertype(Integer.parseInt(usertype));
                isok = (this.userdistionarymybatisdao.insert(userdistionary) > 0)?true:false;
    

                List<Candidateuser> listCa = new ArrayList<>();
                for(String cauid:candidateid){
        
                    Candidateuser candidateuser = new Candidateuser();
                    candidateuser.setCandidateid(Long.parseLong(cauid));
                    candidateuser.setUserdisid(userdistionary.getId());
                    listCa.add(candidateuser);
                }
                this.candidateuserService.saveBatch(listCa);
            }

        }
        return isok;
    }
    /**
     * 查询不在当前关联表中的用户
     * @param paramterPage
     * @param query
     * @return
     */
    @Override
    public IPage<UserDistionaryVo> selectUserNoUd(ParamterPage paramterPage, QueryWrapper query, Map<String,Object> queryMap){
    
        Page<UserDistionaryVo> page = new Page<>(paramterPage.getStart(), paramterPage.getPagesize());
        
        query.ne("u.LOGINNAME","admin");
        query.ne("u.LOGINNAME","zhangyong");
        
        return this.userdistionarymybatisdao.selectUserNoUd(page,query,queryMap);
    }
    /**
     * 通过登录账号，查询审批权限关系表
     * @param loginname 登录账号
     * @return
     */
    public List<Userdistionary> selectListByLoginname(String loginname){
        return this.userdistionarymybatisdao.selectListByLoginname(loginname);
    }
    
    /**
     * 通过登录账号，查询审批权限关系表
     * @param userid 登录账号主键
     * @return
     */
    public Map<String,List<Userdistionary>> selectListByUserid(String userid){
        QueryWrapper queryWrapper = new QueryWrapper();
        queryWrapper.eq("USERID",userid);
    
        List<Userdistionary> list = this.userdistionarymybatisdao.selectList(queryWrapper);
        Map<String,List<Userdistionary>> map = new HashMap<>();
        
        for(Userdistionary userdistionary:list){
    
            List<Userdistionary> listTemp = map.get(userdistionary.getDeptidDis().toString());
            if(null == listTemp){
                listTemp = new ArrayList<>();
                listTemp.add(userdistionary);
                map.put(userdistionary.getDeptidDis().toString(),listTemp);
            }else{
                listTemp.add(userdistionary);
                map.put(userdistionary.getDeptidDis().toString(),listTemp);
            }
        }
        return map;
    }
    /**
     * 查询审批人信息
     * @param candidateid
     * @param deptid
     * @return
     */
    public List<Userdistionary> selectListByCandidateidAndDeptid(String candidateid,String deptid){
        return this.userdistionarymybatisdao.selectListByCandidateidAndDeptid(candidateid,deptid);
    }
    /**
     * 查询审批人信息
     * @param candidateid
     * @return
     */
    public List<Userdistionary> selectListByCandidateid(String candidateid,String loginname){
        return this.userdistionarymybatisdao.selectListByCandidateid(candidateid,loginname);
    }
    
    /**
     * 查询在当前关联表中的用户
     * @param paramterPage
     * @param query
     * @return
     */
    @Override
    public IPage<UserDistionaryVo> selectUserInUd(ParamterPage paramterPage,QueryWrapper query, Map<String,Object> queryMap,String userDisRolesid){
        Page<UserDistionaryVo> page = new Page<>(paramterPage.getStart(), paramterPage.getPagesize());
        query.ne("u.LOGINNAME","admin");
        query.ne("u.LOGINNAME","zhangyong");
        
        //判断权限组主键不为空
        if(StringUtils.isNotBlank(userDisRolesid)){
            queryMap.put("candidateid",userDisRolesid);
        }
    
        query.orderByDesc("osud.CANDIDATEID");
        
        //查询用户审批角色
        IPage<UserDistionaryVo> userDistionaryVoIPage = this.userdistionarymybatisdao.selectUserInUd(page,query,queryMap);
        
        
        for(UserDistionaryVo userDistionaryVo:userDistionaryVoIPage.getRecords()){
            
            //查询用户所在的审批组
            List<Candidateuser> candidateuserList = candidateuserService.selectList(userDisRolesid,userDistionaryVo.getUserdistionaryid());
            StringBuffer stringBuffer = new StringBuffer();
            StringBuffer stringBufferId = new StringBuffer();
            //便利审批组
            for(Candidateuser candidateuser:candidateuserList){
                
                if(stringBuffer.length() > 0){
                    stringBuffer.append(",");
                    stringBuffer.append(candidateuser.getCandidate().getCandidatename());
                    stringBufferId.append(",");
                    stringBufferId.append(candidateuser.getCandidate().getId().toString());
                }else{
                    stringBuffer.append(candidateuser.getCandidate().getCandidatename());
                    stringBufferId.append(candidateuser.getCandidate().getId().toString());
                }
            }
            //审批组名称赋值
            userDistionaryVo.setCandidatename(stringBuffer.toString());
            userDistionaryVo.setCandidateid(stringBufferId.toString());
        }
        
        return userDistionaryVoIPage;
    }
    @Override
    public int deleteByIdMore(String id) {
        int isok = 0;
        
        if(org.apache.commons.lang3.StringUtils.isNotBlank(id)){
            String[] ids = id.split(",");
            
            try{
                QueryWrapper wrapper = new QueryWrapper<>();
                wrapper.in("id",ids);
                isok = this.userdistionarymybatisdao.delete(wrapper);
    
                QueryWrapper wrapperCu = new QueryWrapper<>();
                wrapperCu.in("USERDISID",ids);
                candidateuserService.remove(wrapperCu);
            }catch (Exception e){
                isok = 0;
            }
            
        }
        
        return isok;
    }
}
