package cn.jyjz.xiaoyao.oa.from.vo;

import cn.jyjz.flowable.domain.dto.HistoricTaskInstanceDto;
import cn.jyjz.xiaoyao.common.base.jsonDomain.DateSerializer;
import cn.jyjz.xiaoyao.oa.from.dataobject.Category;
import com.baomidou.mybatisplus.annotation.TableField;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import java.util.List;

/**
 * 流程业务表的聚合对象
 */
@ApiModel(value="ocr_流程审批对象", description="ocr_流程审批对象")
@Data
public class FlowUnionVo {

    @ApiModelProperty(value ="业务表流水号")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long formid;
    @ApiModelProperty(value ="业务编码")
    private String buessinessno;
    @ApiModelProperty(value ="受理人主键")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long userid;
    
    @ApiModelProperty(value ="受理人姓名")
    private String username;
    
    @ApiModelProperty(value ="是否归档，0：未归档，1：归档")
    private Integer guidang;
    @ApiModelProperty(value ="附件")
    private String fileannex;
    @ApiModelProperty(value ="流程类型")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long categoryid;
    @ApiModelProperty(value ="流程名称")
    private String category;
    @ApiModelProperty(value ="状态，审批状态 1:撤销 2:审批中 3:审批通过 5：审批未通过 ")
    private Integer states;
    
    @ApiModelProperty(value ="流程定义id")
    private String processdefinitionid;
    
    @ApiModelProperty(value ="流程部署id")
    private String deploymentid;
    
    @ApiModelProperty(value ="审批人姓名")
    private String assigneename;
    @ApiModelProperty(value ="审批人")
    private String assignee;
    @ApiModelProperty(value ="创建人，记录创建人的帐号")
    private String createuser;
    
    @ApiModelProperty(value ="租户主键")
    private Long tenantid;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonSerialize(using = DateSerializer.class)
    @ApiModelProperty(value ="创建时间")
    private Long createdate;
    
    @ApiModelProperty(value ="创建人姓名")
    private String createusername;
    
    @ApiModelProperty(value ="任务包主键")
    private String packageid;
    
    //节点描述
    private String documentation;
    @ApiModelProperty(value ="流程实例IdprocessInstanceId")
    private String processinstanceid;
    
    @ApiModelProperty(value = "项目对象")
    private Category categoryDto;
    private String taskId;
    
    //是否查看，true：未查看，false：已查看
    private boolean view = false;
    
    // 关联 任务的流程记录
    @ApiModelProperty(value = "审批记录")
    private List<HistoricTaskInstanceDto> transferRecords;
}
