package cn.jyjz.xiaoyao.ocr.controller;

import java.io.IOException;
import java.util.Arrays;
import java.util.List;
import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import cn.hutool.core.bean.BeanUtil;
import cn.jyjz.flowable.common.SystemConstantsOa;
import cn.jyjz.xiaoyao.abase.service.FtperrorService;
import cn.jyjz.xiaoyao.admin.dataobject.User;
import cn.jyjz.xiaoyao.common.base.config.XiaoyaoConfig;
import cn.jyjz.xiaoyao.common.base.constant.CommonsConstants;
import cn.jyjz.xiaoyao.common.base.constant.SystemConstants;
import cn.jyjz.xiaoyao.common.base.util.RequestBaseUtil;
import cn.jyjz.xiaoyao.common.base.vo.UserToken;
import cn.jyjz.xiaoyao.common.mybatisplus.util.SearchQueryFormat;
import cn.jyjz.xiaoyao.framework.security.model.AdminUserModel;
import cn.jyjz.xiaoyao.ocr.dataobject.OcrPackagetask;
import cn.jyjz.xiaoyao.ocr.dataobject.OcrPicture;
import cn.jyjz.xiaoyao.ocr.dataobject.OcrTaskchildPicture;
import cn.jyjz.xiaoyao.ocr.service.OcrPackagetaskService;
import cn.jyjz.xiaoyao.ocr.service.OcrPictureService;
import cn.jyjz.xiaoyao.ocr.service.OcrTaskchildPictureService;
import cn.jyjz.xiaoyao.upload.upload.UploadSpringUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.*;

import cn.jyjz.xiaoyao.admin.service.UserService;
import cn.jyjz.xiaoyao.common.base.service.UserTokenService;
import cn.jyjz.xiaoyao.common.base.controller.BaseController;
import cn.jyjz.xiaoyao.common.base.param.ParamterPage;
import cn.jyjz.xiaoyao.common.base.util.requestFormat.SearchQuery;
import cn.jyjz.xiaoyao.common.base.vo.ResultVo;
import cn.jyjz.xiaoyao.common.base.vo.ResultVoUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springframework.web.multipart.MultipartFile;

@Api(tags="ocr_任务包")
@RestController
@RequestMapping("/ocr/ocrPackagetask")
public class OcrPackagetaskController extends BaseController{

	private Logger log = LoggerFactory.getLogger(this.getClass());

	@Resource
	private OcrPackagetaskService ocrPackagetaskService;
	@Resource
	private OcrTaskchildPictureService ocrTaskchildPictureService;
	@Resource
	private OcrPictureService ocrPictureService;
	@Resource
	private UserTokenService userTokenService;
	@Resource
	private UserService userService;
	
	@Resource
	private XiaoyaoConfig xiaoyaoConfig;
	
	@Resource
	private FtperrorService ftperrorService;
	
	/**
	 * 分页列表查询
	 *
	 * @param ocrPackagetask
	 * @param pageNo
	 * @param pageSize
	 * @return
	 */
	//@AutoLog(value = "ocr_packagetask-分页列表查询")
	@ApiOperation(value="ocr_任务包分页列表查询", notes="ocr_任务包分页列表查询")
	@ApiImplicitParams({
			@ApiImplicitParam(paramType = "header", name = "X-Tenant-Id", value = "租户主键,用户登录时的信息“tenantList”中获得。", dataType = "String", required = true)
	})
	@GetMapping(value = "/list")
	public ResultVo<IPage<OcrPackagetask>> queryPageList(OcrPackagetask ocrPackagetask,
													   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
													   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
													   HttpServletRequest request) {
		
		//租户主键，由前端页面传送
		String tenantId = request.getHeader("X-Tenant-Id");
		if(StringUtils.isBlank(tenantId)){
			return ResultVoUtil.error("租户主键不能为空");
		}
		
		//获取当前登录人
		UserToken userToken = this.userTokenService.getUserToken(RequestBaseUtil.getToken(request));
		
		QueryWrapper<OcrPackagetask> queryWrapper = new QueryWrapper<>();
		queryWrapper.eq("tenant_id",tenantId);
		Page<OcrPackagetask> page = new Page<OcrPackagetask>(pageNo, pageSize);
		IPage<OcrPackagetask> pageList = ocrPackagetaskService.page(page, queryWrapper);
		return ResultVoUtil.success(pageList);
	}
	
	/**
	 *方法描述：根据页面form传来的对象修改数据
	 *创建人：mail.zhangyong@gmail.com
	 *创建时间：2021-11-30 18:01:04
	 **/
	@PostMapping("/upload")
	public ResultVo editUser(HttpServletResponse response, HttpServletRequest request,
							 @RequestParam(value = "file", required = true) MultipartFile imgfile) throws IOException{

		String filepat = SystemConstantsOa.OCR_IMG_UP_PATH;
		
		//上传参考图
		if (null != imgfile && !imgfile.isEmpty()) {
			//获得文件后缀
			String fileType = org.apache.commons.io.FilenameUtils.getExtension(imgfile.getOriginalFilename());
			
			List<String> allowedExtensions = Arrays.asList("jpg", "jpeg", "png", "gif"); // 允许上传的文件类型列表
			if (!allowedExtensions.contains(fileType.toLowerCase())) {
				return ResultVoUtil.error("不支持的文件类型.");
			}
			
			//重新命名
			String fileName = System.currentTimeMillis() + "_c." + fileType;
			ResultVo rs = UploadSpringUtil.springUpload(imgfile, xiaoyaoConfig,filepat, fileName,ftperrorService);
			if (null != rs) {
				if (rs.getCode().equals(ResultVo.SUCCESS)) {
					return ResultVoUtil.success(rs.getOtherMessage().toString());
				}
			}
		}
		
		return ResultVoUtil.error();
	}
//
//	/**
//	 * 任务包详情
//	 *
//	 * @param ocrPackagetask
//	 * @return
//	 */
//	//@AutoLog(value = "ocr_packagetask-分页列表查询")
//	@ApiOperation(value="ocr_任务包详情", notes="ocr_任务包详情")
//	@ApiImplicitParams({
//			@ApiImplicitParam(paramType = "header", name = "X-Tenant-Id", value = "租户主键,用户登录时的信息“tenantList”中获得。", dataType = "String", required = true),
//			@ApiImplicitParam(paramType = "path",name = "packageid", value = "任务包主键", required = true)
//	})
//	@GetMapping(value = "/listorderbytask")
//	public ResultVo<List<OcrPicture>> listorderbytask(OcrPackagetask ocrPackagetask,
//													@RequestParam(name="packageid") String packageid,
//													HttpServletRequest request) {
//		//租户主键，由前端页面传送
//		String tenantId = request.getHeader("X-Tenant-Id");
//		if(StringUtils.isBlank(tenantId)){
//			return ResultVoUtil.error("租户主键不能为空");
//		}
//
//		//获取当前登录人
//		UserToken userToken = this.userTokenService.getUserToken(RequestBaseUtil.getToken(request));
//
//		List<OcrPicture> pageList = ocrPictureService.listByTaskChild(tenantId,userToken.getLoginname(),null,null,packageid);
//
//		return ResultVoUtil.success(pageList);
//	}
	
	
//	/**
//	 * 工单主图真假标记
//	 *
//	 * @param req
//	 * @return
//	 */
//	@ApiOperation(value="工单主图真假标记", notes="工单主图真假标记")
//	@ApiImplicitParams({
//			@ApiImplicitParam(paramType = "path",name = "childpictureid", value = "工单主键", required = true),
//			@ApiImplicitParam(paramType = "path",name = "izTrueorfalse", value = "主图片真假0:假，1：真", required = true),
//			@ApiImplicitParam(paramType = "path",name = "judgeid", value = "主图判真假原因id,从字典表中获得", required = true),
//			@ApiImplicitParam(paramType = "path",name = "packageid", value = "任务包主键", required = true)
//	})
//	@PostMapping(value = "/ordertrueorfalse")
//	public ResultVo ordertrueorfalse(@RequestParam(name="childpictureid",required=true) String childpictureid,
//								   @RequestParam(name="izTrueorfalse",required=true) String izTrueorfalse,
//								   @RequestParam(name="judgeid",required=true) String judgeid,
//								   @RequestParam(name="packageid",required=true) String packageid,
//								   HttpServletRequest req) {
//		//TODO 如果是历史图片，允许进行设置
//		//TODO 如果是已经审批完成的图片不允许是指
//
//		OcrTaskchildPicture ocrTaskchildPicture = new OcrTaskchildPicture();
////		ocrTaskchildPicture.setIztrueorfalse(izTrueorfalse);
////		ocrTaskchildPicture.setJudgeid(judgeid);
//		ocrTaskchildPicture.setPackageid(Long.parseLong(packageid));
//
//		return ocrTaskchildPictureService.trueorfalse(childpictureid,ocrTaskchildPicture)?ResultVoUtil.success():ResultVoUtil.error("失败。");
//	}
//
//	/**
//	 * 工单查重图是否合格标记
//	 *
//	 * @param req
//	 * @return
//	 */
//	@ApiOperation(value="工单查重图是否合格标记", notes="工单查重图是否合格标记")
//	@ApiImplicitParams({
//			@ApiImplicitParam(paramType = "path",name = "childpictureid", value = "工单主键", required = true),
//			@ApiImplicitParam(paramType = "path",name = "izPass", value = "主图片是否合格0：否，1：是", required = true),
//			@ApiImplicitParam(paramType = "path",name = "judgePassid", value = "主图判是否合格原因id,从字典表中获得", required = true),
//			@ApiImplicitParam(paramType = "path",name = "packageid", value =  "任务包主键", required = true)
//	})
//	@PostMapping(value = "/orderpass")
//	public ResultVo<List<OcrPicture>> orderpass(@RequestParam(name="childpictureid",required=true) String childpictureid,
//											  @RequestParam(name="izPass",required=true) String izPass,
//											  @RequestParam(name="judgePassid",required=true) String judgePassid,
//											  @RequestParam(name="packageid",required=true) String packageid,
//											  HttpServletRequest req) {
//		OcrTaskchildPicture ocrTaskchildPicture = new OcrTaskchildPicture();
////		ocrTaskchildPicture.setIzpass(izPass);
////		ocrTaskchildPicture.setJudgepass(Long.parseLong(judgePassid));
//		ocrTaskchildPicture.setPackageid(Long.parseLong(packageid));
//		return ocrTaskchildPictureService.pass(childpictureid,ocrTaskchildPicture)?ResultVoUtil.success():ResultVoUtil.error("失败。");
//	}
}
