package cn.jyjz.xiaoyao.ocr.controller;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import cn.jyjz.xiaoyao.admin.service.LogService;
import cn.jyjz.xiaoyao.common.base.util.RequestBaseUtil;
import cn.jyjz.xiaoyao.common.base.vo.UserToken;
import cn.jyjz.xiaoyao.common.mybatisplus.util.SearchQueryFormat;
import cn.jyjz.xiaoyao.ocr.dataobject.OcrPicture;
import cn.jyjz.xiaoyao.ocr.dataobject.OcrPictureclass;
import cn.jyjz.xiaoyao.ocr.dataobject.OcrTaskchildPicture;
import cn.jyjz.xiaoyao.ocr.service.OcrPictureService;
import cn.jyjz.xiaoyao.ocr.service.OcrPictureclassService;
import cn.jyjz.xiaoyao.ocr.service.OcrTaskchildPictureService;
import cn.jyjz.xiaoyao.ocr.util.DataUtil;
import cn.jyjz.xiaoyao.ocr.util.SearchConfigEnum;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.*;

import cn.jyjz.xiaoyao.admin.service.UserService;
import cn.jyjz.xiaoyao.common.base.service.UserTokenService;
import cn.jyjz.xiaoyao.common.base.controller.BaseController;
import cn.jyjz.xiaoyao.common.base.param.ParamterPage;
import cn.jyjz.xiaoyao.common.base.util.requestFormat.SearchQuery;
import cn.jyjz.xiaoyao.common.base.vo.ResultVo;
import cn.jyjz.xiaoyao.common.base.vo.ResultVoUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;

@RestController
@RequestMapping("/ocr/ocrPicture")
public class OcrPictureController extends BaseController{

	private Logger log = LoggerFactory.getLogger(this.getClass());

	@Resource
	private OcrPictureService ocrPictureService;
	@Resource
	private OcrPictureclassService ocrPictureclassService;
	@Resource
	private OcrTaskchildPictureService ocrTaskchildPictureService;
	@Resource
	private UserTokenService userTokenService;
	@Resource
	private UserService userService;
	@Resource
	private LogService logService;
	/**
	 * 工单查询
	 *
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "ocr_picture-分页列表查询")
	@ApiOperation(value="关闭工单", notes="关闭工单")
	@GetMapping(value = "/closeorder")
	public ResultVo<List<OcrPicture>> closeorder(@RequestParam(name="orderid",required=true) String orderid,
											   HttpServletRequest req) {
		return ocrTaskchildPictureService.closeOrder(orderid)?ResultVoUtil.success():ResultVoUtil.error("失败");
	}
	
	/**
	 * 工单查询@MM1vvPNHRprA7ScHnwE+WG6yz7hcA/u3tzMj6pSdvwc=
	 *@MM1vvPNHRprA7ScHnwE+WG6yz7hcA/u3tzMj6pSdvwc=
	 * @param ocrPicture
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "ocr_picture-分页列表查询")
	@ApiOperation(value="任务查询", notes="任务查询")
	@ApiImplicitParams({
			@ApiImplicitParam(paramType = "header", name = "X-Tenant-Id", value = "租户主键,用户登录时的信息“tenantList”中获得。", dataType = "String", required = true),
			@ApiImplicitParam(paramType = "path",name = "izClose", value = "是否关闭，0：关闭，1：开启", required = true),
			@ApiImplicitParam(paramType = "path",name = "tasktype", value = "任务状态，1：待审批:2：审批中 :3：合格 :4：不合格", required = true)
	})
	@GetMapping(value = "/listorder")
	public ResultVo<List<OcrPicture>> listorder(OcrPicture ocrPicture,
											  @RequestParam(name="izClose") String izClose,
											  @RequestParam(name="tasktype") String tasktype,
											  HttpServletRequest req) {
		//租户主键，由前端页面传送
		String tenantId = req.getHeader("X-Tenant-Id");
		if(StringUtils.isBlank(tenantId)){
			return ResultVoUtil.error("租户主键不能为空");
		}
		
		//获取当前登录人
		UserToken userToken = this.userTokenService.getUserToken(RequestBaseUtil.getToken(req));
		
		List<OcrPicture> pageList = ocrPictureService.listByTaskChild(tenantId,userToken.getLoginname(),izClose,tasktype,null);
		
		return ResultVoUtil.success(pageList);
	}
	
	/**
	 * 工单查询
	 *
	 * @param ocrPicture
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "ocr_picture-分页列表查询")
	@ApiOperation(value="一键查重", notes="一键查重")
	@ApiImplicitParams({
			@ApiImplicitParam(paramType = "header", name = "X-Tenant-Id", value = "租户主键,用户登录时的信息“tenantList”中获得。", dataType = "String", required = true),
			@ApiImplicitParam(paramType = "path",name = "search_month", value = "搜索时间，21,一周内，22：两周内，1：进一个月，2:进两个月，3：近三个月、6：近六个月、9：近九个月、12：近12个月", required = true),
			@ApiImplicitParam(paramType = "path",name = "search_history", value = "是否查询历史记录，0：不查询，1：查询", required = true)
	})
	@GetMapping(value = "/createorder")
	public ResultVo createorder(OcrPicture ocrPicture,
							  HttpServletRequest req) {
		
		//获取当前登录人
		UserToken userToken = this.userTokenService.getUserToken(RequestBaseUtil.getToken(req));
		
		//租户主键，由前端页面传送
		String tenantId = req.getHeader("X-Tenant-Id");
		if(StringUtils.isBlank(tenantId)){
			return ResultVoUtil.error("租户主键不能为空");
		}
		
		QueryWrapper<OcrPicture> queryWrapper = new QueryWrapper<>();
		
		//是否查询历史记录
		String search_history = req.getParameter("search_history");
		
		//任务包名称
		String buessinessno = req.getParameter("buessinessno");
		
		//搜索时间段
		String search_month = req.getParameter("search_month");
		if(StringUtils.isNotBlank(search_month) && Integer.parseInt(search_month) <= 12 && Integer.parseInt(search_month) > 0){
			queryWrapper.le("createTime", DataUtil.afterDateByMonth(Integer.parseInt(search_month)));
		}else if(StringUtils.isNotBlank(search_month) && Integer.parseInt(search_month) > 20){
			queryWrapper.le("createTime",DataUtil.afterDateByWeek(Integer.parseInt(search_month) - 20));
		}
		
		//判断是否需要查询历史记录
		if(search_history.equals("0")){
			queryWrapper.eq("taskstatus", search_history);
		}
		
		queryWrapper.eq("tenant_id",tenantId);
		
		List<OcrPicture> pageList = ocrPictureService.listPage(queryWrapper);
		
		if(null != pageList && !pageList.isEmpty()){
			if(pageList.size() == 1){
				return ResultVoUtil.error("查重数据至少要有两条。");
			}else{
				return ocrPictureService.createTaskChild(pageList,tenantId,userToken,search_month, req,buessinessno);
			}
		}else{
			return ResultVoUtil.error("没有查重数据。");
		}
		//return Result.error("失败。");
	}
	
	/**
	 * 分页列表查询
	 *
	 * @param ocrPicture
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "ocr_picture-分页列表查询")
	@ApiOperation(value="图片分页列表查询", notes="图片分页列表查询@MMlvuvNARprA7ScHnwE+WFPWEBliKUwgUPHdB2Ue9Bw=")
	@ApiImplicitParams({
			@ApiImplicitParam(paramType = "header", name = "X-Tenant-Id", value = "租户主键,用户登录时的信息“tenantList”中获得。", dataType = "String", required = true),
			@ApiImplicitParam(paramType = "path",name = "search_month", value = "搜索时间，3：近三个月、6：近六个月、9：近九个月、12：近12个月、99：一年以上（全部）", required = true),
			@ApiImplicitParam(paramType = "path",name = "search_history", value = "是否查询历史记录，0：不查询，1：查询", required = true)
	})
	@GetMapping(value = "/list")
	public ResultVo<IPage<OcrPicture>> queryPageList(OcrPicture ocrPicture,
												   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
												   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
												   HttpServletRequest req) {
		//租户主键，由前端页面传送
		String tenantId = req.getHeader("X-Tenant-Id");
		if(StringUtils.isBlank(tenantId)){
			return ResultVoUtil.error("租户主键不能为空");
		}
		
		QueryWrapper<OcrPicture> queryWrapper = new QueryWrapper<>();
		
		//是否查询历史记录
		String search_history = req.getParameter("search_history");
		//判断是否需要查询历史记录
		if(search_history.equals("0")){
			queryWrapper.eq("taskstatus", search_history);
		}
		
		String search_month = req.getParameter("search_month");
		if(StringUtils.isNotBlank(search_month) && Integer.parseInt(search_month) <= 12 && Integer.parseInt(search_month) > 0){
			queryWrapper.le("createTime",DataUtil.afterDateByMonth(Integer.parseInt(search_month)));
		}
		
		
		
		//提报人
		//任务计划
		//相似度
		//图片类型
		//年份
		//发布地区
		//SearchConfigEnum.fomarQueryWrapper(req,queryWrapper);
		
		for(SearchConfigEnum config : SearchConfigEnum.values()){
			
			//相似度不在搜索范围内
			if(!config.getId().equals("izSimilarity")){
				String searchvalue = req.getParameter(config.getId());
				if(StringUtils.isNotBlank(searchvalue)){
					if(config.getId().equals("izYear")){
						//针对年份搜索，需要拆分
						String[] year = searchvalue.split(",");
						//当前数据必须是两条
						if(year.length == 2){
							java.text.SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
							Date start = null;
							Date end = null;
							try {
								start = sdf.parse(year[0]);
								end = sdf.parse(year[1]);
							} catch (ParseException e) {
								continue;
							}
							
							queryWrapper.ge(config.getMeaning(),start);
							queryWrapper.le(config.getMeaning(),end);
						}
						
					}else{
						queryWrapper.eq(config.getMeaning(),searchvalue);
					}
					
				}
				
			}
			
		}
		
		queryWrapper.eq("tenant_id",tenantId);
		Page<OcrPicture> page = new Page<OcrPicture>(pageNo, pageSize);
		IPage<OcrPicture> pageList = ocrPictureService.page(page, queryWrapper);
		
		for(OcrPicture ocrPicture1:pageList.getRecords()){
			if(StringUtils.isNotBlank(ocrPicture1.getPictureclassid())){
				OcrPictureclass ocrPictureclass = this.ocrPictureclassService.getById(ocrPicture1.getPictureclassid());
				ocrPicture1.setOcrPictureclass(ocrPictureclass);
			}
			
		}
		
		return ResultVoUtil.success(pageList);
	}
	
	/**
	 * 分页列表查询
	 *
	 * @param ocrPicture
	 * @return
	 */
	//@AutoLog(value = "ocr_picture-分页列表查询")
	@ApiOperation(value="图片信息接收", notes="图片信息接收")
	@PostMapping(value = "/loadpicture")
	public ResultVo loadpicture(OcrPicture ocrPicture,
							  HttpServletRequest request) {
		
		BufferedReader streamReader = null;
		try {
			streamReader = new BufferedReader( new InputStreamReader(request.getInputStream(),"UTF-8"));
		} catch (IOException e) {
			log.error("【数据接收】jsonFormatError:{}",e);
			logService.addLog(101,"接收数据失败。",null,null);
			ResultVoUtil.error("失败");
		}
		StringBuilder sb = new StringBuilder();
		String inputStr;
		try {
			while ((inputStr = streamReader.readLine()) != null) {
				sb.append(inputStr);
			}
		} catch (IOException e) {
			log.error("【数据接收】jsonFormatError:{}",e);
			logService.addLog(101,"接收数据失败。",null,null);
		}
		
		logService.addLog(101,"接收数据成功。",null,null);
		
		JSONObject jsonArray = JSONObject.parseObject(sb.toString());
		
		//TODO 结束json数据，并持久化
		//this.ocrPictureService
		//TODO AI获取图片分类接口

		logService.addLog(102,"AI获取图片分类接口。",null,null);
		
		return ResultVoUtil.success();
	}

}
