package cn.jyjz.xiaoyao.ocr.controller;

import java.io.IOException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import cn.jyjz.xiaoyao.common.base.util.RequestBaseUtil;
import cn.jyjz.xiaoyao.common.base.vo.UserToken;
import cn.jyjz.xiaoyao.common.mybatisplus.util.SearchQueryFormat;
import cn.jyjz.xiaoyao.ocr.dataobject.OcrPictureNotes;
import cn.jyjz.xiaoyao.ocr.service.OcrPictureNotesService;
import com.alibaba.fastjson.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.*;

import cn.jyjz.xiaoyao.admin.service.UserService;
import cn.jyjz.xiaoyao.common.base.service.UserTokenService;
import cn.jyjz.xiaoyao.common.base.controller.BaseController;
import cn.jyjz.xiaoyao.common.base.param.ParamterPage;
import cn.jyjz.xiaoyao.common.base.util.requestFormat.SearchQuery;
import cn.jyjz.xiaoyao.common.base.vo.ResultVo;
import cn.jyjz.xiaoyao.common.base.vo.ResultVoUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;

@RestController
@RequestMapping("/backstage/jifen/ocrpicturenotes")
public class OcrPictureNotesController extends BaseController{

	private Logger log = LoggerFactory.getLogger(this.getClass());

	@Autowired
	private OcrPictureNotesService ocrPictureNotesService;

	@Autowired
	private UserTokenService userTokenService;
	@Autowired
	private UserService userService;
	/**
	*方法描述：返回json字符串，接受参数，dto名称以及分页信息
	*创建人：mail.zhangyong@gmail.com
	*创建时间：2024-01-14 10:27:01
	**/
	@GetMapping("/list")
	public ResultVo<IPage<OcrPictureNotes>> listOcrPictureNotes(ParamterPage paramterPage, HttpServletRequest request, HttpServletResponse response) throws IOException{
		SearchQuery searchQuery = this.getParametersStartingWithToSearchJson(request, "search_");

		OcrPictureNotes ocrpicturenotes = new OcrPictureNotes();

		QueryWrapper<OcrPictureNotes> queryWrapper = SearchQueryFormat.queryStringFormat(searchQuery,ocrpicturenotes);
		IPage<OcrPictureNotes> page = this.ocrPictureNotesService.selectSearchListPage(paramterPage,queryWrapper);;
		return ResultVoUtil.success(page);
	}

	/**
	*方法描述：保存添加数据
	*创建人：mail.zhangyong@gmail.com
	*创建时间：2024-01-14 10:27:01
	**/
	@PostMapping("/save")
	public ResultVo saveOcrPictureNotes(HttpServletResponse response,HttpServletRequest request,OcrPictureNotes tab) throws IOException{
		UserToken userToken = this.userTokenService.getUserToken(RequestBaseUtil.getToken(request));
		
		this.ocrPictureNotesService.save(tab);
		return ResultVoUtil.success();
	}

	/**
	*方法描述：根据页面form传来的对象修改数据
	*创建人：mail.zhangyong@gmail.com
	*创建时间：2024-01-14 10:27:01
	**/
	@PostMapping("/edit")
	public ResultVo editOcrPictureNotes(HttpServletResponse response,HttpServletRequest request,OcrPictureNotes tab) throws IOException{
		UserToken userToken = this.userTokenService.getUserToken(RequestBaseUtil.getToken(request));
		this.ocrPictureNotesService.updateById(tab);
		return ResultVoUtil.success();
	}

	/**
	*方法描述：通过主键获得对象信息
	*创建人：mail.zhangyong@gmail.com
	*创建时间：2024-01-14 10:27:01
	**/
	@GetMapping("/getdata/{id}")
	@ResponseBody
	public ResultVo getdateOcrPictureNotes(HttpServletResponse response,HttpServletRequest request,@PathVariable("id") Long id) throws IOException{
		OcrPictureNotes dto = this.ocrPictureNotesService.selectDtoById(id);
		if(null != dto){
			return ResultVoUtil.success(dto);
		}else{
			return ResultVoUtil.error();
		}
	}

	/**
	*方法描述：根据id字符串组删除对象方法，例如1,2,3
	*创建人：mail.zhangyong@gmail.com
	*创建时间：2024-01-14 10:27:01
	**/
	@GetMapping("/delmore")
	@ResponseBody
	public ResultVo delMoreOcrPictureNotes(HttpServletResponse response,HttpServletRequest request) throws IOException{
		String ids = request.getParameter("id");
		this.ocrPictureNotesService.deleteByIdMore(ids);
		return ResultVoUtil.success();
	}

}
