package cn.jyjz.xiaoyao.ocr.controller;

import java.io.IOException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import cn.jyjz.xiaoyao.ocr.service.OcrPicturetypeService;
import com.alibaba.fastjson.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import cn.jyjz.xiaoyao.admin.service.UserService;
import cn.jyjz.xiaoyao.common.base.service.UserTokenService;
import cn.jyjz.xiaoyao.common.base.controller.BaseController;
import cn.jyjz.xiaoyao.common.base.param.ParamterPage;
import cn.jyjz.xiaoyao.common.base.util.requestFormat.SearchQuery;
import cn.jyjz.xiaoyao.common.base.vo.ResultVo;
import cn.jyjz.xiaoyao.common.base.vo.ResultVoUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;

@Controller
@RequestMapping("/backstage/oa/ocrpicturetypeHtml")
public class OcrPicturetypeHtmlController extends BaseController{

	private Logger log = LoggerFactory.getLogger(this.getClass());

	@Autowired
	private OcrPicturetypeService ocrPicturetypeService;

	@Autowired
	private UserTokenService userTokenService;
	@Autowired
	private UserService userService;
	/**
	*方法描述：跳转到列表页面
	*创建人：mail.zhangyong@gmail.com
	*创建时间：2024-01-14 10:27:01
	**/
	@GetMapping("/toList")
	public String toListOcrPicturetype(HttpServletResponse response,HttpServletRequest request){
		String resourceid = request.getParameter("resourceid");
		request.setAttribute("resourceid",resourceid);
		return "/backstage/oa/ocr/ocrpicturetype/list";
	}

	/**
	*方法描述：跳转到保存页面
	*创建人：mail.zhangyong@gmail.com
	*创建时间：2024-01-14 10:27:01
	**/
	@GetMapping("/toSave")
	public String toSaveOcrPicturetype(HttpServletResponse response,HttpServletRequest request){
		String resourceid = request.getParameter("resourceid");
		request.setAttribute("resourceid",resourceid);
		return "/backstage/oa/ocr/ocrpicturetype/add";
	}

	/**
	*方法描述：根据ID跳转到修改页面
	*创建人：mail.zhangyong@gmail.com
	*创建时间：2024-01-14 10:27:01
	**/
	@GetMapping("/toEdit/{id}")
	public String toEditOcrPicturetype(HttpServletResponse response,HttpServletRequest request,@PathVariable("id") String id){
		String resourceid = request.getParameter("resourceid");
		request.setAttribute("resourceid",resourceid);
		request.setAttribute("id", id);
		return "/backstage/oa/ocr/ocrpicturetype/edit";
	}

}
