package cn.jyjz.xiaoyao.ocr.dataobject;

import cn.jyjz.xiaoyao.common.base.jsonDomain.DateNotimeSerializer;
import cn.jyjz.xiaoyao.common.base.jsonDomain.DateSerializer;
import cn.jyjz.xiaoyao.common.mybatisplus.dto.BaseDto;
import cn.jyjz.xiaoyao.common.base.util.requestFormat.SearchQuery;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import java.util.Map;
import java.util.AbstractMap.SimpleEntry;
import java.util.stream.Stream;
import java.util.stream.Collectors;
 
 

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Schema(name = "个人笔记", title = "个人笔记")
@TableName(value = "ocr_booknote")
public class OcrBooknote implements BaseDto,java.io.Serializable {
	
	private static final long serialVersionUID = -6014849689684268046L;
	@Schema(description = "主键")
	@TableId(value = "id",type = IdType.ASSIGN_ID)
	@JsonSerialize(using = ToStringSerializer.class)
	@TableField(value="ID")
	private Long id;
	
	@Schema(description = "租户ID")
	@JsonSerialize(using = ToStringSerializer.class)
	@TableField(value="TENANTID")
	private Long tenantid;
	
	@Schema(description = "记录内容")
	@TableField(value="NOTECONTENT")
	private String notecontent;
	
	@Schema(description = "创建人，记录创建人的帐号")
	@TableField(value="CREATEUSER")
	private String createuser;
	
	@Schema(description = "创建时间")
	@TableField(value="CREATEDATE")
	@JsonSerialize(using = DateSerializer.class)
	private Long createdate;
	
	@Schema(description = "修改人，记录创建人的帐号")
	@TableField(value="UPDATEUSER")
	private String updateuser;
	
	@Schema(description = "更新时间")
	@TableField(value="UPDATETIME")
	@JsonSerialize(using = DateSerializer.class)
	private Long updatetime;
	
	//保存当前登录用户的数据权限范围的搜索条件
	@TableField(exist = false)
	@JsonIgnore
	private SearchQuery searchQueryrolesShowleave;

	@TableField(exist = false)
	@JsonIgnore
	private final Map<String,String> query = Stream.of(
		new SimpleEntry<>("listdept","deptid"),
		new SimpleEntry<>("ID","id"),
		new SimpleEntry<>("TENANTID","tenantid"),
		new SimpleEntry<>("NOTECONTENT","notecontent"),
		new SimpleEntry<>("CREATEUSER","createuser"),
		new SimpleEntry<>("CREATEDATE","createdate"),
		new SimpleEntry<>("UPDATEUSER","updateuser"),
		new SimpleEntry<>("UPDATETIME","updatetime")
	)
	.collect(Collectors.toMap(SimpleEntry::getKey, SimpleEntry::getValue));
	@Override
	public String getQueryFiled(String filedname){
		String obj = null;
		if(null != query && query.size() > 0){
		obj = query.get(filedname);
		}
		return obj;
	}
}
