package cn.jyjz.xiaoyao.ocr.dataobject;

import cn.jyjz.xiaoyao.common.base.jsonDomain.DateNotimeSerializer;
import cn.jyjz.xiaoyao.common.base.jsonDomain.DateSerializer;
import cn.jyjz.xiaoyao.common.mybatisplus.dto.BaseDto;
import cn.jyjz.xiaoyao.common.base.util.requestFormat.SearchQuery;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.apache.commons.lang3.StringUtils;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.HashMap;
import java.util.Map;
import java.util.AbstractMap.SimpleEntry;
import java.util.stream.Stream;
import java.util.stream.Collectors;
 
 

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Schema(name = "配置管理", title = "配置管理")
@TableName(value = "ocr_configuration")
public class OcrConfiguration implements BaseDto,java.io.Serializable {
	
	private static final long serialVersionUID = -7627701327152463218L;
	@Schema(description = "主键")
	@TableId(value = "id",type = IdType.ASSIGN_ID)
	@JsonSerialize(using = ToStringSerializer.class)
	@TableField(value="ID")
	private Long id;
	
	@Schema(description = "创建人")
	@TableField(value="CREATEBY")
	private String createby;
	
	@Schema(description = "创建时间")
	@JsonSerialize(using = DateSerializer.class)
	@TableField(value="CREATETIME")
	private Long createtime;
	
	@Schema(description = "修改人")
	@TableField(value="UPDATEBY")
	private String updateby;
	
	@Schema(description = "修改时间")
	@JsonSerialize(using = DateSerializer.class)
	@TableField(value="UPDATETIME")
	private Long updatetime;
	
	@Schema(description = "是否图片分类,Y表示是 N表示否，读取单表")
	@TableField(value="IZSHOW")
	private String izshow;
	
	@Schema(description = "是否展示图片相似度阈值,1表示是 0表示否")
	@TableField(value="IZSIMILARITY")
	private String izsimilarity;
	
	@Schema(description = "相似度阈值开始值")
	@TableField(value="SIMILARITYSTART")
	private Integer similaritystart;
	
	@Schema(description = "相似度阈值结束值")
	@TableField(value="SIMILARITYEND")
	private Integer similarityend;
	
	@Schema(description = "年份是否展示,1表示是 0表示否")
	@TableField(value="IZYEAR")
	private String izyear;
	
	@Schema(description = "图片类型是否展示,Y表示是 N表示否，读取单表")
	@TableField(value="IZPICTURETYPE")
	private String izpicturetype;
	
	@Schema(description = "上传参考图,Y表示是 N表示否")
	@TableField(value="IZUPLOAD")
	private String izupload;
	
	@Schema(description = "自定义过滤条件,,Y表示是 N表示否，读取单表")
	@TableField(value="IZSEARCH")
	private String izsearch;
	
	@Schema(description = "自定义筛选,Y表示是 N表示否，读取单表")
	@TableField(value="IZSEARCHMANAGER")
	private String izsearchmanager;
	
	@Schema(description = "添加备注,Y表示是 N表示否")
	@TableField(value="IZDESC")
	private String izdesc;
	
	@Schema(description = "提报人是否展示,Y表示是 N表示否，读取单表")
	@TableField(value="IZUPUSER")
	private String izupuser;
	
	@Schema(description = "任务计划是否展示,Y表示是 N表示否，读取单表")
	@TableField(value="IZPLAN")
	private String izplan;
	
	@Schema(description = "所属项目,Y表示是 N表示否，读取单表")
	@TableField(value="IZPROJECT")
	private String izproject;
	
	@Schema(description = "客户类型,Y表示是 N表示否，读取数据字典")
	@TableField(value="IZCUSTOMTYPE")
	private String izcustomtype;
	
	@Schema(description = "客户级别,Y表示是 N表示否，读取数据字典")
	@TableField(value="IZCUSTOMLEVEL")
	private String izcustomlevel;
	
	@Schema(description = "客户名称,Y表示是 N表示否，读取数据字典")
	@TableField(value="IZCUSTOMNAME")
	private String izcustomname;
	
	@Schema(description = "项目类别,Y表示是 N表示否，读取数据字典")
	@TableField(value="IZPROJECTTYPE")
	private String izprojecttype;
	
	@Schema(description = "任务来源,Y表示是 N表示否，读取数据字典")
	@TableField(value="IZTASKRROM")
	private String iztaskrrom;
	
	@Schema(description = "任务状态,Y表示是 N表示否，读取数据字典")
	@TableField(value="IZTASKSTATUS")
	private String iztaskstatus;
	
	@Schema(description = "拜访省份/直辖市,Y表示是 N表示否，读取单表")
	@TableField(value="IZVISITPRO")
	private String izvisitpro;
	
	@Schema(description = "拜访城市,Y表示是 N表示否，读取单表")
	@TableField(value="IZVISITCITY")
	private String izvisitcity;
	
	@Schema(description = "厂商,Y表示是 N表示否，读取单表")
	@TableField(value="IZFIRM")
	private String izfirm;
	
	@Schema(description = "产品名称,Y表示是 N表示否，读取数据字典")
	@TableField(value="IZPRODUCTNAME")
	private String izproductname;
	
	@Schema(description = "图片下载")
	@TableField(value="IZIMGDOWNLOAD")
	private String izimgdownload;
	
	@Schema(description = "拜访客户类型")
	@TableField(value="IZFILED2")
	private String izfiled2;
	
	@Schema(description = "拜访客户级别")
	@TableField(value="IZFIELD6")
	private String izfield6;
	
	@Schema(description = "拜访客户名称")
	@TableField(value="IZFIELD3")
	private String izfield3;
	
	@Schema(description = "拜访项目类别")
	@TableField(value="IZFIELD17")
	private String izfield17;

	//保存当前登录用户的数据权限范围的搜索条件
	@TableField(exist = false)
	@JsonIgnore
	private SearchQuery searchQueryrolesShowleave;

	@TableField(exist = false)
	@JsonIgnore
	private final Map<String,String> query = Stream.of(
					new SimpleEntry<>("ID","id"),
					new SimpleEntry<>("CREATEBY","createby"),
					new SimpleEntry<>("CREATETIME","createtime"),
					new SimpleEntry<>("UPDATEBY","updateby"),
					new SimpleEntry<>("UPDATETIME","updatetime"),
					new SimpleEntry<>("IZSHOW","izshow"),
					new SimpleEntry<>("IZSIMILARITY","izsimilarity"),
					new SimpleEntry<>("SIMILARITYSTART","similaritystart"),
					new SimpleEntry<>("SIMILARITYEND","similarityend"),
					new SimpleEntry<>("IZYEAR","izyear"),
					new SimpleEntry<>("IZPICTURETYPE","izpicturetype"),
					new SimpleEntry<>("IZUPLOAD","izupload"),
					new SimpleEntry<>("IZSEARCH","izsearch"),
					new SimpleEntry<>("IZSEARCHMANAGER","izsearchmanager"),
					new SimpleEntry<>("IZDESC","izdesc"),
					new SimpleEntry<>("IZUPUSER","izupuser"),
					new SimpleEntry<>("IZPLAN","izplan"),
					new SimpleEntry<>("IZPROJECT","izproject"),
					new SimpleEntry<>("IZCUSTOMTYPE","izcustomtype"),
					new SimpleEntry<>("IZCUSTOMLEVEL","izcustomlevel"),
					new SimpleEntry<>("IZCUSTOMNAME","izcustomname"),
					new SimpleEntry<>("IZPROJECTTYPE","izprojecttype"),
					new SimpleEntry<>("IZTASKRROM","iztaskrrom"),
					new SimpleEntry<>("IZTASKSTATUS","iztaskstatus"),
					new SimpleEntry<>("IZVISITPRO","izvisitpro"),
					new SimpleEntry<>("IZVISITCITY","izvisitcity"),
					new SimpleEntry<>("IZFIRM","izfirm"),
					new SimpleEntry<>("IZPRODUCTNAME","izproductname"),
					new SimpleEntry<>("IZIMGDOWNLOAD","izimgdownload"),
					new SimpleEntry<>("IZFILED2","izfiled2"),
					new SimpleEntry<>("IZFIELD6","izfield6"),
					new SimpleEntry<>("IZFIELD3","izfield3"),
					new SimpleEntry<>("IZFIELD17","izfield17")
	)
	.collect(Collectors.toMap(SimpleEntry::getKey, SimpleEntry::getValue));
	@Override
	public String getQueryFiled(String filedname){
		String obj = null;
		if(null != query && query.size() > 0){
		obj = query.get(filedname);
		}
		return obj;
	}
	
	public void format(OcrSearchmanager ocrSearchmanager){
		
		Map<String, String > allSm  = new HashMap<String, String>(){{
			put("izshow","izshow");
			put("izsimilarity","izsimilarity");
			put("izyear","izyear");
			put("izpicturetype","izpicturetype");
			put("izupload","izupload");
			put("izsearch","izsearch");
			put("izsearchmanager","izsearchmanager");
            put("izdesc","izdesc");
            put("izupuser","izupuser");
            put("izplan","izplan");
			put("izproject","izproject");
			put("izcustomtype","izcustomtype");
			put("izcustomlevel","izcustomlevel");
			put("izcustomname","izcustomname");
			put("izprojecttype","izprojecttype");
			put("iztaskrrom","iztaskrrom");
			put("iztaskstatus","iztaskstatus");
			put("izvisitpro","izvisitpro");
			put("izvisitcity","izvisitcity");
			put("izfirm","izfirm");
			put("izproductname","izproductname");
			put("izimgdownload","izimgdownload");
			
			put("izfiled2","izfiled2");
			put("izfield6","izfield6");
			put("izfield3","izfield3");
			put("izfield17","izfield17");
		}};
		//已经设置的个性化筛选
		String searchcount = ocrSearchmanager.getSearchcount();
		if(StringUtils.isNotBlank(searchcount)){
			String[] sc = searchcount.split(",");
			if(sc.length > 0){
				for(String s:sc){
					allSm.remove(s);
					//是否展示分类
					if(this.izshow.equals("Y") && s.equals("izshow")){
						this.izshow = "Y";
					}else if(this.izshow.equals("N") && s.equals("izshow")){
						this.izshow = "N";
					}
					//是否展示相似度
					else if(this.izsimilarity.equals("Y") && s.equals("izsimilarity")){
						this.izsimilarity = "Y";
					}else if(this.izsimilarity.equals("N") && s.equals("izsimilarity")){
						this.izsimilarity = "N";
					}
					//是否展示年份
					else if(this.izyear.equals("Y") && s.equals("izyear")){
						this.izyear = "Y";
					}else if(this.izyear.equals("N") && s.equals("izyear")){
						this.izyear = "N";
					}
					//是否展示图片类型
					else if(this.izpicturetype.equals("Y") && s.equals("izpicturetype")){
						this.izpicturetype = "Y";
					}else if(this.izpicturetype.equals("N") && s.equals("izpicturetype")){
						this.izpicturetype = "N";
					}
					//是否可以上传参考图
					else if(this.izupload.equals("Y") && s.equals("izupload")){
						this.izupload = "Y";
					}else if(this.izupload.equals("N") && s.equals("izupload")){
						this.izupload = "N";
					}
					
					else if(this.izsearch.equals("Y") && s.equals("izsearch")){
						this.izsearch = "Y";
					}else if(this.izsearch.equals("N") && s.equals("izsearch")){
						this.izsearch = "N";
					}
					
					else if(this.izsearchmanager.equals("Y") && s.equals("izsearchmanager")){
						this.izsearchmanager = "Y";
					}else if(this.izsearchmanager.equals("N") && s.equals("izsearchmanager")){
						this.izsearchmanager = "N";
					}
					
					else if(this.izdesc.equals("Y") && s.equals("izdesc")){
						this.izdesc = "Y";
					}else if(this.izdesc.equals("N") && s.equals("izdesc")){
						this.izdesc = "N";
					}
					
					else if(this.izupuser.equals("Y") && s.equals("izupuser")){
						this.izupuser = "Y";
					}else if(this.izupuser.equals("N") && s.equals("izupuser")){
						this.izupuser = "N";
					}
					
					else if(this.izplan.equals("Y") && s.equals("izplan")){
						this.izplan = "Y";
					}else if(this.izplan.equals("N") && s.equals("izplan")){
						this.izplan = "N";
					}
					
					else if(this.izproject.equals("Y") && s.equals("izproject")){
						this.izproject = "Y";
					}else if(this.izproject.equals("N") && s.equals("izproject")){
						this.izproject = "N";
					}
					
					else if(this.izcustomtype.equals("Y") && s.equals("izcustomtype")){
						this.izcustomtype = "Y";
					}else if(this.izcustomtype.equals("N") && s.equals("izcustomtype")){
						this.izcustomtype = "N";
					}
					
					else if(this.izcustomlevel.equals("Y") && s.equals("izcustomlevel")){
						this.izcustomlevel = "Y";
					}else if(this.izcustomlevel.equals("N") && s.equals("izcustomlevel")){
						this.izcustomlevel = "N";
					}
					
					else if(this.izcustomname.equals("Y") && s.equals("izcustomname")){
						this.izcustomname = "Y";
					}else if(this.izcustomname.equals("N") && s.equals("izcustomname")){
						this.izcustomname = "N";
					}
					
					else if(this.izprojecttype.equals("Y") && s.equals("izprojecttype")){
						this.izprojecttype = "Y";
					}else if(this.izprojecttype.equals("N") && s.equals("izprojecttype")){
						this.izprojecttype = "N";
					}
					
					else if(this.iztaskrrom.equals("Y") && s.equals("iztaskrrom")){
						this.iztaskrrom = "Y";
					}else if(this.iztaskrrom.equals("N") && s.equals("iztaskrrom")){
						this.iztaskrrom = "N";
					}
					
					else if(this.iztaskstatus.equals("Y") && s.equals("iztaskstatus")){
						this.iztaskstatus = "Y";
					}else if(this.iztaskstatus.equals("N") && s.equals("iztaskstatus")){
						this.iztaskstatus = "N";
					}
					
					else if(this.izvisitpro.equals("Y") && s.equals("izvisitpro")){
						this.izvisitpro = "Y";
					}else if(this.izvisitpro.equals("N") && s.equals("izvisitpro")){
						this.izvisitpro = "N";
					}
					
					else if(this.izvisitcity.equals("Y") && s.equals("izvisitcity")){
						this.izvisitcity = "Y";
					}else if(this.izvisitcity.equals("N") && s.equals("izvisitcity")){
						this.izvisitcity = "N";
					}
					
					else if(this.izfirm.equals("Y") && s.equals("izfirm")){
						this.izfirm = "Y";
					}else if(this.izfirm.equals("N") && s.equals("izfirm")){
						this.izfirm = "N";
					}
					
					else if(this.izproductname.equals("Y") && s.equals("izproductname")){
						this.izproductname = "Y";
					}else if(this.izproductname.equals("N") && s.equals("izproductname")){
						this.izproductname = "N";
					}
					
					else if(this.izimgdownload.equals("Y") && s.equals("izimgdownload")){
						this.izimgdownload = "Y";
					}else if(this.izimgdownload.equals("N") && s.equals("izimgdownload")){
						this.izimgdownload = "N";
					}
					
					//拜访客户类型
					else if(this.izfiled2.equals("Y") && s.equals("izfiled2")){
						this.izfiled2 = "Y";
					}else if(this.izfiled2.equals("N") && s.equals("izfiled2")){
						this.izfiled2 = "N";
					}
					//拜访客户级别
					else if(this.izfield6.equals("Y") && s.equals("izfield6")){
						this.izfield6 = "Y";
					}else if(this.izfield6.equals("N") && s.equals("izfield6")){
						this.izfield6 = "N";
					}
					//拜访客户名称
					else if(this.izfield3.equals("Y") && s.equals("izfield3")){
						this.izfield3 = "Y";
					}else if(this.izfield3.equals("N") && s.equals("izfield3")){
						this.izfield3 = "N";
					}
					//拜访项目类别
					else if(this.izfield17.equals("Y") && s.equals("izfield17")){
						this.izfield17 = "Y";
					}else if(this.izfield17.equals("N") && s.equals("izfield17")){
						this.izfield17 = "N";
					}

				}
				
				//个性化以外的内容设置为不展示
				for(Map.Entry<String,String> entry:allSm.entrySet()){
					//是否展示分类
					if(entry.getKey().equals("izshow")){
						this.izshow = "N";
					}else if(entry.getKey().equals("izsimilarity")){
						this.izsimilarity = "N";
					}else if(entry.getKey().equals("izyear")){
						this.izyear = "N";
					}else if(entry.getKey().equals("izpicturetype")){
						this.izpicturetype = "N";
					}else if(entry.getKey().equals("izupload")){
						this.izupload = "N";
					}else if(entry.getKey().equals("izsearch")){
						this.izsearch = "N";
					}else if(entry.getKey().equals("izdesc")){
						this.izdesc = "N";
					}else if(entry.getKey().equals("izupuser")){
						this.izupuser = "N";
					}else if(entry.getKey().equals("izplan")){
						this.izplan = "N";
					}else if(entry.getKey().equals("izproject")){
						this.izproject = "N";
					}else if(entry.getKey().equals("izcustomtype")){
						this.izcustomtype = "N";
					}else if(entry.getKey().equals("izcustomlevel")){
						this.izcustomlevel = "N";
					}else if(entry.getKey().equals("izcustomname")){
						this.izcustomname = "N";
					}else if(entry.getKey().equals("iztaskrrom")){
						this.iztaskrrom = "N";
					}else if(entry.getKey().equals("iztaskstatus")){
						this.iztaskstatus = "N";
					}else if(entry.getKey().equals("izvisitpro")){
						this.izvisitpro = "N";
					}else if(entry.getKey().equals("izvisitcity")){
						this.izvisitcity = "N";
					}else if(entry.getKey().equals("izfirm")){
						this.izfirm = "N";
					}else if(entry.getKey().equals("izproductname")){
						this.izproductname = "N";
					}else if(entry.getKey().equals("izimgdownload")){
						this.izimgdownload = "N";
					}
					//拜访客户类型
					else if(entry.getKey().equals("izfiled2")){
						this.izfiled2 = "Y";
					}
					//拜访客户级别
					else if(entry.getKey().equals("izfield6")){
						this.izfield6 = "Y";
					}
					//拜访客户名称
					else if(entry.getKey().equals("izfield3")){
						this.izfield3 = "Y";
					}
					//拜访项目类别
					else if(entry.getKey().equals("izfield17")){
						this.izfield17 = "Y";
					}
				}
			}
			
		}
		
	}
}
