package cn.jyjz.xiaoyao.ocr.dataobject;

import cn.jyjz.xiaoyao.common.base.jsonDomain.DateNotimeSerializer;
import cn.jyjz.xiaoyao.common.mybatisplus.dto.BaseDto;
import cn.jyjz.xiaoyao.common.base.util.requestFormat.SearchQuery;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Map;
import java.util.AbstractMap.SimpleEntry;
import java.util.stream.Stream;
import java.util.stream.Collectors;
 
 

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Schema(name = "任务包", title = "任务包")
@TableName(value = "ocr_packagetask")
public class OcrPackagetask implements BaseDto,java.io.Serializable {
	
	private static final long serialVersionUID = -3500422812469364660L;
	@Schema(description = "主键")
	@TableId(value = "id",type = IdType.ASSIGN_ID)
	@JsonSerialize(using = ToStringSerializer.class)
	@TableField(value="ID")
	private Long id;
	
	@Schema(description = "创建人")
	@TableField(value="create_by")
	private String createBy;
	
	@Schema(description = "创建时间")
	@JsonSerialize(using = DateNotimeSerializer.class)
	@TableField(value="create_time")
	private Long createTime;
	
	@Schema(description = "修改人")
	@TableField(value="update_by")
	private String updateBy;
	
	@Schema(description = "修改时间")
	@JsonSerialize(using = DateNotimeSerializer.class)
	@TableField(value="update_time")
	private Long updateTime;
	
	@Schema(description = "租户ID")
	@JsonSerialize(using = ToStringSerializer.class)
	@TableField(value="tenant_id")
	private Long tenantId;
	
	@Schema(description = "任务包名称")
	@TableField(value="packagename")
	private String packagename;
	
	@Schema(description = "主图数量")
	@TableField(value="pictureno")
	private Integer pictureno;
	
	@Schema(description = "相似度，记录相似度内容")
	@TableField(value="similaritys")
	private String similaritys;
	
	@Schema(description = "筛选时间，记录筛选的内容")
	@TableField(value="searchtimes")
	private String searchtimes;


	//保存当前登录用户的数据权限范围的搜索条件
	@TableField(exist = false)
	@JsonIgnore
	private SearchQuery searchQueryrolesShowleave;

	@TableField(exist = false)
	@JsonIgnore
	private final Map<String,String> query = Stream.of(
		new SimpleEntry<>("listdept","deptid"),
		new SimpleEntry<>("ID","id"),
		new SimpleEntry<>("create_by","createBy"),
		new SimpleEntry<>("create_time","createTime"),
		new SimpleEntry<>("update_by","updateBy"),
		new SimpleEntry<>("update_time","updateTime"),
		new SimpleEntry<>("tenant_id","tenantId"),
		new SimpleEntry<>("packagename","packagename"),
		new SimpleEntry<>("pictureno","pictureno"),
		new SimpleEntry<>("similaritys","similaritys"),
		new SimpleEntry<>("searchtimes","searchtimes")
	)
	.collect(Collectors.toMap(SimpleEntry::getKey, SimpleEntry::getValue));
	@Override
	public String getQueryFiled(String filedname){
		String obj = null;
		if(null != query && query.size() > 0){
		obj = query.get(filedname);
		}
		return obj;
	}
}
