package cn.jyjz.xiaoyao.ocr.dataobject;

import cn.jyjz.xiaoyao.common.base.jsonDomain.DateNotimeSerializer;
import cn.jyjz.xiaoyao.common.base.jsonDomain.DateSerializer;
import cn.jyjz.xiaoyao.common.mybatisplus.dto.BaseDto;
import cn.jyjz.xiaoyao.common.base.util.requestFormat.SearchQuery;

import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.Map;
import java.util.AbstractMap.SimpleEntry;
import java.util.stream.Stream;
import java.util.stream.Collectors;



@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Schema(name = "图片信息表", title = "图片信息表")
@ApiModel(value="图片信息表", description="图片信息表")
@TableName(value = "ocr_picture")
public class OcrPicture implements BaseDto,java.io.Serializable {
	
	private static final long serialVersionUID = -10378331243377607L;
	@ApiModelProperty(value ="主键")
	@TableId(value = "id",type = IdType.ASSIGN_ID)
	@JsonSerialize(using = ToStringSerializer.class)
	@TableField(value="ID")
	private Long id;
	
	@ApiModelProperty(value ="创建人")
	@TableField(value="create_by")
	private String createBy;
	
	@ApiModelProperty(value ="创建时间")
	@TableField(value="create_time")
	@JsonSerialize(using = DateSerializer.class)
	private Long createTime;
	
	@ApiModelProperty(value ="修改人")
	@TableField(value="update_by")
	private String updateBy;
	
	@ApiModelProperty(value ="修改时间")
	@TableField(value="update_time")
	@JsonSerialize(using = DateSerializer.class)
	private Long updateTime;
	
	@ApiModelProperty(value ="分类表主键--通过“图片分类”字段做匹配，如果没有自动添加")
	@TableField(value="classificationid")
	private String classificationid;
	
	@ApiModelProperty(value ="图片类型--通过“AI图片分类接口获得”")
	@TableField(value="pictureclassid")
	private String pictureclassid;
	
	@Schema(description = "图片类型相似度，图片类型--通过“AI图片分类接口获得”")
	@TableField(value="pictureclassscores")
	private String pictureclassscores;
	
	@ApiModelProperty(value ="图片真假0:假，1：真")
	@TableField(value="iztrueorfalse",updateStrategy = FieldStrategy.IGNORED)
	private Integer iztrueorfalse;
	
	@ApiModelProperty(value ="选判真假原因id,从字典表中获得，其他时，当前字段为零")
	@TableField(value="judgeid",updateStrategy = FieldStrategy.IGNORED)
	@JsonSerialize(using = ToStringSerializer.class)
	private Long judgeid;
	
	@ApiModelProperty(value ="图片为假的其他原因，长度不超过50个汉字")
	@TableField(value="judgedesc",updateStrategy = FieldStrategy.IGNORED)
	private String judgedesc;
	
	@ApiModelProperty(value ="公司ID")
	@JsonSerialize(using = ToStringSerializer.class)
	@TableField(value="tenant_id")
	private Long tenantId;
	
	@ApiModelProperty(value ="公司状态")
	@TableField(value="tenantstatus")
	private String tenantstatus;
	
	@ApiModelProperty(value ="公司代码，第三方系统")
	@TableField(value="plantCode")
	private String plantcode;
	
	@ApiModelProperty(value ="公司名称")
	@TableField(value="tenantname")
	private String tenantname;
	
	@ApiModelProperty(value ="业务主体ID--图片主键")
	@TableField(value="pictureid")
	private String pictureid;
	
	@ApiModelProperty(value ="业务主体名称--图片成名")
	@TableField(value="picturename")
	private String picturename;
	
	@ApiModelProperty(value ="图片名称")
	@TableField(value="imgName")
	private String imgname;
	
	@ApiModelProperty(value ="图片地址")
	@TableField(value="imgUrl")
	private String imgurl;
	
	@ApiModelProperty(value ="业务主体状态")
	@TableField(value="picturestatus")
	private String picturestatus;
	
	@ApiModelProperty(value ="源项目id")
	@TableField(value="projectId")
	private String projectid;
	
	@ApiModelProperty(value ="项目名称")
	@TableField(value="projectIdName")
	private String projectidname;
	
	@ApiModelProperty(value ="项目状态")
	@TableField(value="projectstatus")
	private String projectstatus;
	
	@ApiModelProperty(value ="源计划id")
	@TableField(value="planId")
	private String planid;
	
	@ApiModelProperty(value ="计划名称")
	@TableField(value="planName")
	private String planname;
	
	@ApiModelProperty(value ="计划状态")
	@TableField(value="planstatus")
	private String planstatus;
	
	@ApiModelProperty(value ="所属子计划ID")
	@TableField(value="planchildid")
	private String planchildid;
	
	@ApiModelProperty(value ="所属子计划名称")
	@TableField(value="planchildname")
	private String planchildname;
	
	@ApiModelProperty(value ="所属子计划状态")
	@TableField(value="planchildstatus")
	private String planchildstatus;
	
	@ApiModelProperty(value ="上传时间")
	@JsonSerialize(using = DateNotimeSerializer.class)
	@TableField(value="upTime")
	private Long uptime;
	
	@ApiModelProperty(value ="生成时间")
	@JsonSerialize(using = DateNotimeSerializer.class)
	@TableField(value="genTime")
	private Long gentime;
	
	@ApiModelProperty(value ="色彩空间")
	@TableField(value="space")
	private String space;
	
	@ApiModelProperty(value ="来源")
	@TableField(value="source")
	private String source;
	
	@ApiModelProperty(value ="上报者头像--接口传送")
	@TableField(value="upHead")
	private String uphead;
	
	@ApiModelProperty(value ="上报人主键")
	@TableField(value="upuserid")
	private String upuserid;
	
	@ApiModelProperty(value ="上报者名称--接口传送")
	@TableField(value="upName")
	private String upname;
	
	@ApiModelProperty(value ="发布地区,拜访城市,城市名称，例如：北京市、天津市、石家庄市")
	@TableField(value="releaseArea")
	private String releasearea;
	
	@ApiModelProperty(value ="拜访省份")
	@TableField(value="releaseProvince")
	private String releaseprovince;
	
	@ApiModelProperty(value ="任务id")
	@TableField(value="remark")
	private String remark;
	
	@ApiModelProperty(value ="任务名称，源系统")
	@TableField(value="taskName")
	private String taskname;
	
	@ApiModelProperty(value ="是否已经生成任务,0：否，1：是")
	@TableField(value="taskstatus")
	private String taskstatus;
	
	@ApiModelProperty(value ="是否已经审批，0：未生成，1：审批中，2：已审批")
	@TableField(value="work_status")
	private String workStatus;
	
	@ApiModelProperty(value ="现项目ID")
	@TableField(value="categoryid")
	private Long categoryid;
	
	@ApiModelProperty(value ="任务-工单主键")
	@TableField(value="taskchildpictureid")
	private String taskchildpictureid;
	
	@ApiModelProperty(value ="提报人")
	@TableField(value="field1")
	private String field1;
	
	@ApiModelProperty(value ="拜访客户类型")
	@TableField(value="field2")
	private String field2;
	
	@ApiModelProperty(value ="拜访客户名称,终端名称，例如中日友好医院")
	@TableField(value="field3")
	private String field3;
	
	@ApiModelProperty(value ="任务来源")
	@TableField(value="field4")
	private String field4;
	
	@ApiModelProperty(value ="厂商")
	@TableField(value="field5")
	private String field5;
	
	@ApiModelProperty(value ="拜访客户级别")
	@TableField(value="field6")
	private String field6;
	
	@ApiModelProperty(value ="科室名称")
	@TableField(value="field7")
	private String field7;
	
	@ApiModelProperty(value ="拜访小结")
	@TableField(value="field8")
	private String field8;
	
	@ApiModelProperty(value ="产品名称")
	@TableField(value="field9")
	private String field9;
	
	@ApiModelProperty(value ="地区，定位信息，例如北京市朝阳区文苑路10号")
	@TableField(value="field10")
	private String field10;
	
	@ApiModelProperty(value ="拜访日期")
	@TableField(value="field11")
	private Long field11;
	
	@ApiModelProperty(value ="定位距离")
	@TableField(value="field12")
	private String field12;
	
	@ApiModelProperty(value ="病历号")
	@TableField(value="field13")
	private String field13;
	
	@ApiModelProperty(value ="是否重复")
	@TableField(value="field14")
	private String field14;
	
	@ApiModelProperty(value ="任务类型")
	@TableField(value="field15")
	private String field15;
	
	@ApiModelProperty(value ="任务状态")
	@TableField(value="field16")
	private String field16;
	
	
	@Schema(description = "拜访项目类别")
	@TableField(value="field17")
	private String field17;
	
	@Schema(description = "备用字段")
	@TableField(value="field18")
	private String field18;
	
	@ApiModelProperty(value = "图片查重的比对图片集合")
	@TableField(exist = false)
	private List<OcrPicture> listCom;
	
	@ApiModelProperty(value = "非历史图片主键集合")
	@TableField(exist = false)
	private List<String> picturecompareList;
	
	@ApiModelProperty(value = "图片对应的工单对象")
	@TableField(exist = false)
	private OcrTaskchildPicture ocrTaskchildPicture;
	
	@ApiModelProperty(value = "当前图片与参考图比对结果")
	//当前图片与参考图比对结果
	@TableField(exist = false)
	private String result;
	
	//图片分类
	@TableField(exist = false)
	private OcrPictureclass ocrPictureclass;
	
	//保存当前登录用户的数据权限范围的搜索条件
	@TableField(exist = false)
	@JsonIgnore
	private SearchQuery searchQueryrolesShowleave;

	@TableField(exist = false)
	@JsonIgnore
	private final Map<String,String> query = Stream.of(
		new SimpleEntry<>("ID","id"),
		new SimpleEntry<>("create_by","createBy"),
		new SimpleEntry<>("create_time","createTime"),
		new SimpleEntry<>("update_by","updateBy"),
		new SimpleEntry<>("update_time","updateTime"),
		new SimpleEntry<>("classificationid","classificationid"),
		new SimpleEntry<>("pictureclassid","pictureclassid"),
		new SimpleEntry<>("pictureclassscores","pictureclassscores"),
		new SimpleEntry<>("iztrueorfalse","iztrueorfalse"),
		new SimpleEntry<>("judgeid","judgeid"),
		new SimpleEntry<>("judgedesc","judgedesc"),
		new SimpleEntry<>("tenant_id","tenantId"),
		new SimpleEntry<>("tenantstatus","tenantstatus"),
		new SimpleEntry<>("plantCode","plantcode"),
		new SimpleEntry<>("tenantname","tenantname"),
		new SimpleEntry<>("pictureid","pictureid"),
		new SimpleEntry<>("picturename","picturename"),
		new SimpleEntry<>("imgName","imgname"),
		new SimpleEntry<>("imgUrl","imgurl"),
		new SimpleEntry<>("picturestatus","picturestatus"),
		new SimpleEntry<>("projectId","projectid"),
		new SimpleEntry<>("projectIdName","projectidname"),
		new SimpleEntry<>("projectstatus","projectstatus"),
		new SimpleEntry<>("planId","planid"),
		new SimpleEntry<>("planName","planname"),
		new SimpleEntry<>("planstatus","planstatus"),
		new SimpleEntry<>("planchildid","planchildid"),
		new SimpleEntry<>("planchildname","planchildname"),
		new SimpleEntry<>("planchildstatus","planchildstatus"),
		new SimpleEntry<>("upTime","uptime"),
		new SimpleEntry<>("genTime","gentime"),
		new SimpleEntry<>("space","space"),
		new SimpleEntry<>("source","source"),
		new SimpleEntry<>("upHead","uphead"),
		new SimpleEntry<>("upuserid","upuserid"),
		new SimpleEntry<>("upName","upname"),
		new SimpleEntry<>("releaseArea","releasearea"),
		new SimpleEntry<>("releaseProvince","releaseprovince"),
		new SimpleEntry<>("remark","remark"),
		new SimpleEntry<>("taskName","taskname"),
		new SimpleEntry<>("taskstatus","taskstatus"),
		new SimpleEntry<>("work_status","workStatus"),
		new SimpleEntry<>("categoryid","categoryid"),
		new SimpleEntry<>("taskchildpictureid","taskchildpictureid"),
		new SimpleEntry<>("field1","field1"),
		new SimpleEntry<>("field2","field2"),
		new SimpleEntry<>("field3","field3"),
		new SimpleEntry<>("field4","field4"),
		new SimpleEntry<>("field5","field5"),
		new SimpleEntry<>("field6","field6"),
		new SimpleEntry<>("field7","field7"),
		new SimpleEntry<>("field8","field8"),
		new SimpleEntry<>("field9","field9"),
		new SimpleEntry<>("field10","field10"),
		new SimpleEntry<>("field11","field11"),
		new SimpleEntry<>("field12","field12"),
		new SimpleEntry<>("field13","field13"),
		new SimpleEntry<>("field14","field14"),
		new SimpleEntry<>("field15","field15"),
		new SimpleEntry<>("field16","field16"),
		new SimpleEntry<>("field17","field17"),
		new SimpleEntry<>("field18","field18")
	)
	.collect(Collectors.toMap(SimpleEntry::getKey, SimpleEntry::getValue));
	@Override
	public String getQueryFiled(String filedname){
		String obj = null;
		if(null != query && query.size() > 0){
		obj = query.get(filedname);
		}
		return obj;
	}
}
