package cn.jyjz.xiaoyao.ocr.dataobject;

import cn.jyjz.xiaoyao.common.base.jsonDomain.DateNotimeSerializer;
import cn.jyjz.xiaoyao.common.base.jsonDomain.DateSerializer;
import cn.jyjz.xiaoyao.common.mybatisplus.dto.BaseDto;
import cn.jyjz.xiaoyao.common.base.util.requestFormat.SearchQuery;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Map;
import java.util.AbstractMap.SimpleEntry;
import java.util.stream.Stream;
import java.util.stream.Collectors;
 
 

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Schema(name = "子图", title = "子图")
@TableName(value = "ocr_picture_notes")
public class OcrPictureNotes implements BaseDto,java.io.Serializable {
	
	private static final long serialVersionUID = -7426400762142140889L;
	@Schema(description = "主键")
	@TableId(value = "id",type = IdType.ASSIGN_ID)
	@JsonSerialize(using = ToStringSerializer.class)
	@TableField(value="ID")
	private Long id;
	
	@Schema(description = "原图片主键")
	@TableField(value="pictureid")
	@JsonSerialize(using = ToStringSerializer.class)
	private Long pictureid;
	
	@Schema(description = "创建时间")
	@TableField(value="create_time")
	@JsonSerialize(using = DateSerializer.class)
	private Long createTime;
	
	@Schema(description = "修改时间")
	@TableField(value="update_time")
	@JsonSerialize(using = DateSerializer.class)
	private Long updateTime;
	
	@Schema(description = "备注内容")
	@TableField(value="notes")
	private String notes;
	
	@Schema(description = "图片名称")
	@TableField(value="imgName")
	private String imgname;
	
	@Schema(description = "图片地址")
	@TableField(value="imgUrl")
	private String imgurl;
	
	@Schema(description = "上传时间")
	@TableField(value="upTime")
	@JsonSerialize(using = DateNotimeSerializer.class)
	private Long uptime;
	
	@Schema(description = "生成时间")
	@TableField(value="genTime")
	@JsonSerialize(using = DateNotimeSerializer.class)
	private Long gentime;
	
	@Schema(description = "色彩空间")
	@TableField(value="space")
	private String space;
	
	@Schema(description = "来源")
	@TableField(value="source")
	private String source;
	
	@Schema(description = "上传者头像--接口传送")
	@TableField(value="upHead")
	private String uphead;
	
	@Schema(description = "上传者名称--接口传送")
	@TableField(value="upName")
	private String upname;
	
	@Schema(description = "发布地区")
	@TableField(value="releaseArea")
	private String releasearea;
	
	@Schema(description = "分类表主键--通过“图片分类”字段做匹配，如果没有自动添加")
	@TableField(value="classificationid")
	@JsonSerialize(using = ToStringSerializer.class)
	private Long classificationid;
	
	@Schema(description = "图片类型--通过“AI图片分类接口获得”")
	@TableField(value="pictureclassid")
	@JsonSerialize(using = ToStringSerializer.class)
	private Long pictureclassid;

	//保存当前登录用户的数据权限范围的搜索条件
	@TableField(exist = false)
	@JsonIgnore
	private SearchQuery searchQueryrolesShowleave;

	@TableField(exist = false)
	@JsonIgnore
	private final Map<String,String> query = Stream.of(
		new SimpleEntry<>("listdept","deptid"),
		new SimpleEntry<>("ID","id"),
		new SimpleEntry<>("pictureid","pictureid"),
		new SimpleEntry<>("create_time","createTime"),
		new SimpleEntry<>("update_time","updateTime"),
		new SimpleEntry<>("notes","notes"),
		new SimpleEntry<>("imgName","imgname"),
		new SimpleEntry<>("imgUrl","imgurl"),
		new SimpleEntry<>("upTime","uptime"),
		new SimpleEntry<>("genTime","gentime"),
		new SimpleEntry<>("space","space"),
		new SimpleEntry<>("source","source"),
		new SimpleEntry<>("upHead","uphead"),
		new SimpleEntry<>("upName","upname"),
		new SimpleEntry<>("releaseArea","releasearea"),
		new SimpleEntry<>("classificationid","classificationid"),
		new SimpleEntry<>("pictureclassid","pictureclassid")
	)
	.collect(Collectors.toMap(SimpleEntry::getKey, SimpleEntry::getValue));
	@Override
	public String getQueryFiled(String filedname){
		String obj = null;
		if(null != query && query.size() > 0){
		obj = query.get(filedname);
		}
		return obj;
	}
}
