package cn.jyjz.xiaoyao.ocr.dataobject;

import cn.jyjz.xiaoyao.admin.dataobject.Tenant;
import cn.jyjz.xiaoyao.common.base.jsonDomain.DateNotimeSerializer;
import cn.jyjz.xiaoyao.common.base.jsonDomain.DateSerializer;
import cn.jyjz.xiaoyao.common.mybatisplus.dto.BaseDto;
import cn.jyjz.xiaoyao.common.base.util.requestFormat.SearchQuery;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Map;
import java.util.AbstractMap.SimpleEntry;
import java.util.stream.Stream;
import java.util.stream.Collectors;
 
 

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Schema(name = "图片类型表", title = "图片类型表")
@TableName(value = "ocr_picturetype")
public class OcrPicturetype implements BaseDto,java.io.Serializable {
	
	private static final long serialVersionUID = -8397167347516537770L;
	@Schema(description = "主键")
	@TableId(value = "id",type = IdType.ASSIGN_ID)
	@JsonSerialize(using = ToStringSerializer.class)
	@TableField(value="ID")
	private Long id;
	
	@Schema(description = "创建人")
	@TableField(value="CREATEBY")
	private String createby;
	
	@Schema(description = "创建时间")
	@JsonSerialize(using = DateSerializer.class)
	@TableField(value="CREATETIME")
	private Long createtime;
	
	@Schema(description = "修改人")
	@TableField(value="UPDATEBY")
	private String updateby;
	
	@Schema(description = "修改时间")
	@JsonSerialize(using = DateSerializer.class)
	@TableField(value="UPDATETIME")
	private Long updatetime;
	
	@Schema(description = "租户ID")
	@JsonSerialize(using = ToStringSerializer.class)
	@TableField(value="TENANTID")
	private Long tenantid;
	
	@Schema(description = "父节点，默认为0，表示根")
	@JsonSerialize(using = ToStringSerializer.class)
	@TableField(value="PID")
	private Long pid;
	
	@Schema(description = "是否有子节点")
	@TableField(value="HASCHILD")
	private String haschild;
	
	@Schema(description = "图片类型名称")
	@TableField(value="TYPENAME")
	private String typename;
	
	@Schema(description = "排序字段")
	@TableField(value="REORDER")
	private Integer reorder;
	
	//租户对象
	@TableField(exist = false)
	private Tenant tenant;
	
	//保存当前登录用户的数据权限范围的搜索条件
	@TableField(exist = false)
	@JsonIgnore
	private SearchQuery searchQueryrolesShowleave;

	@TableField(exist = false)
	@JsonIgnore
	private final Map<String,String> query = Stream.of(
		new SimpleEntry<>("ID","id"),
		new SimpleEntry<>("CREATEBY","createby"),
		new SimpleEntry<>("CREATETIME","createtime"),
		new SimpleEntry<>("UPDATEBY","updateby"),
		new SimpleEntry<>("UPDATETIME","updatetime"),
		new SimpleEntry<>("TENANTID","tenantid"),
		new SimpleEntry<>("PID","pid"),
		new SimpleEntry<>("HASCHILD","haschild"),
		new SimpleEntry<>("TYPENAME","typename"),
		new SimpleEntry<>("REORDER","reorder")
	)
	.collect(Collectors.toMap(SimpleEntry::getKey, SimpleEntry::getValue));
	@Override
	public String getQueryFiled(String filedname){
		String obj = null;
		if(null != query && query.size() > 0){
		obj = query.get(filedname);
		}
		return obj;
	}
}
