package cn.jyjz.xiaoyao.ocr.dataobject;

import cn.jyjz.xiaoyao.common.base.jsonDomain.DateNotimeSerializer;
import cn.jyjz.xiaoyao.common.base.jsonDomain.DateSerializer;
import cn.jyjz.xiaoyao.common.mybatisplus.dto.BaseDto;
import cn.jyjz.xiaoyao.common.base.util.requestFormat.SearchQuery;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Map;
import java.util.AbstractMap.SimpleEntry;
import java.util.stream.Stream;
import java.util.stream.Collectors;
 
 

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Schema(name = "提报人管理", title = "提报人管理")
@TableName(value = "ocr_upuser")
public class OcrUpuser implements BaseDto,java.io.Serializable {
	
	private static final long serialVersionUID = 2809984041577736011L;
	@Schema(description = "主键")
	@TableId(value = "id",type = IdType.ASSIGN_ID)
	@JsonSerialize(using = ToStringSerializer.class)
	@TableField(value="ID")
	private Long id;
	
	@Schema(description = "创建人")
	@TableField(value="create_by")
	private String createBy;
	
	@Schema(description = "创建时间")
	@JsonSerialize(using = DateSerializer.class)
	@TableField(value="create_time")
	private Long createTime;
	
	@Schema(description = "修改人")
	@TableField(value="update_by")
	private String updateBy;
	
	@Schema(description = "修改时间")
	@JsonSerialize(using = DateSerializer.class)
	@TableField(value="update_time")
	private Long updateTime;
	
	@Schema(description = "租户ID")
	@JsonSerialize(using = ToStringSerializer.class)
	@TableField(value="tenant_id")
	private Long tenantId;
	
	@Schema(description = "源系统提报人主键")
	@TableField(value="upuserid")
	private String upuserid;
	
	@Schema(description = "提报人名称")
	@TableField(value="upname")
	private String upname;

	//保存当前登录用户的数据权限范围的搜索条件
	@TableField(exist = false)
	@JsonIgnore
	private SearchQuery searchQueryrolesShowleave;

	@TableField(exist = false)
	@JsonIgnore
	private final Map<String,String> query = Stream.of(
		new SimpleEntry<>("listdept","deptid"),
		new SimpleEntry<>("ID","id"),
		new SimpleEntry<>("create_by","createBy"),
		new SimpleEntry<>("create_time","createTime"),
		new SimpleEntry<>("update_by","updateBy"),
		new SimpleEntry<>("update_time","updateTime"),
		new SimpleEntry<>("tenant_id","tenantId"),
		new SimpleEntry<>("upuserid","upuserid"),
		new SimpleEntry<>("upname","upname")
	)
	.collect(Collectors.toMap(SimpleEntry::getKey, SimpleEntry::getValue));
	@Override
	public String getQueryFiled(String filedname){
		String obj = null;
		if(null != query && query.size() > 0){
		obj = query.get(filedname);
		}
		return obj;
	}
}
