package cn.jyjz.xiaoyao.ocr.dataobject;

import cn.jyjz.xiaoyao.common.base.jsonDomain.DateNotimeSerializer;
import cn.jyjz.xiaoyao.common.base.jsonDomain.DateSerializer;
import cn.jyjz.xiaoyao.common.mybatisplus.dto.BaseDto;
import cn.jyjz.xiaoyao.common.base.util.requestFormat.SearchQuery;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.Map;
import java.util.AbstractMap.SimpleEntry;
import java.util.stream.Stream;
import java.util.stream.Collectors;
 
 

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Schema(name = "个人过滤条件", title = "个人过滤条件")
@TableName(value = "ocr_usersearch")
public class OcrUsersearch implements BaseDto,java.io.Serializable {
	
	private static final long serialVersionUID = 3214150960755020489L;
	@Schema(description = "主键")
	@TableId(value = "id",type = IdType.ASSIGN_ID)
	@JsonSerialize(using = ToStringSerializer.class)
	@TableField(value="ID")
	private Long id;
	
	@Schema(description = "创建人")
	@TableField(value="CREATEBY")
	private String createby;
	
	@Schema(description = "创建时间")
	@JsonSerialize(using = DateSerializer.class)
	@TableField(value="CREATETIME")
	private Long createtime;
	
	@Schema(description = "修改人")
	@TableField(value="UPDATEBY")
	private String updateby;
	
	@Schema(description = "修改时间")
	@JsonSerialize(using = DateSerializer.class)
	@TableField(value="UPDATETIME")
	private Long updatetime;
	
	@Schema(description = "租户ID--通过公司代码做匹配")
	@JsonSerialize(using = ToStringSerializer.class)
	@TableField(value="TENANTID")
	private Long tenantid;
	
	@Schema(description = "所属用户主键")
	@JsonSerialize(using = ToStringSerializer.class)
	@TableField(value="USERID")
	private Long userid;
	
	@Schema(description = "筛选名称")
	@TableField(value="SEARCHNAME")
	private String searchname;
	
	@Schema(description = "排序字段")
	@TableField(value="REORDER")
	private Integer reorder;
	
	@Schema(description = "是否置顶，默认为0，表示不置顶")
	@TableField(value="IZTOP")
	private Integer iztop;
	
	@TableField(exist = false)
	private List<OcrUsersearchchild> ocrUsersearchchildList;

	//保存当前登录用户的数据权限范围的搜索条件
	@TableField(exist = false)
	@JsonIgnore
	private SearchQuery searchQueryrolesShowleave;

	@TableField(exist = false)
	@JsonIgnore
	private final Map<String,String> query = Stream.of(
		new SimpleEntry<>("ID","id"),
		new SimpleEntry<>("CREATEBY","createby"),
		new SimpleEntry<>("CREATETIME","createtime"),
		new SimpleEntry<>("UPDATEBY","updateby"),
		new SimpleEntry<>("UPDATETIME","updatetime"),
		new SimpleEntry<>("TENANTID","tenantid"),
		new SimpleEntry<>("USERID","userid"),
		new SimpleEntry<>("SEARCHNAME","searchname"),
		new SimpleEntry<>("REORDER","reorder"),
		new SimpleEntry<>("IZTOP","iztop")
	)
	.collect(Collectors.toMap(SimpleEntry::getKey, SimpleEntry::getValue));
	@Override
	public String getQueryFiled(String filedname){
		String obj = null;
		if(null != query && query.size() > 0){
		obj = query.get(filedname);
		}
		return obj;
	}
}
