package cn.jyjz.xiaoyao.ocr.dataobject;

import cn.jyjz.xiaoyao.common.mybatisplus.dto.BaseDto;
import cn.jyjz.xiaoyao.common.base.util.requestFormat.SearchQuery;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import java.util.Map;
import java.util.AbstractMap.SimpleEntry;
import java.util.stream.Stream;
import java.util.stream.Collectors;
 
 

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Schema(name = "个人过滤条件子表", title = "个人过滤条件子表")
@TableName(value = "ocr_usersearchchild")
public class OcrUsersearchchild implements BaseDto,java.io.Serializable {
	
	private static final long serialVersionUID = 6404860339470764341L;
	@Schema(description = "主键")
	@TableId(value = "id",type = IdType.ASSIGN_ID)
	@JsonSerialize(using = ToStringSerializer.class)
	@TableField(value="ID")
	private Long id;
	
	@Schema(description = "过滤条件主表主键")
	@TableField(value="usersearchid")
	private Long usersearchid;
	
	@Schema(description = "过滤内容，搜索的字段名称")
	@TableField(value="searchfield")
	private String searchfield;
	
	@Schema(description = "比较类型")
	@TableField(value="searchtype")
	private String searchtype;
	
	@Schema(description = "比较内容，如果是多个使用英文逗号分隔")
	@TableField(value="searchvalue")
	private String searchvalue;

	//保存当前登录用户的数据权限范围的搜索条件
	@TableField(exist = false)
	@JsonIgnore
	private SearchQuery searchQueryrolesShowleave;

	@TableField(exist = false)
	@JsonIgnore
	private final Map<String,String> query = Stream.of(
		new SimpleEntry<>("listdept","deptid"),
		new SimpleEntry<>("ID","id"),
		new SimpleEntry<>("usersearchid","usersearchid"),
		new SimpleEntry<>("searchfield","searchfield"),
		new SimpleEntry<>("searchtype","searchtype"),
		new SimpleEntry<>("searchvalue","searchvalue")
	)
	.collect(Collectors.toMap(SimpleEntry::getKey, SimpleEntry::getValue));
	@Override
	public String getQueryFiled(String filedname){
		String obj = null;
		if(null != query && query.size() > 0){
		obj = query.get(filedname);
		}
		return obj;
	}
}
