package cn.jyjz.xiaoyao.ocr.service;

import java.io.Serializable;
import java.util.Collection;
import java.util.List;

import cn.jyjz.xiaoyao.common.base.vo.ResultVo;
import cn.jyjz.xiaoyao.common.base.vo.UserToken;
import cn.jyjz.xiaoyao.common.mybatisplus.base.BaseService;
import cn.jyjz.xiaoyao.ocr.dataobject.OcrPicture;
import cn.jyjz.xiaoyao.ocr.dataobject.OcrPictureNotes;
import cn.jyjz.xiaoyao.ocr.dataobject.OcrPicturejob;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.Wrapper;

import javax.servlet.http.HttpServletRequest;

/**
* 业务层
*/
public interface OcrPictureService extends BaseService<OcrPicture>  {
    
    
    List<OcrPicture> listPage(Wrapper<OcrPicture> queryWrapper);
    
    /**
     * 保存接口传来的json数据
     * @param jsonArray
     * @return
     */
    public List<OcrPicture> savePicture(JSONObject jsonArray);
    
    public ResultVo createTaskChild(List<OcrPicture> ocrPictureList, String tenantId , UserToken sysUser, String search_month, HttpServletRequest req, String buessinessno);
    
    /**
     * 查询工单图片信息
     * @param tenantId
     * @param createuser
     * @return
     */
    public List<OcrPicture> listByTaskChild(String tenantId,String createuser,String isclose,String tasktype,String packageid);
    
    /**
     * 查询工单图片信息
     * @return
     */
    public List<OcrPicture> listByTaskChild(List<String> pictureid);
    
    /**
     * 添加一对多
     *
     * @param ocrPicture
     * @param ocrPicturejobList
     * @param ocrPictureNotesList
     */
    public void saveMain(OcrPicture ocrPicture, List<OcrPicturejob> ocrPicturejobList, List<OcrPictureNotes> ocrPictureNotesList) ;
    
    /**
     * 修改一对多
     *
     * @param ocrPicture
     * @param ocrPicturejobList
     * @param ocrPictureNotesList
     */
    public void updateMain(OcrPicture ocrPicture,List<OcrPicturejob> ocrPicturejobList,List<OcrPictureNotes> ocrPictureNotesList);
    
    /**
     * 删除一对多
     *
     * @param id
     */
    public void delMain (String id);
    
    /**
     * 批量删除一对多
     *
     * @param idList
     */
    public void delBatchMain (Collection<? extends Serializable> idList);
    
    
}
