package cn.jyjz.xiaoyao.ocr.service;

import java.util.List;
import java.util.Map;

import cn.jyjz.xiaoyao.common.base.param.ParamterPage;
import cn.jyjz.xiaoyao.common.base.vo.ResultVo;
import cn.jyjz.xiaoyao.common.base.vo.UserToken;
import cn.jyjz.xiaoyao.common.mybatisplus.base.BaseService;
import cn.jyjz.xiaoyao.ocr.dataobject.OcrPicture;
import cn.jyjz.xiaoyao.ocr.dataobject.OcrTaskchildPicture;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springframework.web.bind.annotation.RequestParam;

/**
* 业务层
*/
public interface OcrTaskchildPictureService extends BaseService<OcrTaskchildPicture>  {
    
    public List<OcrTaskchildPicture> listAll(String tenantId, String createUser, QueryWrapper queryWrapper);
    
    /**
     * 批量标记当前任务相似度为百分之百
     * @param taskids 任务主键
     * @return
     */
    public boolean markPoint(List<Long> taskids);
    
    /**
     * 查询智能识别
     * @param packageid 任务包主键
     * @return
     */
    public List<OcrTaskchildPicture> markpoint(String  packageid);
    
    /**
     * 判断任务是否已经审批
     * @param formid 任务主键
     * @return
     */
    public boolean validateApprove(String[] formid);
    
    /**
     * 判断当前用户是否可以审批
     * @param formid 任务主键
     * @param userToken
     * @return
     */
    public boolean validateAssignee(String[] formid,UserToken userToken);
    
    /**
     * 根据主键，查询图片详情
     * @param fromid 任务主键
     * @return
     */
    public OcrTaskchildPicture listPicturePackageId(String fromid,Long packageid);
    /**
     * 根据任务包主键，查询对应的任务信息
     * @param taskchildpictureid 当前显示的任务主键
     * @param queryWrapper
     * @return
     */
    public IPage<OcrTaskchildPicture> listByPackageId(String taskchildpictureid, ParamterPage paramterPage, QueryWrapper queryWrapper,String orderbyname,String orderbyvalue,String packageid,String tenantId );

    /**
     * 图片真假设置
     * @param childpictureid
     * @return
     */
    public ResultVo trueorfalse(String childpictureid, String packageid, String iztrueorfalse, String judgeid, String judgedesc);
    
    public ResultVo clearmark(String childpictureid, String packageid);
    /**
     * 图片是否合格设置
     * @param childpictureid
     * @return
     */
    public boolean pass(String childpictureid,OcrTaskchildPicture ocrTaskchildPicture);
    
    /**
     * 关闭工单
     * @param id
     * @return
     */
    public boolean closeOrder(String id);
    
    /**
     * 生成工单
     * @param ocrPicture 源图
     * @param tenantId 公司主键
     * @param sysUser 当前登录用户
     * @param packageid 任务包主键
     */
    public OcrTaskchildPicture create(OcrPicture ocrPicture, String tenantId , UserToken sysUser, Long packageid,String buessinessno);
    
    /**
     * 查询所有业务表集合
     * @param query
     * @return
     */
    public List<OcrTaskchildPicture> listFinal(Map<String, Object> query);
    
    /**
     * 根据任务\工单主键查询图片对象
     * @param taskchildid
     * @return
     */
    public OcrPicture findOcrPictureByTaskchildid(String taskchildid);
    
    /**
     * 查询所有业务表数量
     * @param query
     * @return
     */
    Long listFinalCount(Map<String, Object> query);
}
