package cn.jyjz.xiaoyao.ocr.service.impl;

import cn.jyjz.xiaoyao.ocr.dataDao.OcrAreaMybatisDao;
import cn.jyjz.xiaoyao.ocr.dataobject.OcrArea;
import cn.jyjz.xiaoyao.ocr.dataobject.OcrPlan;
import cn.jyjz.xiaoyao.ocr.service.OcrAreaService;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import cn.jyjz.xiaoyao.common.mybatisplus.base.BaseServiceImpl;
import lombok.extern.slf4j.Slf4j;
import java.util.List;
/**
* 业务层实现
*/
@Service
@Slf4j
public class OcrAreaServiceImpl extends BaseServiceImpl<OcrAreaMybatisDao, OcrArea>  implements OcrAreaService {
	@Autowired
	private OcrAreaMybatisDao ocrareamybatisdao;
	
	/**
	 * 查询所有数据，无分页
	 *
	 * @param queryWrapper
	 * @return List<OcrArea>
	 */
	public List<OcrArea> queryListNoPage(QueryWrapper<OcrArea> queryWrapper){
		Long count = ocrareamybatisdao.selectCount(queryWrapper);
		
		Page<OcrArea> page = new Page(1,count);
		page.setMaxLimit(count);
		
		IPage<OcrArea> iPage = this.page(page,queryWrapper);
		return iPage.getRecords();
	}
}
