package cn.jyjz.xiaoyao.ocr.service.impl;

import cn.jyjz.flowable.domain.vo.FlowInstanceVo;
import cn.jyjz.flowable.service.IFlowInstanceService;
import cn.jyjz.xiaoyao.abase.service.SeqManageService;
import cn.jyjz.xiaoyao.admin.service.LogService;
import cn.jyjz.xiaoyao.common.base.vo.ResultVo;
import cn.jyjz.xiaoyao.common.base.vo.ResultVoUtil;
import cn.jyjz.xiaoyao.common.base.vo.UserToken;
import cn.jyjz.xiaoyao.oa.from.dataobject.Category;
import cn.jyjz.xiaoyao.oa.from.service.CategoryService;
import cn.jyjz.xiaoyao.ocr.dataDao.OcrPictureMybatisDao;
import cn.jyjz.xiaoyao.ocr.dataobject.*;
import cn.jyjz.xiaoyao.ocr.service.*;
import cn.jyjz.xiaoyao.ocr.util.ImageClassUtil;
import cn.jyjz.xiaoyao.ocr.util.SearchEnum;
import cn.jyjz.xiaoyao.ocr.util.httputil.HttpClient;
import cn.jyjz.xiaoyao.ocr.util.httputil.HttpHeader;
import cn.jyjz.xiaoyao.ocr.util.httputil.HttpParamers;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.commons.lang3.StringUtils;
import org.apache.poi.hpsf.Decimal;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import cn.jyjz.xiaoyao.common.mybatisplus.base.BaseServiceImpl;
import lombok.extern.slf4j.Slf4j;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.io.Serializable;
import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
/**
* 业务层实现
*/
@Service
@Slf4j
public class OcrPictureServiceImpl extends BaseServiceImpl<OcrPictureMybatisDao, OcrPicture>  implements OcrPictureService {
	@Resource
	private OcrPictureMybatisDao ocrpicturemybatisdao;
	
	@Resource
	private OcrPicturejobService ocrPicturejobService;
	@Resource
	private OcrPictureNotesService ocrPictureNotesService;
	
	@Resource
	private OcrPackagetaskService ocrPackagetaskService;
	@Resource
	private LogService logService;
	@Autowired
	private SeqManageService seqManageService;
	@Resource
	private OcrTaskchildPictureService ocrTaskchildPictureService;
	@Resource
	IFlowInstanceService flowInstanceService;
	@Resource
	private CategoryService categoryService;
	public ResultVo createTaskChild(List<OcrPicture> ocrPictureList, String tenantId , UserToken sysUser, String search_month, HttpServletRequest request, String buessinessno){
		
		//图片错误信息
		StringBuffer error = new StringBuffer();
		//项目错误信息
		StringBuffer errorProject = new StringBuffer();
		//流程错误信息
		StringBuffer errorFlow = new StringBuffer();
		
		//记录任务相似度为百分百的任务主键
		List<Long> pointsList = new ArrayList<>();
		//图片信息不能为空
		if(null != ocrPictureList && !ocrPictureList.isEmpty()){
			//生成任务包
			//String packageName = seqManageService.getSeqNextNo("AI任务包");
			
			//TODO 相似度、图片查询时间未传
			
			//创建任务包
			OcrPackagetask ocrPackagetask = this.ocrPackagetaskService.create(buessinessno,tenantId,sysUser);
			
			if(null == ocrPackagetask){
				return ResultVoUtil.error("失败。");
			}
			
			//用于标记相似度是否存在百分百的情况
			
			List<OcrPicture> newList = new ArrayList<>();
			for(OcrPicture ocrPicture:ocrPictureList){
				
				//如果当前图片已经生成任务包，直接跳过
				if(ocrPicture.getTaskstatus().equals("1")){
					continue;
				}
				
				
				//图片查重的比对图片集合
				List<OcrPicture> compareList = new ArrayList<>();
				
				//非历史图片主键集合
				List<String> picturecompareList = new ArrayList<>();
				
				boolean havePoint = false;
				//二次遍历进行比对
				for(OcrPicture ocrPictureNext:ocrPictureList){
					
					if(ocrPictureNext.getId().longValue() == ocrPicture.getId().longValue()){
						continue;
					}
					
	
					//TODO 接口请求判断重复情况
					logService.addLog(103,"AI获取图片相似度接口", sysUser, "sendParams");
					
					
					JSONObject jsonObjectSimi = ImageClassUtil.getSimilarity(ocrPicture.getImgurl(),
							ocrPictureNext.getImgurl(),
							null);
					System.out.println("responseDataXs--code = [" + jsonObjectSimi.get("code") + "]");
					System.out.println("responseDataXs--similarity = [" + jsonObjectSimi.get("similarity") + "]");
					
					String resultValue = "";
					
					//返回内容为零，表示成功，否则表示失败
					if(null != jsonObjectSimi && jsonObjectSimi.getString("code").equals("0")){
						
						resultValue = jsonObjectSimi.getString("similarity");
						ocrPictureNext.setResult(resultValue);
					}else{
						resultValue = "0";
						ocrPictureNext.setResult(resultValue);
					}
					
					BigDecimal b1 = new BigDecimal(resultValue);
					BigDecimal b2 = new BigDecimal("100");
					int val = b1.compareTo(b2);
					if(val == 0){
						havePoint = true;
					}
					
					//如果当前图片未生成任务需要临时保存
					if(ocrPictureNext.getTaskstatus().equals("0")){
						picturecompareList.add(ocrPictureNext.getId().toString());
					}
					
					compareList.add(ocrPictureNext);
				}
				bubbleSortOpt(compareList);
				//从大到小进行排序
				ocrPicture.setListCom(compareList);
				
				//非历史图片主键集合
				ocrPicture.setPicturecompareList(picturecompareList);
				
				//查询项目对象
				if(null == ocrPicture.getCategoryid()){
					//TODO 没有对应项目，返回提示信息
					if(null != error && error.length() > 1){
						error.append("," + ocrPicture.getImgname());
					}else{
						error.append(ocrPicture.getImgname());
					}
					continue;
				}
				Category category = categoryService.getById(ocrPicture.getCategoryid());
				if(null == category){
					if(null != errorProject && errorProject.length() > 1){
						errorProject.append("," + ocrPicture.getImgname());
					}else {
						errorProject.append(ocrPicture.getImgname());
					}
					continue;
				}else if(StringUtils.isBlank(category.getProcessdefinitionid())){
					if(null != errorFlow && errorFlow.length() > 1){
						errorFlow.append("," + category.getCategoryname());
					}else {
						errorFlow.append(category.getCategoryname());
					}
					continue;
				}
				
				//创建工单,如果创建成功，增加标志，用于过滤条件使用
				OcrTaskchildPicture ocrTaskchildPicture = this.ocrTaskchildPictureService.create(ocrPicture,tenantId,sysUser,ocrPackagetask.getId(),buessinessno);
				if(null != ocrTaskchildPicture){
					
					//发起流程
					flowInstanceService.startProcessInstanceById(
							category.getProcessdefinitionid(),
							null,
							request,
							ocrTaskchildPicture.getId().toString(),
							category.getServicename()
					);
					
					if(havePoint){
						pointsList.add(ocrTaskchildPicture.getId());
					}
					
					//TODO 需要测试
					ocrPicture.setTaskchildpictureid(ocrTaskchildPicture.getId().toString());
					ocrPicture.setWorkStatus("1");
					this.updateById(ocrPicture);
				}
				
				newList.add(ocrPicture);
			}
			
			//批量更新 pointsList 主键相似度为百分百的数据
			if(null != pointsList && !pointsList.isEmpty()){
				this.ocrTaskchildPictureService.markPoint(pointsList);
			}
			
			
			if(StringUtils.isNotBlank(search_month)){
				if(StringUtils.isNotBlank(search_month) && Integer.parseInt(search_month) <= 12 && Integer.parseInt(search_month) > 0){
					
					ocrPackagetask.setSearchtimes(SearchEnum.getName(Integer.parseInt(search_month)));
				}else if(StringUtils.isNotBlank(search_month) && Integer.parseInt(search_month) > 20){
					ocrPackagetask.setSearchtimes(SearchEnum.getName((Integer.parseInt(search_month) - 20)));
				}
			}
			ocrPackagetask.setPictureno(ocrPictureList.size());
			this.ocrPackagetaskService.updateById(ocrPackagetask);
			
			//原主图设置为任务包已经生成
			for(OcrPicture ocrPicture:newList){
				ocrPicture.setTaskstatus("1");
				this.updateById(ocrPicture);
			}
			
			if(StringUtils.isBlank(error) && StringUtils.isBlank(errorProject) && StringUtils.isBlank(errorFlow)){
				return ResultVoUtil.success();
			}else{
				
				String msg = (StringUtils.isBlank(error))?"":error.toString() + "，图片没有对应项目，无法查重。";
				msg = msg + ((StringUtils.isBlank(errorProject))?"":errorProject.toString() + "，图片没有对应项目，无法查重。");
				msg = msg + ((StringUtils.isBlank(errorFlow))?"":errorFlow.toString() + "，项目没有配置审批流程，无法查重。");
				return ResultVoUtil.success(msg);
			}
			
			
		}
		return ResultVoUtil.error("失败。");
	}
	public void bubbleSortOpt(List<OcrPicture> compareList) {
		
		if(null == compareList) {
			return;
		}
		OcrPicture temp = null;
		for(int i = 0; i < compareList.size() - 1; i++) {
			for(int j = 0; j < compareList.size() - i - 1; j++) {
				if(Double.parseDouble(compareList.get(j).getResult()) < Double.parseDouble(compareList.get(j + 1).getResult())) {
					temp = compareList.get(j);
					compareList.set(j,compareList.get(j + 1));
					compareList.set((j + 1),temp);
				}
			}
		}
	}
	/**
	 * 保存接口传来的json数据
	 * @param jsonArray
	 * @return
	 */
	public List<OcrPicture> savePicture(JSONObject jsonArray){
		List<OcrPicture> list = new ArrayList<>();
		
		
		return list;
	}
	public List<OcrPicture> listPage( Wrapper<OcrPicture> queryWrapper){
		
		long count = this.count(queryWrapper);
		
		Page<OcrPicture> ocrPicturePage = new Page<>(1,count);
		ocrPicturePage.setMaxLimit(count);
		IPage<OcrPicture> iPage = this.page(ocrPicturePage,queryWrapper);
		
		return iPage.getRecords();
	}
	
	public List<OcrPicture> listByTaskChild(String tenantId,String createuser,String isclose,String tasktype,String packageid){
		
		List<OcrPicture> resultPicture = new ArrayList<>();
		
		QueryWrapper queryWrapper = new QueryWrapper();
		queryWrapper.eq("TENANTID",tenantId);
		if(StringUtils.isNotBlank(createuser)){
			queryWrapper.eq("CREATEUSER",createuser);
		}
		
		if(StringUtils.isNotBlank(isclose)){
			queryWrapper.eq("IZCLOSE",isclose);
		}
		
		if(StringUtils.isNotBlank(tasktype)){
			queryWrapper.eq("TASKTYPE",tasktype);
		}
		
		if(StringUtils.isNotBlank(packageid)){
			queryWrapper.eq("PACKAGEID",packageid);
		}
		
		//查询工单/任务集合
		List<OcrTaskchildPicture> list = ocrTaskchildPictureService.listAll(tenantId,createuser,queryWrapper);
		for(OcrTaskchildPicture ocrTaskchildPicture:list){
			OcrPicture ocrPicture = view(ocrTaskchildPicture);
			if(null != ocrPicture){
				resultPicture.add(view(ocrTaskchildPicture));
			}
		}
		
		return resultPicture;
		
	}
	
	/**
	 * 查询工单图片信息
	 * @return
	 */
	public List<OcrPicture> listByTaskChild(List<String> pictureidlist){
		List<OcrPicture> resultPicture = new ArrayList<>();
		//查询工单集合
		QueryWrapper queryWrapper = new QueryWrapper();
		queryWrapper.in("pictureid",pictureidlist);
		
		long count = this.ocrTaskchildPictureService.count(queryWrapper);
		
		Page<OcrTaskchildPicture> page = new Page<>(1, count);
		page.setMaxLimit(count);
		
		IPage<OcrTaskchildPicture> iPage = this.ocrTaskchildPictureService.page(page,queryWrapper);
		
		List<OcrTaskchildPicture> list = iPage.getRecords();
		for(OcrTaskchildPicture ocrTaskchildPicture:list){
			OcrPicture ocrPicture = view(ocrTaskchildPicture);
			if(null != ocrPicture){
				resultPicture.add(view(ocrTaskchildPicture));
			}
		}
		
		return resultPicture;
	}
	
	/**
	 * 查询工单下的图片以及查重结果
	 * @param ocrTaskchildPicture
	 * @return
	 */
	public OcrPicture view(OcrTaskchildPicture ocrTaskchildPicture){
		
		//参照图
		OcrPicture ocrPicture = this.getById(ocrTaskchildPicture.getPictureid());
		
		ocrPicture.setOcrTaskchildPicture(ocrTaskchildPicture);
		
		//图片比对结果
		String result = ocrTaskchildPicture.getPictureresult();
		String[] comResult = result.split(",");
		
		//比较图
		List<OcrPicture> listCom = null;
		
		//判断查重图片是否为空
		if(StringUtils.isNotBlank(ocrTaskchildPicture.getOcpictureid())){
			//图片比较数量不确定
			
			QueryWrapper queryWrapper = new QueryWrapper();
			queryWrapper.in("id",ocrTaskchildPicture.getOcpictureid().split(","));
			
			long count = this.count(queryWrapper);
			
			Page<OcrPicture> ocrPicturePage = new Page<>(1,count);
			ocrPicturePage.setMaxLimit(count);
			
			IPage<OcrPicture> iPage = this.page(ocrPicturePage,queryWrapper);
			
			int tempco = 0;
			for(OcrPicture ocrPicture1:iPage.getRecords()){
				
				//比对结果
				if(null != comResult && comResult.length > 0){
					ocrPicture1.setResult(comResult[tempco]);
				}
				tempco++;
			}
			
			listCom = iPage.getRecords();
			
			ocrPicture.setListCom(listCom);
			
			return ocrPicture;
			
		}
		
		return null;
	}
	
	@Override
	@Transactional(rollbackFor = Exception.class)
	public void saveMain(OcrPicture ocrPicture, List<OcrPicturejob> ocrPicturejobList, List<OcrPictureNotes> ocrPictureNotesList) {
		ocrpicturemybatisdao.insert(ocrPicture);
		if(ocrPicturejobList!=null && ocrPicturejobList.size()>0) {
			for(OcrPicturejob entity:ocrPicturejobList) {
				//外键设置
				entity.setPictureid(ocrPicture.getId());
				ocrPicturejobService.save(entity);
			}
		}
		if(ocrPictureNotesList!=null && ocrPictureNotesList.size()>0) {
			for(OcrPictureNotes entity:ocrPictureNotesList) {
				//外键设置
				entity.setPictureid(ocrPicture.getId());
				ocrPictureNotesService.save(entity);
			}
		}
	}
	
	@Override
	@Transactional(rollbackFor = Exception.class)
	public void updateMain(OcrPicture ocrPicture,List<OcrPicturejob> ocrPicturejobList,List<OcrPictureNotes> ocrPictureNotesList) {
		ocrpicturemybatisdao.updateById(ocrPicture);
		
		//1.先删除子表数据
		ocrPicturejobService .deleteByMainId(ocrPicture.getId().toString());
		ocrPictureNotesService.deleteByMainId(ocrPicture.getId().toString());
		
		//2.子表数据重新插入
		if(ocrPicturejobList!=null && ocrPicturejobList.size()>0) {
			for(OcrPicturejob entity:ocrPicturejobList) {
				//外键设置
				entity.setPictureid(ocrPicture.getId());
				ocrPicturejobService.save(entity);
			}
		}
		if(ocrPictureNotesList!=null && ocrPictureNotesList.size()>0) {
			for(OcrPictureNotes entity:ocrPictureNotesList) {
				//外键设置
				entity.setPictureid(ocrPicture.getId());
				ocrPictureNotesService.save(entity);
			}
		}
	}
	
	@Override
	@Transactional(rollbackFor = Exception.class)
	public void delMain(String id) {
		ocrPicturejobService.deleteByMainId(id);
		ocrPictureNotesService.deleteByMainId(id);
		ocrpicturemybatisdao.deleteById(id);
	}
	
	@Override
	@Transactional(rollbackFor = Exception.class)
	public void delBatchMain(Collection<? extends Serializable> idList) {
		for(Serializable id:idList) {
			ocrPicturejobService.deleteByMainId(id.toString());
			ocrPictureNotesService.deleteByMainId(id.toString());
			ocrpicturemybatisdao.deleteById(id);
		}
	}
	
	
}
