package cn.jyjz.xiaoyao.ocr.service.impl;

import cn.jyjz.xiaoyao.ocr.dataDao.OcrPlanMybatisDao;
import cn.jyjz.xiaoyao.ocr.dataobject.OcrPlan;
import cn.jyjz.xiaoyao.ocr.dataobject.OcrUpuser;
import cn.jyjz.xiaoyao.ocr.service.OcrPlanService;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import cn.jyjz.xiaoyao.common.mybatisplus.base.BaseServiceImpl;
import lombok.extern.slf4j.Slf4j;
import java.util.List;
/**
* 业务层实现
*/
@Service
@Slf4j
public class OcrPlanServiceImpl extends BaseServiceImpl<OcrPlanMybatisDao, OcrPlan>  implements OcrPlanService {
	@Autowired
	private OcrPlanMybatisDao ocrplanmybatisdao;
	/**
	 * 查询所有数据，无分页
	 *
	 * @param queryWrapper
	 * @return List<OcrPlan>
	 */
	public List<OcrPlan> queryListNoPage(QueryWrapper<OcrPlan> queryWrapper){
		
		Long count = ocrplanmybatisdao.selectCount(queryWrapper);
		
		Page<OcrPlan> page = new Page(1,count);
		page.setMaxLimit(count);
		
		IPage<OcrPlan> iPage = this.page(page,queryWrapper);
		return iPage.getRecords();
	}
}
