package cn.jyjz.xiaoyao.ocr.service.impl;

import cn.jyjz.flowable.common.SystemConstantsOa;
import cn.jyjz.flowable.service.IFlowTaskService;
import cn.jyjz.xiaoyao.common.base.param.ParamterPage;
import cn.jyjz.xiaoyao.common.base.vo.ResultVo;
import cn.jyjz.xiaoyao.common.base.vo.ResultVoUtil;
import cn.jyjz.xiaoyao.common.base.vo.UserToken;
import cn.jyjz.xiaoyao.common.mybatisplus.util.SearchQueryFormat;
import cn.jyjz.xiaoyao.ocr.dataDao.OcrTaskchildPictureMybatisDao;
import cn.jyjz.xiaoyao.ocr.dataobject.OcrPicture;
import cn.jyjz.xiaoyao.ocr.dataobject.OcrTaskchildPicture;
import cn.jyjz.xiaoyao.ocr.service.OcrPictureService;
import cn.jyjz.xiaoyao.ocr.service.OcrTaskchildPictureService;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.commons.lang3.StringUtils;
import org.flowable.task.api.Task;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import cn.jyjz.xiaoyao.common.mybatisplus.base.BaseServiceImpl;
import lombok.extern.slf4j.Slf4j;

import javax.annotation.Resource;
import java.util.*;

/**
* 业务层实现
*/
@Service("ocrTaskchildPictureService")
@Slf4j
public class OcrTaskchildPictureServiceImpl extends BaseServiceImpl<OcrTaskchildPictureMybatisDao, OcrTaskchildPicture>  implements OcrTaskchildPictureService {
	@Resource
	private OcrTaskchildPictureMybatisDao ocrtaskchildpicturemybatisdao;
	
	@Resource
	private OcrPictureService ocrPictureService;
	
	@Resource
	IFlowTaskService iFlowTaskService;
	/**
	 * 图片真假设置
	 * @param childpictureids
	 * @return
	 */
	public ResultVo trueorfalse(String childpictureids, String packageid, String iztrueorfalse, String judgeid, String judgedesc){
		
		String[] cps = childpictureids.split(",");
		
		List<OcrPicture> saveList =new ArrayList<>();
		
		StringBuffer historyPname = new StringBuffer();
		
		StringBuffer taskType = new StringBuffer();
		for(String childpictureid:cps){
			OcrTaskchildPicture old = this.listPicturePackageId(childpictureid,Long.parseLong(packageid));
			
			//如果是历史图片，不允许进行设置
			if(old.isIzHistory()){
				if(historyPname.length() > 0){
					historyPname.append("," + old.getOcrPicture().getImgname());
				}else{
					historyPname.append(old.getOcrPicture().getImgname());
				}
			}
			if(old.getStates().intValue() == 3 || old.getStates().intValue() == 5) {
				if(taskType.length() > 0){
					taskType.append("," + old.getOcrPicture().getImgname());
				}else{
					taskType.append(old.getOcrPicture().getImgname());
				}
			}
			
			OcrPicture ocrPicture = old.getOcrPicture();
			ocrPicture.setJudgeid(Long.parseLong(judgeid));
			ocrPicture.setJudgedesc(judgedesc);
			ocrPicture.setIztrueorfalse(Integer.parseInt(iztrueorfalse));
			ocrPicture.setUpdateTime(System.currentTimeMillis());
			
			saveList.add(ocrPicture);
		}
		
		if(StringUtils.isNotBlank(historyPname.toString())){
			return ResultVoUtil.error(historyPname.toString() + "为历史数据，不能标记。");
		}
		else if(StringUtils.isNotBlank(taskType.toString())){
			return ResultVoUtil.error( taskType.toString() + "已经审批，不能标记。");
		}
		
		return this.ocrPictureService.updateBatchById(saveList)?ResultVoUtil.success():ResultVoUtil.error();
	}
	
	public ResultVo clearmark(String childpictureids, String packageid){
		String[] cps = childpictureids.split(",");
		
		List<OcrPicture> saveList =new ArrayList<>();
		
		StringBuffer historyPname = new StringBuffer();
		
		StringBuffer taskType = new StringBuffer();
		for(String childpictureid:cps){
			OcrTaskchildPicture old = this.listPicturePackageId(childpictureid,Long.parseLong(packageid));
			
			//如果是历史图片，不允许进行设置
			if(old.isIzHistory()){
				if(historyPname.length() > 0){
					historyPname.append("," + old.getOcrPicture().getImgname());
				}else{
					historyPname.append(old.getOcrPicture().getImgname());
				}
			}
			if(old.getStates().intValue() == 3 || old.getStates().intValue() == 5) {
				if(taskType.length() > 0){
					taskType.append("," + old.getOcrPicture().getImgname());
				}else{
					taskType.append(old.getOcrPicture().getImgname());
				}
			}
			
			OcrPicture ocrPicture = old.getOcrPicture();
			ocrPicture.setJudgeid(null);
			ocrPicture.setJudgedesc(null);
			ocrPicture.setIztrueorfalse(null);
			ocrPicture.setUpdateTime(System.currentTimeMillis());
			
			saveList.add(ocrPicture);
		}
		
		if(StringUtils.isNotBlank(historyPname.toString())){
			return ResultVoUtil.error(historyPname.toString() + "为历史数据，不能清除标记。");
		}
		else if(StringUtils.isNotBlank(taskType.toString())){
			return ResultVoUtil.error( taskType.toString() + "已经审批，不能清除标记。");
		}
		
		return this.ocrPictureService.updateBatchById(saveList)?ResultVoUtil.success():ResultVoUtil.error();
	}
	
	/**
	 * 图片是否合格设置
	 * @param childpictureid
	 * @return
	 */
	public boolean pass(String childpictureid,OcrTaskchildPicture ocrTaskchildPicture){
		OcrTaskchildPicture old = this.getById(childpictureid);
		
		//判断当前图片是否在任务包中，如果不在任务保重，不允许设置图片真假
		if(!old.getPackageid().equals(ocrTaskchildPicture.getPackageid())){
			return false;
		}
//
//		//更新图片真假
//		if(StringUtils.isNotBlank(ocrTaskchildPicture.getIzpass())){
//			old.setIzpass(ocrTaskchildPicture.getIzpass());
//		}
//		if(null != ocrTaskchildPicture.getJudgepass()){
//			old.setJudgepass(ocrTaskchildPicture.getJudgepass());
//		}
//		if(StringUtils.isNotBlank(ocrTaskchildPicture.getPicturecompare())){
//			old.setPicturecompare(ocrTaskchildPicture.getPicturecompare());
//		}
		
		old.setUpdatetime(System.currentTimeMillis());
		
		return this.updateById(old);
	}
	
	/**
	 * 判断当前用户是否可以审批
	 * @param formid 任务主键
	 * @param userToken
	 * @return
	 */
	public boolean validateAssignee(String[] formid,UserToken userToken){
		QueryWrapper queryWrapper = new QueryWrapper();
		queryWrapper.in("ID",formid);
		List<OcrTaskchildPicture> list = this.ocrtaskchildpicturemybatisdao.selectList(queryWrapper);
		
		//目前没有做其他信息返回，如果需要再做修改
		for(OcrTaskchildPicture ocrTaskchildPicture:list){
			//判断审批人是否为当前登录用户
			if(userToken.getLoginname().equals(ocrTaskchildPicture.getAssignee())){
			
			}else{
				return false;
			}
		}
		return true;
	}
	
	/**
	 * 判断任务是否已经审批
	 * @param formid 任务主键
	 * @return
	 */
	public boolean validateApprove(String[] formid){
		QueryWrapper queryWrapper = new QueryWrapper();
		queryWrapper.in("ID",formid);
		List<OcrTaskchildPicture> list = this.ocrtaskchildpicturemybatisdao.selectList(queryWrapper);
		
		//目前没有做其他信息返回，如果需要再做修改
		for(OcrTaskchildPicture ocrTaskchildPicture:list){
			//判断当前审批状态为拒绝或者通过的，不允许再做审批
			if(ocrTaskchildPicture.getStates().intValue() == SystemConstantsOa.OA_STATUS_TYPE_END
					|| ocrTaskchildPicture.getStates().intValue() == SystemConstantsOa.OA_STATUS_TYPE_REFUSE ){
				return false;
			}else{
			
			}
		}
		return true;
	}

	@Override
	public List<OcrTaskchildPicture> listAll(String tenantId, String createUser, QueryWrapper queryWrapper){
		
		
		long count = this.count(queryWrapper);
		
		Page<OcrTaskchildPicture> page = new Page<>(1, count);
		page.setMaxLimit(count);
		
		IPage<OcrTaskchildPicture> iPage = this.page(page,queryWrapper);
		
		return iPage.getRecords();
	}
	
	/**
	 * 批量标记当前任务相似度为百分之百
	 * @param taskids 任务主键
	 * @return
	 */
	public boolean markPoint(List<Long> taskids){
		UpdateWrapper updateWrapper = new UpdateWrapper();
		updateWrapper.set("HAVEPOINTS",1);
		updateWrapper.in("ID",taskids);
		
		return this.update(updateWrapper);
	}

	/**
	 * 查询智能识别
	 * @param packageid 任务包主键
	 * @return
	 */
	public List<OcrTaskchildPicture>  markpoint(String  packageid){
		QueryWrapper<OcrTaskchildPicture> queryWrapperNew = new QueryWrapper<>();
		queryWrapperNew.eq("HAVEPOINTS","1");
		queryWrapperNew.eq("PACKAGEID",packageid);
		
		List<OcrTaskchildPicture> list = this.ocrtaskchildpicturemybatisdao.selectList(queryWrapperNew);
		this.formatTask(list,packageid);
		
		return list;
	}
	
	/**
	 * 根据主键，查询图片详情
	 * @param fromid 任务主键
	 * @return
	 */
	public OcrTaskchildPicture listPicturePackageId(String fromid,Long packageid){
		OcrTaskchildPicture ocrTaskchildPicture = this.getById(fromid);
		//查询图片对象
		OcrPicture ocrPicture = this.ocrPictureService.selectDtoById(ocrTaskchildPicture.getPictureid());
		
//		String pictureids = ocrTaskchildPicture.getPicturecompare();
//		String[] splitPictureids = pictureids.split(",");
//		List<String> listPictureids = Arrays.asList(splitPictureids);
//		//设置是否为历史信息
//		ocrTaskchildPicture.setIzHistory(listPictureids.contains(ocrPicture.getPictureid())?false:true);
		
		//如果当前任务的任务包主键一致，说明不是历史数据，如果不一致，说明是历史数据
		if(packageid.toString().equals(ocrTaskchildPicture.getPackageid().toString())){
			ocrTaskchildPicture.setIzHistory(false);
		}else{
			ocrTaskchildPicture.setIzHistory(true);
		}
		
		//查询审批流节点信息
		List<Task> taskList = iFlowTaskService.nowRunTask(ocrTaskchildPicture.getProcessinstanceid(),ocrTaskchildPicture.getProcessdefinitionid());
		if(null != taskList && !taskList.isEmpty()) {
			ocrTaskchildPicture.setTaskId(taskList.get(0).getId());
		}
		
		//获取当前真假标记
		ocrTaskchildPicture.setIztrueorfalse(ocrPicture.getIztrueorfalse());
		//是否已经审批
		ocrTaskchildPicture.setWorkStatus(ocrPicture.getWorkStatus());
		
		
		ocrTaskchildPicture.setOcrPicture(ocrPicture);
		
		return ocrTaskchildPicture;
	}
	/**
	 * 根据任务包主键，查询对应的任务信息
	 * @param taskchildpictureid 当前显示的任务主键
	 * @param queryWrapper
	 * @return
	 */
	public IPage<OcrTaskchildPicture> listByPackageId(String taskchildpictureid, ParamterPage paramterPage,QueryWrapper queryWrapper,String orderbyname,String orderbyvalue,String packageid,String tenantId ){
		Page<OcrTaskchildPicture> page = new Page<>(paramterPage.getStart(), paramterPage.getPagesize());
		
		//当前显示的任务对象
		OcrTaskchildPicture mainOcrTaskchildPicture = this.getById(taskchildpictureid);
		
		//判断当前图片是否为历史图片
		if(!packageid.equals(mainOcrTaskchildPicture.getPackageid().toString())){
			
			QueryWrapper<OcrTaskchildPicture> queryWrapperNew = new QueryWrapper<>();
			queryWrapperNew.eq("TENANTID",tenantId);
			queryWrapperNew.eq("PACKAGEID",packageid);
			
			//查询非历史图片存在的集合
			IPage<OcrTaskchildPicture> pageNew = this.selectSearchListPage(paramterPage,queryWrapperNew);
			
			//如果是历史图片，从非历史图片存在的集合中随机选取一个
			if(!pageNew.getRecords().isEmpty()){
				mainOcrTaskchildPicture = pageNew.getRecords().get(0);
			}
			
		}
		
		//不包含当前选中的图片
		queryWrapper.ne("ID",taskchildpictureid);
		
		queryWrapper.eq("TENANTID",tenantId);
		if(StringUtils.isNotBlank(orderbyname) && orderbyname.equals("asc")){
			if(StringUtils.isNotBlank(orderbyvalue) && orderbyvalue.equals("pictureResult")){
				queryWrapper.orderByAsc("FIELD(PICTUREID,"+ mainOcrTaskchildPicture.getOcpictureid() +")");
			}else if(StringUtils.isNotBlank(orderbyvalue) && orderbyvalue.equals("fromuptime")){
				queryWrapper.orderByAsc("FROMUPTIME");
			}
			
		}else if(StringUtils.isNotBlank(orderbyname) && orderbyname.equals("desc")){
			
			if(StringUtils.isNotBlank(orderbyvalue)  && orderbyvalue.equals("pictureResult")){
				queryWrapper.orderByDesc("FIELD(PICTUREID,"+ mainOcrTaskchildPicture.getOcpictureid() +")");
			}else if(StringUtils.isNotBlank(orderbyvalue) && orderbyvalue.equals("fromuptime")){
				queryWrapper.orderByDesc("FROMUPTIME");
			}
			
		}else{
			queryWrapper.in("PICTUREID",mainOcrTaskchildPicture.getOcpictureid().split(","));
		}
		
		
		IPage<OcrTaskchildPicture> iPage = this.page(page,queryWrapper);
		
		this.formatTask(iPage.getRecords(),packageid);
		
		
		return iPage;
	}
	
	/**
	 * 格式化显示数据
	 * @param list
	 * @param packageid
	 */
	private void formatTask(List<OcrTaskchildPicture> list,String packageid){
		for(OcrTaskchildPicture ocrTaskchildPicture:list){
			
			//查询审批流节点信息
			List<Task> taskList = iFlowTaskService.nowRunTask(ocrTaskchildPicture.getProcessinstanceid(),ocrTaskchildPicture.getProcessdefinitionid());
			if(null != taskList && !taskList.isEmpty()) {
				ocrTaskchildPicture.setTaskId(taskList.get(0).getId());
			}
//			//非历史图片主键集合
//			String pictureids = ocrTaskchildPicture.getPicturecompare();
//			String[] splitPictureids = pictureids.split(",");
//			List<String> listPictureids = Arrays.asList(splitPictureids);
//			//设置是否为历史信息
//			ocrTaskchildPicture.setIzHistory(listPictureids.contains(ocrTaskchildPicture.getPictureid())?false:true);
			
			//如果当前任务的任务包主键一致，说明不是历史数据，如果不一致，说明是历史数据
			if(packageid.equals(ocrTaskchildPicture.getPackageid().toString())){
				ocrTaskchildPicture.setIzHistory(false);
			}else{
				ocrTaskchildPicture.setIzHistory(true);
			}
			
			
			OcrPicture ocrPicture = this.ocrPictureService.selectDtoById(ocrTaskchildPicture.getPictureid());
			//获取当前真假标记
			ocrTaskchildPicture.setIztrueorfalse(ocrPicture.getIztrueorfalse());
			//是否已经审批
			ocrTaskchildPicture.setWorkStatus(ocrPicture.getWorkStatus());
			
			ocrTaskchildPicture.setOcrPicture(ocrPicture);
		}
	}
	
	/**
	 * 关闭工单
	 * @param id
	 * @return
	 */
	public boolean closeOrder(String id){
		OcrTaskchildPicture ocrTaskchildPicture = this.getById(id);
		if(null != ocrTaskchildPicture){
//			ocrTaskchildPicture.setIzclose("0");
			return this.updateById(ocrTaskchildPicture);
		}
		return false;
	}
	
	/**
	 * 生成工单
	 * @param ocrPicture 源图
	 * @param tenantId 公司主键
	 * @param sysUser 当前登录用户
	 */
	public OcrTaskchildPicture create(OcrPicture ocrPicture, String tenantId , UserToken sysUser, Long packageid,String buessinessno){

		OcrTaskchildPicture ocrTaskchildPicture = new OcrTaskchildPicture();
		ocrTaskchildPicture.setBuessinessno(buessinessno);
		ocrTaskchildPicture.setFromtaskid(ocrPicture.getRemark());
		ocrTaskchildPicture.setFromtaskname(ocrPicture.getTaskname());
		ocrTaskchildPicture.setPictureid(ocrPicture.getId());
		ocrTaskchildPicture.setTenantid(Long.parseLong(tenantId));
		ocrTaskchildPicture.setCreateuser(sysUser.getLoginname());
		ocrTaskchildPicture.setCreateusername(sysUser.getUsername());
		ocrTaskchildPicture.setCreatedate(System.currentTimeMillis());
		ocrTaskchildPicture.setPackageid(packageid);
		ocrTaskchildPicture.setCategoryid(ocrPicture.getCategoryid());
		
		ocrTaskchildPicture.setFromsourceid(ocrPicture.getField4());
		ocrTaskchildPicture.setFromuptime(ocrPicture.getUptime());
		ocrTaskchildPicture.setFromplanid(ocrPicture.getPlanid());
		ocrTaskchildPicture.setFromprojectid(ocrPicture.getProjectid());
		ocrTaskchildPicture.setFromuserid(ocrPicture.getUpuserid());
		
		StringBuffer pcid = new StringBuffer();
		StringBuffer result = new StringBuffer();
		for(OcrPicture comp:ocrPicture.getListCom()){
			if(null == pcid || pcid.toString().length() < 1){
				pcid.append(comp.getId());
				result.append(comp.getResult());
			}else{
				pcid.append("," + comp.getId());
				result.append("," + comp.getResult());
			}
		}
		
		ocrTaskchildPicture.setOcpictureid(pcid.toString());
		ocrTaskchildPicture.setPictureresult(result.toString());
		ocrTaskchildPicture.setPicturecompare(String.join(",",ocrPicture.getPicturecompareList()));
		
		return this.save(ocrTaskchildPicture)?ocrTaskchildPicture:null;
	}
	
	/**
	 * 查询所有业务表集合
	 * @param query
	 * @return
	 */
	public List<OcrTaskchildPicture> listFinal(Map<String, Object> query){
		
		return this.ocrtaskchildpicturemybatisdao.listFinal(query);
	}
	
	
	/**
	 * 根据任务\工单主键查询图片对象
	 * @param taskchildid
	 * @return
	 */
	public OcrPicture findOcrPictureByTaskchildid(String taskchildid){
		OcrTaskchildPicture ocrTaskchildPicture = this.ocrtaskchildpicturemybatisdao.selectById(taskchildid);
		
		if(null == ocrTaskchildPicture){
			return null;
		}
		
		OcrPicture ocrPicture = ocrPictureService.selectDtoById(ocrTaskchildPicture.getPictureid());
		
		return ocrPicture;
	}
	
	/**
	 * 查询所有业务表数量
	 * @param query
	 * @return
	 */
	public Long listFinalCount(Map<String, Object> query){
		return this.ocrtaskchildpicturemybatisdao.listFinalCount(query);
	}
}
