package cn.jyjz.xiaoyao.ocr.service.impl;

import cn.jyjz.xiaoyao.ocr.dataDao.OcrUpuserMybatisDao;
import cn.jyjz.xiaoyao.ocr.dataobject.OcrPictureclass;
import cn.jyjz.xiaoyao.ocr.dataobject.OcrUpuser;
import cn.jyjz.xiaoyao.ocr.service.OcrUpuserService;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import cn.jyjz.xiaoyao.common.mybatisplus.base.BaseServiceImpl;
import lombok.extern.slf4j.Slf4j;
import java.util.List;
/**
* 业务层实现
*/
@Service
@Slf4j
public class OcrUpuserServiceImpl extends BaseServiceImpl<OcrUpuserMybatisDao, OcrUpuser>  implements OcrUpuserService {
	@Autowired
	private OcrUpuserMybatisDao ocrupusermybatisdao;
	/**
	 * 查询所有数据，无分页
	 *
	 * @param queryWrapper
	 * @return List<OcrPictureclass>
	 */
	public List<OcrUpuser> queryListNoPage(QueryWrapper<OcrUpuser> queryWrapper){
		
		Long count = ocrupusermybatisdao.selectCount(queryWrapper);
		
		Page<OcrUpuser> page = new Page(1,count);
		page.setMaxLimit(count);
		
		IPage<OcrUpuser> iPage = this.page(page,queryWrapper);
		return iPage.getRecords();
	}
}
