package cn.jyjz.xiaoyao.ocr.service.impl;

import cn.jyjz.xiaoyao.ocr.dataDao.OcrUsersearchMybatisDao;
import cn.jyjz.xiaoyao.ocr.dataobject.OcrUsersearch;
import cn.jyjz.xiaoyao.ocr.service.OcrUsersearchService;
import cn.jyjz.xiaoyao.ocr.service.OcrUsersearchchildService;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import cn.jyjz.xiaoyao.common.mybatisplus.base.BaseServiceImpl;
import lombok.extern.slf4j.Slf4j;

import javax.annotation.Resource;
import java.util.Arrays;
import java.util.List;
/**
* 业务层实现
*/
@Service
@Slf4j
public class OcrUsersearchServiceImpl extends BaseServiceImpl<OcrUsersearchMybatisDao, OcrUsersearch>  implements OcrUsersearchService {
	@Resource
	private OcrUsersearchMybatisDao ocrusersearchmybatisdao;
	
	@Resource
	private OcrUsersearchchildService ocrUsersearchchildService;
	public boolean removeByIds(String ids){
		this.ocrusersearchmybatisdao.deleteBatchIds(Arrays.asList(ids.split(",")));
		
		QueryWrapper queryWrapper = new QueryWrapper();
		queryWrapper.in("usersearchid",Arrays.asList(ids.split(",")));
		
		return this.ocrUsersearchchildService.remove(queryWrapper);
	}
	
	/**
	 * 删除个人过滤含子表
	 * @param ids
	 * @return
	 */
	public boolean removeChildByIds(String ids){
		QueryWrapper queryWrapper = new QueryWrapper();
		queryWrapper.in("usersearchid",Arrays.asList(ids.split(",")));
		
		return this.ocrUsersearchchildService.remove(queryWrapper);
	}
	
	/**
	 * 获取当前个人过滤的最大排序字段
	 * @param userid
	 * @return
	 */
	public int getReorder(Long userid){
		QueryWrapper queryWrapper = new QueryWrapper();
		queryWrapper.eq("USERID",userid);
		queryWrapper.orderByDesc("REORDER");
		
		List<OcrUsersearch> list = this.ocrusersearchmybatisdao.selectList(queryWrapper);
		
		if(null == list || list.isEmpty()){
			return 1;
		}else{
			return (list.get(0).getReorder() + 3);
		}
	
	}
}
