package cn.jyjz.xiaoyao.ocr.util;

import cn.jyjz.xiaoyao.ocr.util.httputil.HttpClient;
import cn.jyjz.xiaoyao.ocr.util.httputil.HttpHeader;
import cn.jyjz.xiaoyao.ocr.util.httputil.HttpParamers;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ImageClassUtil {
    private static Logger logger = LoggerFactory.getLogger(ImageClassUtil.class);
    /**
     * 相似度检查
     * 接口文档
     * https://console-docs.apipost.cn/preview/b85e3fe97510f177/96421d73df6c7f7d
     * @param imgurl
     * @param baseurl
     * @return
     */
    public static JSONObject getSimilarity(String imgurl,String baseurl,String serverurl){
        if(StringUtils.isBlank(serverurl)){
            serverurl = "http://47.93.3.37/api/similarity/";
        }

        JSONObject jsonObjectXs = new JSONObject();
        jsonObjectXs.put("imgUrl",imgurl);
        jsonObjectXs.put("baseUrl",baseurl);

        HttpParamers paramersXs = HttpParamers.httpPostParamers();
        paramersXs.setJsonParamer(jsonObjectXs.toJSONString());
        HttpHeader headerXs = null;
        String responseDataXs = "";
        try {
            responseDataXs = HttpClient.doService(serverurl, paramersXs, headerXs, 15000, 30000);
        } catch (Exception e) {
            logger.error("similarity={}",e);
            return null;
        }
        JSONObject jsonObject = JSON.parseObject(responseDataXs);
        return jsonObject;
    }
    
    /**
     * 类型检查
     * 接口文档
     * https://console-docs.apipost.cn/preview/7add2088a9a191d5/874020cbfba4287b
     * @param imgurl
     * @param taskId
     * @return
     */
    public static JSONObject getClassify(String imgurl,String taskId,String serverurl){
        if(StringUtils.isBlank(serverurl)){
            serverurl = "http://47.93.3.37/api/classify/";
        }
    
        //类型检查
        JSONObject jsonObjectVi = new JSONObject();
        jsonObjectVi.put("taskId",taskId);
        JSONArray jsonArrayVi = new JSONArray();
        jsonArrayVi.add(imgurl);
        jsonObjectVi.put("imgUrls",jsonArrayVi);

        HttpParamers paramersVi = HttpParamers.httpPostParamers();
        paramersVi.setJsonParamer(jsonObjectVi.toJSONString());
        HttpHeader headerVi = null;
        String responseDataVi = "";
        try {
            responseDataVi = HttpClient.doService(serverurl, paramersVi, headerVi, 15000, 30000);
        } catch (Exception e) {
            logger.error("classify={}",e);
            return null;
        }
    
        JSONObject jsonObject = JSON.parseObject(responseDataVi);
        return jsonObject;
    }
}
