package cn.jyjz.xiaoyao.ocr.util;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.apache.commons.lang3.StringUtils;

import javax.servlet.http.HttpServletRequest;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

public enum SearchConfigEnum {
    
    //所属项目
    PROJECT("izproject","projectIdName"),
    //拜访客户类型
    FILED2("izfiled2","field2"),
    //拜访客户级别
    FILED6("izfield6","field6"),
    //拜访客户名称
    FILED3("izfield3","field3"),
    //任务来源
    FIELD4("iztaskrrom","field4"),
    //任务状态
    FIELD16("iztaskstatus","field16"),
    //拜访省份/直辖市、
    PROCINCE("izvisitpro","releaseprovince"),
    //厂商
    FIELD5("izfirm","field5"),
    //产品名称
    FIELD9("izproductname","field9"),
    //拜访项目类别
    FIELD17("izfield17","field17"),
    
    //所属项目、拜访客户类型、拜访客户级别、拜访客户名称、拜访项目类别、任务来源、任务状态、拜访省份/直辖市、、厂商、产品名称、
    //提报人
    UPUSERSEARCH("izUpuser","upName"),
    //所属计划
    PLANSEARCH("izPlan","planName"),
    //相似度
    SIMISEARCH("izSimilarity","pictureresult"),
    //分类搜索
    CLASSISEARCH("izShow","classificationid"),

    //是否展示年份
    YEARSEARCH("izYear","upTime"),
    //图片类型
    TYPESEARCH("izPicturetype","pictureclassid"),
    //发布地区、拜访城市
    AREASEARCH("izArea","releaseArea"),
    
    THREEWEEKdd("izYeardddd","upTime");
    private String id;
    private String meaning;
    
    SearchConfigEnum(String id, String meaning) {
        this.id = id;
        this.meaning = meaning;
    }
    public static String getName(String id) {
        for (SearchConfigEnum c : SearchConfigEnum.values()) {
            if (c.getId().equals(id))  {
                return c.meaning;
            }
        }
        return null;
    }
    
    public String getId() {
        return id;
    }
    
    public void setId(String id) {
        this.id = id;
    }
    
    public String getMeaning() {
        return meaning;
    }
    
    public void setMeaning(String meaning) {
        this.meaning = meaning;
    }
    
    /**
     * 格式化搜索内容
     * @param req
     * @param queryWrapper
     */
    public static void fomarQueryWrapper(HttpServletRequest req, QueryWrapper queryWrapper){
        for(SearchConfigEnum config : SearchConfigEnum.values()){
            
            //相似度不在搜索范围内
            if(!config.getId().equals("izSimilarity")){
                String searchvalue = req.getParameter(config.getId());
                if(StringUtils.isNotBlank(searchvalue)){
                    if(config.getId().equals("izYear")){
                        //针对年份搜索，需要拆分
                        String[] year = searchvalue.split(",");
                        //当前数据必须是两条
                        if(year.length == 2){
                            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
                            Date start = null;
                            Date end = null;
                            try {
                                start = sdf.parse(year[0]);
                                end = sdf.parse(year[1]);
                            } catch (ParseException e) {
                                continue;
                            }
    
                            queryWrapper.ge(config.getMeaning(),start);
                            queryWrapper.le(config.getMeaning(),end);
                        }

                    }else{
                        queryWrapper.eq(config.getMeaning(),searchvalue);
                    }
                    
                }
    
            }
            
        }
    }
}
